// $Id$

App.DiscoveryDataController = Ember.Object.extend({
    discoveryAudit_id:0,
    isPasswordNeeded:true
});

App.DiscoverySSHController = Ember.ObjectController.extend({
    needs:'Discovery',//NO I18N
    actions : {
        importUsersFromAD:function()
        {
            this.get('controllers.Discovery').send('importUsersFromAD');//No I18N
        },
        generateTree:function()
        {
            this.get('controllers.Discovery').send('generateTree');//No I18N
        },
       	discoverSubmit: function()
	{
            this.get('controllers.Discovery').send('discoverSubmit');//No I18N
        },
       	close: function()
	{
            this.get('controllers.Discovery').send('close');//No I18N
        }
    }
});

App.DiscoverySSLController = Ember.ObjectController.extend({
    needs:'Discovery',//NO I18N
    actions : {
        importUsersFromAD:function()
        {
            this.get('controllers.Discovery').send('importUsersFromAD');//No I18N
        },
        generateTree:function()
        {
            this.get('controllers.Discovery').send('generateTree');//No I18N
        },
       	discoverSubmit: function()
	{
            this.get('controllers.Discovery').send('discoverSubmit');//No I18N
        },
       	close: function()
	{
            this.get('controllers.Discovery').send('close');//No I18N
        }
    }
});

App.DiscoverySMTPController = Ember.ObjectController.extend({
    needs:'Discovery',//NO I18N
    actions : {
        importUsersFromAD:function()
        {
            this.get('controllers.Discovery').send('importUsersFromAD');//No I18N
        },
        generateTree:function()
        {
            this.get('controllers.Discovery').send('generateTree');//No I18N
        },
       	discoverSubmit: function()
	{
            this.get('controllers.Discovery').send('discoverSubmit');//No I18N
        },
       	close: function()
	{
            this.get('controllers.Discovery').send('close');//No I18N
        }
    }
});

App.DiscoveryADController = Ember.ObjectController.extend({
    needs:['Discovery','application'],//NO I18N
    actions : {
        openADOUdialog:function(template)
        {
            var app = this.get("controllers.application");
            app.send('opendialog',template);//NO I18N                        
        },        
        importUsersFromAD:function()
        {
            this.get('controllers.Discovery').send('importUsersFromAD');//No I18N
        },
        generateTree:function()
        {
            this.get('controllers.Discovery').send('generateTree');//No I18N
        },
       	discoverSubmit: function()
	{
            this.get('controllers.Discovery').send('discoverSubmit');//No I18N
        },
       	close: function()
	{
            this.get('controllers.Discovery').send('close');//No I18N
        }
    }
});

App.DiscoveryCertStoreController = Ember.ObjectController.extend({
    actions : {
        toggleList:function()
        {
            $("#storeListDiv").hide();
            $("#store").show();
            $("#storeName").val("");//NO I18N
            $("#storeList").text("");
        },
        toggleTemplateList:function()
        {
            $("#templateListDiv").hide();
            $("#template_name_div").show();
            $("#template_name").val("");//NO I18N
        },
        getStoreList:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Feature doesn't work in Linux");//NO I18N
                return;
            }
            var machineName=$("#machineName").val();
            var userName=$("#userName").val();
            var pwd=$("#password").val();
            var ajaxUrl="/api/pki/Discovery/certStoreList";//No I18N
            var params="MachineName="+machineName+"&UserName="+userName+"&Password="+encodeURIComponent(pwd);//No I18N
            getAjaxApiRequest(ajaxUrl,params,function(jsonData){
                if(jsonData.Status=="Success")
                {
                    var storeList=jsonData.StoreList;
                    if(storeList.length!=0)
                    {
                        $("#storeList").text("");
                        for(var i=0;i<storeList.length;i++)
                        {
                            if(storeList[i].trim()!="")
                            {
                                $("#storeList").append("<option value='"+storeList[i]+"'>"+storeList[i]+"</option>");
                            }
                        }
                        $("#storeListDiv").show();
                        $("#store").hide();
                        $("#storeName").val("");//NO I18N
                    }
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
        },
        getTemplateList:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Feature doesn't work in Linux");//NO I18N
                return;
            }
            var machineName=$("#machineName").val();
            var userName=$("#userName").val();
            var pwd=$("#password").val();
            var ajaxUrl="/api/pki/Discovery/getTemplateList";//No I18N
            var params="MachineName="+machineName+"&UserName="+userName+"&Password="+encodeURIComponent(pwd);//No I18N
            getAjaxApiRequest(ajaxUrl,params,function(jsonData){
                if(jsonData.Status=="Success")
                {
                    var templateList=jsonData.TemplateList;
                    if(templateList.length!=0)
                    {
                        $("#templateList").text("");
                        for(var i=0;i<templateList.length;i++)
                        {
                            var templateDetails=templateList[i];
                            if(templateDetails.displayName.trim()!="")
                            {
                                if(templateDetails.msPKI_Cert_Template_OID!=undefined)
                                {
                                     $("#templateList").append("<option value='"+templateDetails.msPKI_Cert_Template_OID+"'>"+templateDetails.displayName+"</option>");//No I18N
                                } else
                                {
                                    $("#templateList").append("<option value='" + templateDetails.distinguishedName + "'>" + templateDetails.displayName + "</option>");//No I18N
                                }
                                }
                                else
                                {
                                    $("#templateList").append("<option value='"+templateDetails.distinguishedName+"'>"+templateDetails.displayName+"</option>");//No I18N
                                }
                            }
                        }
                        $("#templateListDiv").show();
                        $("#template_name_div").hide();
                        $("#template_name").val("");
                    }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
        },
        getCertStoreCertificates:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Feature doesn't work in Linux");//NO I18N
                return;
            }
            var ajaxUrl="/api/pki/Discovery/certStore";//No I18N
            var params={};
            params=getcertStoreDiscoveryParams(params);
            if(params!==undefined)
            {
                var redirectUrl="SSLMgmt/SSL";//No I18N
                if($("#windows_dis_type").val()!=="cert_store")
                {
                    ajaxUrl="/api/pki/Discovery/localCA";//No I18N
                    redirectUrl="Discovery/AuditDiscovery";//NO I18N
                }
                ajaxapicall(ajaxUrl,params,true,redirectUrl);
            }
        }
    }
});

function getcertStoreDiscoveryParams(params)
{
            var machineName=$("#machineName").val();
            var userName=$("#userName").val();
            var pwd=$("#password").val();
            var revoked=false;
            var expired=false;
            var date_filter=false;
            var template_filter=false;
    params.MachineName=machineName;
    params.UserName=userName;
    params.Password=pwd;
    params.pmpcp=Get_Cookie('pmpcc');//No I18N
            if($("#windows_dis_type").val()=="cert_store")
            {
        params.DisType="cert_store";//No I18N
            var storeName=$("#storeName").val();
        if(!validateFieldIsEmpty($("#userName")))
        {
            if(validateFieldIsEmpty($("#password")) && App.DiscoveryDataController.isPasswordNeeded)
            {
                showAlert(I18N.getMsg("js.serverSettings.enterUsernameAndPassword"));//No I18N
                return;
            }
        }
            if(storeName.trim()!="")
            {
                if(storeName.indexOf(machineName)==-1)
                {
                storeName=machineName+"\\"+$("#storeName").val();//No I18N
            }
            }
            else
            {
                    if($("#storeList").val()!=null && $("#storeList").val()!="")
                {
                    storeName=$("#storeList").val().trim();
                }
                else
                {
                    showAlert("Mention/Select Valid store name");//No I18N
                    return;
                }
            }
        params.storeName=storeName;//No I18N
            }
            else
            {
        params.DisType="msca";//No I18N
                if(validateFieldIsEmpty($("#machineName")))
                {
                    showAlert(I18N.getMsg("js.radius.validserver"));//No I18N
                    return;
                }
                else if(validateFieldIsEmpty($("#userName")) || validateFieldIsEmpty($("#password")))
                {
                    if(App.DiscoveryDataController.isPasswordNeeded)
                    {
                    showAlert(I18N.getMsg("js.serverSettings.enterUsernameAndPassword"));//No I18N
                    return;
                }
                }
                if(document.getElementById("CACertTypeID1").checked)
                {
                    revoked=true
                }
                if(document.getElementById("CACertTypeID2").checked)
                {
                    expired=true;
                }
                if(document.getElementById("CACertTypeID3").checked)
                {
                    date_filter=true;
                    var fromDate=document.getElementById("FROM_DATE").value;
                    var toDate=document.getElementById("TO_DATE").value;
                    if(validateDateAsCurrentDateVal(toDate))
                    {
                        if(validateFromAndToDate(fromDate,toDate))
                        {
                            params.FROM_DATE=fromDate;
                            params.TO_DATE=toDate;
                        }
                        else
                        {
                            showAlert(I18N.getMsg("js.fromdate.does.exceeds.todate.date"));//No I18N
                            return;                            
                        }
                    }
                    else
                    {
                        showAlert(I18N.getMsg("js.todate.does.exceeds.current.date"));//No I18N
                        return;
                    }
                }
                if(document.getElementById("CACertTypeID4").checked)
                {
                    template_filter=true;
                    var template_name="";
                    if(document.getElementById("template_name").value!=="")
                    {
                        template_name=document.getElementById("template_name").value;
                    }
                    else if(document.getElementById("templateList").value!=="")
                    {
                        template_name=document.getElementById("templateList").value;
                    }
                    else
                    {
                        showAlert("Mention/Select Valid template name");//No I18N
                        return;
                    }
            params.TemplateName=template_name;
                }
        params.Revoked=revoked;
        params.Expired=expired;
        params.date_filter=date_filter;
        params.template_filter=template_filter;
            }
    return params;
        }

App.DiscoveryADUserCertController = Ember.ObjectController.extend({
    actions : {
        importADUserCertificate:function()
        {
            var grid = jQuery("#ADUserCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.resource.selectAtleastOneCertificate')); //No I18N
                    return;
            }

            vConfirmation('Import selected certificates?',function(){//NO I18N
                var arr = new Array();
                var res_ids="";
                $.each(selRowIds, function()
                {
                    var id = this;
                    var res_id = grid.jqGrid('getCell', id, 'ManageID'); //No I18N
                    if(res_ids!=="")
                    {
                        res_ids=res_ids+","+res_id;
                    }
                    else
                    {
                        res_ids=res_id;
                    }
                });
                var data = {

                    };
                data.ManageIds = res_ids;
                var ajaxRequestUrl = '/api/pki/Discovery/importADUserCertificate'; //No I18N
                data.pmpcp=Get_Cookie('pmpcc');//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                    if(jsonData.Status==="Success")//No I18N
                    {
                        getADUserCertificate();
                        messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                    }
                });
            });
        },
        deleteADUserCertificate:function()
        {
            var grid = jQuery("#ADUserCertList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.resource.selectAtleastOneCertificate')); //No I18N
                    return;
            }

            vConfirmation(I18N.getMsg('js.confirmationMsg.deleteSelectedCertificates'),function(){//NO I18N
                var arr = new Array();
                var res_ids="";
                $.each(selRowIds, function()
                {
                    var id = this;
                    var res_id = grid.jqGrid('getCell', id, 'ManageID'); //No I18N
                    if(res_ids!=="")
                    {
                        res_ids=res_ids+","+res_id;
                    }
                    else
                    {
                        res_ids=res_id;
                    }
                });
                var data = {

                    };
                data.ManageIds = res_ids;
                var ajaxRequestUrl = '/api/pki/Discovery/deleteADUserCertificate'; //No I18N
                data.pmpcp=Get_Cookie('pmpcc');//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                    if(jsonData.Status==="Success")//No I18N
                    {
                        getADUserCertificate();
                        messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                    }

                });
            });
        }
    }
});

App.DiscoveryController = Ember.ObjectController.extend({
    needs:'SettingsADAuth',//NO I18N
    actions : {
        importUsersFromAD:function()
        {
            this.get('controllers.SettingsADAuth').send('importUsersFromAD');//No I18N
        },
        generateTree:function()
        {
            this.get('controllers.SettingsADAuth').send('generateTree');//No I18N
        },
        close:function()
        {
            if (window.cur_path.indexOf("Discovery") > -1)//No I18N
            {
                redirectUrl("Discovery/SSL");//No I18N
            } else {
                redirectUrl("Settings/UserManagement");//No I18N
            }
        },
       	discoverSubmit: function()
	{
		var DISC_TYPE = "";
		var HOST = "";
		var START_ADDR = "";
		var END_ADDR = "";
		var ADDR = "";
		var MASK = "";
		var TIMEOUT = $('#TIMEOUT').val().trim();
                var RES_TYPE="";
		var RETRIES = 0;
		var PORT=443;
                var LandingServer="";
                var FILE_CONTENT="";
                var browse="";
                var textfile="";
                var fileName="";
                var selectedIPType="";
                var fileData = new FormData();
                if(document.getElementById("DISC_TYPE").checked)
                {
                    selectedIPType = "SINGLE_DEVICE";//No I18N
                }else if(document.getElementById("DISC_TYPE2").checked)
                {
                    selectedIPType = "ADDR_RANGE";//No I18N
                }
                else
                {
                    selectedIPType = "HOST_FILE";//No I18N
                }
                if(selectedIPType !== "HOST_FILE")
                            {
                    PORT = $('#port').val().trim();
                    if(!isNotEmpty(PORT))
                    {
                        showAlert(I18N.getMsg('js.port.specifyaValidPort')); //No I18N
                               return; 
                            }
                }
               if(isNaN(TIMEOUT)||TIMEOUT=="" ||TIMEOUT<=0 || TIMEOUT!=parseInt(TIMEOUT))
                {
                        showAlert(I18N.getMsg('js.inputtime.enteraValidTime')); //No I18N
                        return;
                }
                if(TIMEOUT>15)
                {
                    showAlert(I18N.getMsg('js.inputtime.discovery.enteraValidTimeMaxValue15')); //No I18N
                        return;
                }
		if(selectedIPType ==="SINGLE_DEVICE") { //No I18N
			DISC_TYPE = "SINGLE_CERT"; //No I18N
			HOST = $('#ipHostName').val().trim(); 
			if(!isNotEmpty(HOST)){
				showAlert(I18N.getMsg('js.hostname.specifyaValidHostnameOrIPAddress')); //No I18N
				return;
			}
                        
                        }
                else if(selectedIPType ==="ADDR_RANGE") { //No I18N
			DISC_TYPE = "ADDR_RANGE"; //No I18N
			START_ADDR = $('#START_ADDR').val().trim();
			END_ADDR = $('#END_ADDR').val().trim();
                        var result=ipRangeValidation(START_ADDR,END_ADDR);
                        if(result==false)
                        {
                            return;
		}
                        }
                else
                {
                    DISC_TYPE = "FILE_BASED"; //No I18N
                    FILE_CONTENT=window.FILE_CONTENT;
                    browse = $('#importCsv');
                    if(FILE_CONTENT==="")
                    {
                       showAlert(I18N.getMsg('js.file.selectaFileWithProperFormat'));//No I18N
                        return;
                    }
                    if ($('#textfile').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                fileName=$('#textfile').val();
                   textfile=document.getElementById('textfile');
                    var file = document.getElementById("importCsv").files[0];
                fileData.append("File", file);//NO I18N
                   clearfileElt(browse,textfile);
                }
                var ajaxRequestUrl = '';
                if(window.cur_path=="Discovery.SSH")
                {
                    if(selectedIPType !== "HOST_FILE")
                    {
                        if(!isValidPort(PORT))
                        {
                            return;
                        }
                    }
                    if(document.getElementById("LSServer").value!=="-1")
                    {
                        if(DISC_TYPE==="SINGLE_CERT")
                        {
                            if(HOST.toLowerCase()==="localhost" || HOST.indexOf('127')===0)
                            {
                                showAlert(I18N.getMsg("loopback.address.cantadd"));//NO I18N
                                return;
                            }
                        }
                        else if(DISC_TYPE === "ADDR_RANGE")
                        {
                            if(checkLocalhostInRange(START_ADDR,END_ADDR))
                            {
                                showAlert(I18N.getMsg("loopback.address.cantadd"));//NO I18N
                                return;
                            }
                        }
                        LandingServer=document.getElementById("LSServer").value;
                    }
                    ajaxRequestUrl='/api/pki/Discovery/ssh';//NO I18N
                }
                else
                {
                    if(selectedIPType !== "HOST_FILE")
                    {
                        if(PORT.indexOf("-")!=-1)
                        {
                            var portcheck = PORT.split("-");//NO I18N
                            if(portcheck.length != 2 || portcheck[0] >= portcheck[1])
                            {
                                showAlert(I18N.getMsg('js.port.specifyaValidPort'));//NO I18N
                                return;
                            }
                            if(!isValidPort(portcheck[0]) || !isValidPort(portcheck[1]))
                            {
                                return;
                            }
                        }else{
                            var portcheck = PORT.split(",");//NO I18N
                            for(i=0;i<portcheck.length;i++)
                            {
                                if(!isValidPort(portcheck[i]))
                                {
                                   return; 
                                }
                            }
                        }
                    }
                    ajaxRequestUrl='/api/pki/Discovery/ssl';//NO I18N
                }
                if(window.cur_path=="Discovery.SMTP")
                {
                    DISC_TYPE="SMTP";//NO I18N
                }
                fileData.append("pmpcp", Get_Cookie('pmpcc'));//NO I18N
                fileData.append("DISC_TYPE", DISC_TYPE);//NO I18N
                fileData.append("HOST", HOST);//NO I18N
                fileData.append("START_ADDR", START_ADDR);//NO I18N
                fileData.append("END_ADDR", END_ADDR);//NO I18N
                fileData.append("ADDR", ADDR);//NO I18N
                fileData.append("PORT", PORT);//NO I18N
                fileData.append("TIMEOUT", TIMEOUT);//NO I18N
                fileData.append("FILE_NAME", fileName);//NO I18N
                fileData.append("LandingServer", LandingServer);//NO I18N
//            var req_params='DISC_TYPE='+DISC_TYPE+'&HOST='+HOST+'&START_ADDR='+START_ADDR+'&END_ADDR='+END_ADDR+'&ADDR='+ADDR+'&PORT='+PORT//No I18N
//                +'&FILE_CONTENT='+FILE_CONTENT+'&TIMEOUT='+TIMEOUT+'&FILE_NAME='+fileName+"&LandingServer="+LandingServer; //No I18N
            getAjaxApiRequestForFile(ajaxRequestUrl,fileData,null,null,true,function(jsonData){
                         if(jsonData.Status=="Success")//No I18N
                         {
                            redirectUrl("Discovery/DetailedAuditDiscovery/"+jsonData.discoveryAuditId);//No I18N
                         }
		});
	}

    }
});

App.DiscoveryDetailedAuditDiscoveryController = Ember.ObjectController.extend({
    isDetailedAuditDiscoveryInprogress:false,
    needs:'application',//NO I18N
    actions : {
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var hostname=document.getElementById("gs_HOSTNAME").value;//NO I18N
            var ipaddress=document.getElementById("gs_IPADDRESS").value;
            //var status=document.getElementById("gs_STATUS").value;
            var description=document.getElementById("gs_DESCRIPTION").value;
            var discoveryAuditId=App.DiscoveryDataController.discoveryAudit_id;
            var params="&hostname="+hostname+"&ipaddress="+ipaddress+"&status="+status+"&description="+description+"&discoveryAuditId="+discoveryAuditId;//NO I18N
            App.ReportController.scheduleType="DetailedAuditDiscoveryReport";//No I18N
            var ids = jQuery("#DiscoveryAuditList").jqGrid('getDataIDs');//NO I18N
            if (App.DiscoveryDetailedAuditDiscoveryController.isDetailedAuditDiscoveryInprogress)
            {
                messageNotification("messageNotifyFailure", I18N.getMsg("js.discoveryaudit.inprogress"));//No I18N
            } else {
                if (ids.length > 0)
                {
                    locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=DetailedAuditDiscovery" + params);//NO I18N
                } else {
                    messageNotification("messageNotifyFailure", I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
                }
            }
        },
        exportCsv:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var hostname=document.getElementById("gs_HOSTNAME").value;//NO I18N
            var ipaddress=document.getElementById("gs_IPADDRESS").value;
            //var status=document.getElementById("gs_STATUS").value;
            var description=document.getElementById("gs_DESCRIPTION").value;
            var discoveryAuditId=App.DiscoveryDataController.discoveryAudit_id;
            var params="&hostname="+hostname+"&ipaddress="+ipaddress+"&status="+status+"&description="+description+"&discoveryAuditId="+discoveryAuditId;//NO I18N
            App.ReportController.scheduleType="DetailedAuditDiscoveryReport";//No I18N
            var ids = jQuery("#DiscoveryAuditList").jqGrid('getDataIDs');//NO I18N
            if (App.DiscoveryDetailedAuditDiscoveryController.isDetailedAuditDiscoveryInprogress)
            {
                messageNotification("messageNotifyFailure", I18N.getMsg("js.discoveryaudit.inprogress"));//No I18N
            } else {
                if (ids.length > 0)
                {
                    locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportCsv&ReportType=DetailedAuditDiscovery" + params);//NO I18N
                } else {
                    messageNotification("messageNotifyFailure", I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
                }
            }
        },
        dataCheck:function()
        {
            App.ReportController.scheduleType="DetailedAuditDiscoveryReport";//No I18N
            var app=this.get('controllers.application');
            var ids = jQuery("#DiscoveryAuditList").jqGrid('getDataIDs');//NO I18N
            if (App.DiscoveryDetailedAuditDiscoveryController.isDetailedAuditDiscoveryInprogress)
            {
                messageNotification("messageNotifyFailure", I18N.getMsg("js.discoveryaudit.inprogress"));//No I18N
            } else {
                if (ids.length > 0)
                {
                    app.send('opendialog', 'EmailNotify');//NO I18N
                } else {
                    messageNotification("messageNotifyFailure", I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
                }
            }
        }
    }
});
