// $Id$
App.InventoryController = Ember.ObjectController.extend({
            res_Id:"",
            res_Ids:"",
            rGroupName:"",
            description:"",
            port:"",
            path:"",
            lsid:"",
            lsname:"",
            rGroup:false,
            cmdb:false,
            deleteWithoutDisassociationoption:false
});

App.InventoryTabListController = Ember.Object.create({
    selectedTab: "",
    path:"",
    root:true
});

App.InventoryListDetailsController = Ember.Object.create({	
	hostId: "", //No I18N
        cert_id:-1,
        cert_name:"",
        cert_nav:false,
        selectedTab: "",
        certificate: "",
        res_type: "",
        res_name:"",
        ip_address:"",
        dGroupId:"",
        parameterMap:{},
        conditionMap:{},
        comparatorMap:{},
        AllUnselectedHostMap:{},
        QUERYID:"",
        deploy:false,
        certVersionId:-1
});

App.LandingServerDetailsController = Ember.ObjectController.extend({
    actions:{
        close: function() {
          listusers=true;
          return this.send('closeModal');//NO I18N
        },
        submit: function() {
            var serverName = $("#servername").val();
            if(serverName=="")
            {
                showAlert(I18N.getMsg("landingserver.provide.servername"));//NO I18N
                return;
            }
            var description = $("#description").val();
            var primaryserver_id = $("#primaryserver").val();
            if(primaryserver_id=="-1")
            {
                showAlert(I18N.getMsg("landingserver.select.primaryserver"));//NO I18N
                return;
            }
            var primaryuser_id = $("#primaryuser").val();
            if(primaryuser_id==="-1")
            {
                showAlert(I18N.getMsg("landingserver.select.primaryuser"));//NO I18N
                return;
            }
            var params = "primaryserver_id="+primaryserver_id+"&primaryuser_id="+primaryuser_id+"&servername="+serverName+"&description="+description;//NO I18N
            var secondaryserver_id = $("#secondaryserver").val();
            if(secondaryserver_id!=="-1")
            {
                if(secondaryserver_id === primaryserver_id)
                {
                    showAlert(I18N.getMsg("landingserver.primaryandsecondary.same"));//NO I18N
                    return;
                }
                var secondaryuser_id = $("#secondaryuser").val();
                if(secondaryuser_id==="-1")
                {
                    showAlert(I18N.getMsg("landingserver.select.secondaryuser"));//NO I18N
                    return;
                }
                params=params+"&secondaryserver_id="+secondaryserver_id+"&secondaryuser_id="+secondaryuser_id;//NO I18N
            }
            else 
            {
                params=params+"&secondaryserver_id=-1"+"&secondaryuser_id=-1";//NO I18N
            }
            params=params+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            var requestUrl = "/api/pki/landingserver/saveLandingServer";//NO I18N
            getAjaxApiRequest(requestUrl,params,function(jsonData){
               if(jsonData.Status === "Success")
               {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                   document.getElementById("closeButton").click();
                   App.Inventory.getLandingServersList();
               }
               else
               {
                   messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
               }
            });
        }
    }
    });
    
    App.LandingServerEditController = Ember.ObjectController.extend({
        actions:{
        close: function() {
          listusers=true;
          return this.send('closeModal');//NO I18N
        },
        submit: function() {
            var serverName = $("#servername").val();
            if(serverName=="")
            {
                showAlert(I18N.getMsg("landingserver.provide.servername"));//NO I18N
                return;
            }
            var description = $("#description").val();
            var primaryserver_id = $("#primaryserver").val();
            if(primaryserver_id=="-1")
            {
                showAlert(I18N.getMsg("landingserver.select.primaryserver"));//NO I18N
                return;
            }
            var primaryuser_id = $("#primaryuser").val();
            if(primaryuser_id==="-1")
            {
                showAlert(I18N.getMsg("landingserver.select.primaryuser"));//NO I18N
                return;
            }
            var params = "primaryserver_id="+primaryserver_id+"&primaryuser_id="+primaryuser_id+"&servername="+serverName+"&description="+description;//NO I18N
            var secondaryserver_id = $("#secondaryserver").val();
            if(secondaryserver_id!=="-1")
            {
                if(secondaryserver_id === primaryserver_id)
                {
                    showAlert(I18N.getMsg("landingserver.primaryandsecondary.same"));//NO I18N
                    return;
                }
                var secondaryuser_id = $("#secondaryuser").val();
                if(secondaryuser_id==="-1")
                {
                    showAlert(I18N.getMsg("landingserver.select.secondaryuser"));//NO I18N
                    return;
                }
                params=params+"&secondaryserver_id="+secondaryserver_id+"&secondaryuser_id="+secondaryuser_id;//NO I18N
            }
            else 
            {
                params=params+"&secondaryserver_id=-1"+"&secondaryuser_id=-1";//NO I18N
            }
            params=params+"&id="+App.InventoryController.lsid+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            var requestUrl = "/api/pki/landingserver/editLandingServer";//NO I18N
            getAjaxApiRequest(requestUrl,params,function(jsonData){
               if(jsonData.Status === "Success")
               {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                   document.getElementById("closeButton").click();
                   App.Inventory.getLandingServersList();
               }
               else
               {
                   messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
               }
            });
        }
    }
    });    

App.VulnerabilitiesViewController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
   actions: {
       checkVulnerabilities: function(){
            var cert_id = App.InventoryListDetailsController.cert_id;
            var port = document.getElementById("defaultPort").value;
            var ajaxRequestUrl = '/api/pki/Inventory/checkSSLVulnerabilities'; //No I18N
            var params='cert_id='+cert_id+'&port='+port;//No I18N
            if(document.getElementById("checksan").checked)
            {
                params+="&SAN=yes";//NO I18N
            }
            else
            {
                params+="&SAN=no";//NO I18N
            }
            if(document.getElementById("checkip").checked)
            {
                params+="&IP=yes";//NO I18N
            }
            else
            {
                params+="&IP=no";//NO I18N
            }
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
               if(jsonData.Status==="Success")
               {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N                   
               }
               else
               {
                   messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
               }
               setTimeout(function(){
                    getSSLVunerabilitiesReload();           
                 },2000);
            });
       },
       exportPdf: function(){
           if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var cert_id = App.InventoryListDetailsController.cert_id;
            var ajaxRequestUrl = '/api/pki/Inventory/checkSSLVulnExport'; //No I18N
            var params='cert_id='+cert_id;//No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
               if(jsonData.Status === "Failed")
               {
                   messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
               }
               else 
               {
                   var reqParams = "&cert_id="+cert_id;//NO I18N
                   locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=SSLVulnerabilitiesReport"+reqParams);//NO I18N
               }
            });
       },
       mailPdf: function(){
           var app=this.get('controllers.application');
            var cert_id = App.InventoryListDetailsController.cert_id;
            var ajaxRequestUrl = '/api/pki/Inventory/checkSSLVulnExport'; //No I18N
            var params='cert_id='+cert_id;//No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
               if(jsonData.Status === "Failed")
               {
                   messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
               }
               else 
               {       
                   App.ReportController.scheduleType="SSLVulnerabilitiesCertReport";//No I18N
                   app.send('opendialog', 'EmailNotify');//NO I18N
               }
            });
       }
   }
});

App.LandingServerConfigController = Ember.ObjectController.extend({
   actions: {
       deleteLS: function(){
            var ajaxRequestUrl = '/api/pki/landingserver/deleteLandingServers';//NO I18N
            var grid = jQuery("#LandingServersList");//NO I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length===0)
            {
                showAlert(I18N.getMsg("landingserver.select.atleastone"));//NO I18N
                return;
            }
            var ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var sid = grid.jqGrid('getCell',id,'SERVER_ID');//NO I18N
                if(ids==="")
                {
                    ids=sid;
                }
                else
                {
                    ids=ids+","+sid;//NO I18N
                }
            });
            var params = "ids="+ids+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
               if(jsonData.Status==="Success")
               {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N                   
               }
               else
               {
                   messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
               }
               App.Inventory.getLandingServersList();
            });
       }
   } 
});

App.LandingServerAssociationController = Ember.ObjectController.extend({
   actions: {
       associate: function() {
            var ajaxRequestUrl = '/api/pki/landingserver/landingServerAssociation';//NO I18N
            var grid = jQuery("#PKIInventoryList");//NO I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length===0)
            {
                showAlert(I18N.getMsg("js.resource.selectAtleastOneResource"));//NO I18N
                return;
            }
            var ids="";
            var check = false;
            $.each(selRowIds, function()
            {
                var id = this;
                var sid = grid.jqGrid('getCell',id,'ResourceID');//NO I18N
                var resName = grid.jqGrid('getCell', id, 'ResourceName'); //No I18N
                var ipAddress = grid.jqGrid('getCell',id, 'IPAddress'); //No I18N
                if(resName.toLowerCase()==="localhost"||ipAddress.indexOf('127')===0)
                {
                    check=true;
                    showAlert(I18N.getMsg("loopback.address.cantadd"));//NO I18N
                    return;
                }
                if(ids==="")
                {
                    ids=sid;
                }
                else
                {
                    ids=ids+","+sid;//NO I18N
                }
            });
            if(check)
            {
                return;
            }
            var params = "RIds="+ids+"&LSId="+App.InventoryController.lsid+"&LSName="+$("#serverName").text()+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
               if(jsonData.Status==="Success")
               {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    changeLandingServerGridView();
               }
               else
               {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
               }
            });
       },
       dissociate: function() {
            var ajaxRequestUrl = '/api/pki/landingserver/landingServerDissociation';//NO I18N
            var grid = jQuery("#PKIInventoryList");//NO I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var LSName = App.InventoryController.lsname;
            if(selRowIds == undefined || selRowIds.length===0)
            {
                showAlert(I18N.getMsg("js.resource.selectAtleastOneResource"));//NO I18N
                return;
            }
            var ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var sid = grid.jqGrid('getCell',id,'ResourceID');//NO I18N
                if(ids==="")
                {
                    ids=sid;
                }
                else
                {
                    ids=ids+","+sid;//NO I18N
                }
            });
            var params = "RIds="+ids+"&LSId="+App.InventoryController.lsid+"&LSName="+LSName+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
               if(jsonData.Status==="Success")
               {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    changeLandingServerGridView();                
               }
               else
               {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
               }
            });
       }
   } 
});

App.ResourceGroupController = Ember.ObjectController.extend({
    needs: 'application',//NO I18N
    actions: {
        deleteGroup: function() {
            var ajaxRequestUrl = '/api/pki/Inventory/deleteResourceGroup'; //No I18N
            var data = {

            };
            var grid = jQuery("#PKIResourceGroupList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                   showAlert(I18N.getMsg('js.resourceGroup.SelectAtleastOneGroup')); //No I18N
                    return;
            }
            var arr = "";
            var namesArr="";
            var val=vConfirmation(I18N.getMsg('js.deleteresourcegroup.deletetheSelectedResourceGroup'),function(){//NO I18N
            $.each(selRowIds, function()
            {
                var id = this;
                var rg_id = grid.jqGrid('getCell', id, 'GROUP_ID'); //No I18N
                var groupName = grid.jqGrid('getCell',id,'GROUP_NAME');//NO I18N
                if(arr==="")
                {
                    arr=rg_id;
                    namesArr=groupName;
                }
                else
                {
                    arr=arr+","+rg_id;
                    namesArr+=","+groupName;
                }
            });
            data.DEVICE_GROUP_ID=arr;
            data.RESOURCE_GROUP_NAMESARR=namesArr;
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    App.Inventory.getResourceGroupList();
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
            });
        }
//        editUserPath: function(){
//            var grid = jQuery("#PKIResourceGroupList"); //No I18N
//            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
//            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
//                   showAlert(I18N.getMsg('js.selectone.group')); //No I18N
//                    return;
//            }
//            var rg_id = grid.jqGrid('getCell', selRowIds, 'GROUP_ID'); //No I18N
//            var rgname = grid.jqGrid('getCell',selRowIds,'GROUP_NAME');//NO I18N
//            App.SettingsCommonController.rGroup=true;
//            App.InventoryController.res_Id=rg_id;
//            App.InventoryController.rGroupName=rgname;
//            var app=this.get('controllers.application');
//            app.send('opendialog','EditUserPath');//NO I18N
//        }
    }
});

App.SSLCertificatesGroupController = Ember.ObjectController.extend({
   actions: {
       deleteGroup: function() {
            var ajaxRequestUrl = '/api/pki/Inventory/deleteCertificatesGroup'; //No I18N
            var data = {

            };
            var grid = jQuery("#PKIResourceGroupList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                   showAlert(I18N.getMsg('js.certGroup.SelectAtleastOneGroup')); //No I18N
                    return;
            }
            var arr = "";
            var namesArr="";
            var val=vConfirmation(I18N.getMsg('js.deletecertgroup.deletetheSelectedcertGroup'),function(){//NO I18N
            $.each(selRowIds, function()
            {
                var id = this;
                var rg_id = grid.jqGrid('getCell', id, 'GROUP_ID'); //No I18N
                var groupName = grid.jqGrid('getCell',id,'GROUP_NAME');//NO I18N
                if(arr==="")
                {
                    arr=rg_id;
                    namesArr=groupName;
                }
                else
                {
                    arr=arr+","+rg_id;
                    namesArr+=","+groupName;
                }
            });
            data.GROUP_ID=arr;
            data.GROUP_NAMESARR=namesArr;
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    App.Inventory.getCertificatesGroupList();
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
            });
        }
   } 
});

App.RootCertificateViewController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        deleteFromRoot: function(){
            var grid = $("#PKIRootCertificateList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.resource.selectAtleastOneCertificate')); //No I18N
                    return;
            }
            var res_ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var res_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                if(res_ids!=="")
                {
                    res_ids=res_ids+","+res_id;
                }
                else
                {
                    res_ids=res_id;
                }
            });      
            if(res_ids=="")
            {
                showAlert(I18N.getMsg('Private Key file not available for this certificates')); //No I18N
                return;
            }
            var ajaxRequestUrl = '/api/pki/request/setRootCertificate'; //No I18N
            var params={};
            params.cert_id=res_ids;
            params.isRoot=0;
            params.pmpcp=Get_Cookie('pmpcc');//No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    if(jsonData.Status ===  "Success")
                    {
                        messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                        {{App.Inventory.getRootCertificateList()}}
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }
            });
        },
        signWithRootCertificate: function() {
            var grid = $("#PKIRootCertificateList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length != 1) {
                showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
                    return;
            }
            var app=this.get('controllers.application');//No I18N
            app.send('opendialog','SignWithRootCertificate');//NO I18N

        }
    }
});

App.AddCertificateGroupController = Ember.ObjectController.extend({
    actions: {
            cancelOperation:function() {
                redirectUrl("SSLMgmt/SSLCertificatesGroup");//No I18N
            },
            saveCertificateGroup: function() {
		var data = {
				
		};
		var ajaxRequestUrl = '/api/pki/Inventory/addCertificatesGroup'; //No I18N
		var dGroupId = App.InventoryListDetailsController.dGroupId;
		if(dGroupId != "new") {
			data.GROUP_ID = dGroupId;
			data.IS_EDIT_VIEW = true;
		} else {
			data.IS_EDIT_VIEW = false;
		}
                var rgName=$('#rGroupName').val().trim();
                if(rgName=="")
                {
                    showAlert(I18N.getMsg("js.resource.givecertificategroupNameAlert",this)); // No I18N
                    return;                    
                }
		data.GROUP_NAME = rgName;
		data.DESCRIPTION = $('#dGroupDesc').val();
		var componentSelection = $("input[name='ComponentSelection']:checked").val();//No I18N
		data.ComponentSelection = componentSelection;
                var exit=false;
		if(componentSelection == "DeviceByCriteria") {
			var CRITERIA_LIST = new Array();
			var emptyValue = false;
			$("#critetriaTable").find('tr').each(function (i, el) {
				var id = $(this).attr("id");
				var cri = {
						
				};
				cri.Condition = $("#CONDITION_"+id).val();
				cri.Field = $("#PARAMETER_"+id).val();
				if($("#COMPARATOR_"+id).val() == undefined || $("#COMPARATOR_"+id).val() == "") {
					cri.Comparator = "and"; // No I18N
				} else {
					cri.Comparator = $("#COMPARATOR_"+id).val();
				}
				
				var val = $("#PATTERN_"+id).val();
				if(val == "") {
					emptyValue = true;
				}
				cri.Value = val;
                                if(cri.Field==="KEY_STRENGTH")
                                {
                                    var numbers = /^[0-9]+$/;  
                                    if(!val.match(numbers))  
                                    {
                                        showAlert(I18N.getMsg("keysize.numberinput.alert"));//NO I18N
                                        exit=true;
                                        return;
                                    }
                                }  
				CRITERIA_LIST.push(cri);
			});
                        if(exit)
                        {
                            return;
                        }
                        var rowcount = $('#PKIMatchingResourcesList').jqGrid('getGridParam', 'reccount');
                        if (rowcount != undefined && rowcount <= 0) {
                            showAlert(I18N.getMsg("js.resource.selectAtleastOneCertificate", this)); //No I18N 
                            return;
                        }
			if(emptyValue == true) {
				showAlert(I18N.getMsg("js.certificateGroup.emptyValuesAlert",this)); // No I18N
				return;
			}
			data.CRITERIA_LIST = JSON.stringify(CRITERIA_LIST);
		} else {
			var selected = "";
			$("#SELECTEDDEVICES option").each(function()
			{
                            if(selected=="")
                            {
                                selected=$(this).val();
                            }
                            else
                            {
                                selected=selected+","+$(this).val();
                            }
			});
			if(selected == "") {
				showAlert(I18N.getMsg("js.resource.selectAtleastOneCertificate",this)); //No I18N 
				return;
			}
			data.SELECTEDDEVICES = selected;
		}
		data.QUERYID = App.InventoryListDetailsController.QUERYID;
                data.pmpcp=Get_Cookie('pmpcc');//NO I18N
                ajaxapicall(ajaxRequestUrl,data,true,"SSLMgmt/SSLCertificatesGroup");//NO I18N
	}
    }
});

App.AddResourceGroupController = Ember.ObjectController.extend({

    actions: {
            cancelOperation:function() {
               redirectUrl("SSHMgmt/resourceGroup"); //No I18N
            },
            saveDeviceGroup: function() {
		var data = {
				
		};
		var ajaxRequestUrl = '/api/pki/Inventory/addResourceGroup'; //No I18N
		var dGroupId = App.InventoryListDetailsController.dGroupId;
		if(dGroupId != "new") {
			data.DEVICE_GROUP_ID = dGroupId;
			data.IS_EDIT_VIEW = true;
		} else {
			data.IS_EDIT_VIEW = false;
		}
                var rgName=$('#rGroupName').val().trim();
                if(rgName=="")
                {
                    showAlert(I18N.getMsg("js.resource.giveResourceNameAlert",this)); // No I18N
                    return;                    
                }
		data.DEVICE_GROUP_NAME = rgName;
		data.DG_DESCRIPTION = $('#dGroupDesc').val();
		var componentSelection = $("input[name='ComponentSelection']:checked").val();//No I18N
		data.ComponentSelection = componentSelection;
		if(componentSelection == "DeviceByCriteria") {
			var CRITERIA_LIST = new Array();
			var emptyValue = false;
			$("#critetriaTable").find('tr').each(function (i, el) {
				var id = $(this).attr("id");
				var cri = {
						
				};
				cri.Condition = $("#CONDITION_"+id).val();
				cri.Field = $("#PARAMETER_"+id).val();
				if($("#COMPARATOR_"+id).val() == undefined || $("#COMPARATOR_"+id).val() == "") {
					cri.Comparator = "and"; // No I18N
				} else {
					cri.Comparator = $("#COMPARATOR_"+id).val();
				}
				
				var val = $("#PATTERN_"+id).val();
				if(val == "") {
					emptyValue = true;
				}
				cri.Value = val;
				CRITERIA_LIST.push(cri);
			});
                        var rowcount = $('#PKIMatchingResourcesList').jqGrid('getGridParam', 'reccount');
                        if (rowcount != undefined && rowcount <= 0) {
                            showAlert(I18N.getMsg("js.resource.selectAtleastOneResource", this)); //No I18N 
                            return;
                        }
			if(emptyValue == true) {
				showAlert(I18N.getMsg("js.resourceGroup.emptyValuesAlert",this)); // No I18N
				return;
			}
			data.CRITERIA_LIST = JSON.stringify(CRITERIA_LIST);
		} else {
			var selected = "";
			$("#SELECTEDDEVICES option").each(function()
			{
                            if(selected=="")
                            {
                                selected=$(this).val();
                            }
                            else
                            {
                                selected=selected+","+$(this).val();
                            }
			});
			if(selected == "") {
				showAlert(I18N.getMsg("js.resource.selectAtleastOneResource",this)); //No I18N 
				return;
			}
			data.SELECTEDDEVICES = selected;
		}
		data.QUERYID = App.InventoryListDetailsController.QUERYID;
                data.pmpcp=Get_Cookie('pmpcc');//No I18N
                ajaxapicall(ajaxRequestUrl,data,true,"SSHMgmt/resourceGroup");//NO I18N
	}
    }
});
App.InventoryDetailsSSLController = Ember.ObjectController.extend({
    actions: {
        CertificateNext :function()
        {
            if(window.cert_ids.length-1>=window.nav_index+1)
            {
                window.nav_index=window.nav_index+1;
                App.InventoryListDetailsController.cert_id=window.cert_ids[window.nav_index];
                App.Inventory.endPointSummary(App.InventoryListDetailsController.cert_id);
            }
        },
        CertificatePrev :function()
        {
            if(window.nav_index-1>=0)
            {
                window.nav_index=window.nav_index-1;
                App.InventoryListDetailsController.cert_id=window.cert_ids[window.nav_index];
                App.Inventory.endPointSummary(App.InventoryListDetailsController.cert_id);
            }
        }
    }    
});

App.SSHMgmtResourceListController = Ember.ObjectController.extend({
    needs:'SSHResources',//NO I18N
    actions: {
        getUsersListForEnumeration: function()
        {
            var app=this.get('controllers.SSHResources');//NO I18N
            app.send('getUsersListForEnumeration');//NO I18N
        }
    }
});

App.InventorySSLResourcesController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        showDeployedServersDialog:function(){
            var app=this.get('controllers.application');
            app.send('opendialog','SSLMultipleServers');//NO I18N
        },
        vulnerabilityView:function(){
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length != 1) {
                showAlert(I18N.getMsg('letsencrypt.renewrequest.selectonecert')); //No I18N
                return;
            }          
            var cert_id=0;
            $.each(selRowIds, function()
            {
                var id = this;
                cert_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
            });            
            redirectUrl("SSLMgmt/vulnerabilities/"+cert_id);//No I18N
        },
        setRootCertificate: function() {
            var grid = $("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.resource.selectAtleastOneCertificate')); //No I18N
                    return;
            }
            var res_ids="";
            $.each(selRowIds, function()
            {
                var id = this;
                var IsOnlyKeyStore = grid.jqGrid('getCell', id, 'IsKeyStore'); //No I18N
                if(IsOnlyKeyStore !=undefined && IsOnlyKeyStore.indexOf("keyStoreActionMenu") !== -1 )
                {
                    var res_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                    if(res_ids!=="")
                    {
                        res_ids=res_ids+","+res_id;
                    }
                    else
                    {
                        res_ids=res_id;
                    }
                }
            });      
            if(res_ids=="")
            {
                showAlert(I18N.getMsg('Private Key file not available for this certificates')); //No I18N
                return;
            }
            var ajaxRequestUrl = '/api/pki/request/setRootCertificate'; //No I18N
            var params={};
            params.cert_id=res_ids;
            params.isRoot=1;
            params.pmpcp=Get_Cookie('pmpcc');//No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                    if(jsonData.Status ===  "Success")
                    {
                        messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                    }
            });
        },
        creategroup:function(){
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.resource.selectAtleastOneCertificate')); //No I18N
                return;
            }
            var app=this.get('controllers.application');
            App.SettingsCommonController.cGroup=true;
            App.SettingsCommonController.uGroup=false;
            App.SettingsCommonController.rGroup=false;
            app.send('opendialog','CreateGroup');//NO I18N
        },
        cmdbSync: function() {
            var ids = jQuery("#PKIInventoryList").jqGrid('getDataIDs');//NO I18N
            if(ids.length==0)
            {
                messageNotification("messageNotifyFailure",I18N.getMsg("cmdb.nocertificate.sync"));//No I18N
                return;
        }
            var ajaxRequestUrl = '/api/pki/settings/isCMDBEnabled'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){                
                if(jsonData.Status=="Success")
                {
                    ajaxRequestUrl = '/api/pki/settings/syncCMDB'; //No I18N
                    getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){                
                        if(jsonData.Status ===  "Success")
                        {
                            messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
    }
                        else
                        {
                            messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                        }
});
                }
                else
                {
                    vConfirmation(I18N.getMsg('cmdb.alert.enable'),function(){//NO I18N                                               
                        location.href="#/Settings/SDP/CMDB";//NO I18N                        
                    });     
                }
            });
        }
    }
});

App.SSLMultipleServersToDeploymentController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        showCertDeployment:function(){
            var app=this.get('controllers.application');
            app.send('opendialog','WildCardCertDeployment');//NO I18N
        },
        deleteDeployedServers:function(){
            var grid = jQuery("#wildcardList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var servers="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }
            $.each(selRowIds, function()
            {
                var id = this;
                var server=grid.jqGrid('getCell', id, 'MappingID'); //No I18N
                if(servers!=="")
                {
                    servers=servers+","+server;//No I18N
                }
                else
                {
                    servers=server;
                }
            });
            var ajaxRequestUrl = '/api/pki/Inventory/deleteWildCardServers'; //No I18N
            var reqParams = "mapping_id="+servers+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            ajaxapicall(ajaxRequestUrl,reqParams,true,"")//No I18N
        },
        wildcardDeployCertificate:function(){
            var grid = jQuery("#wildcardList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var servers="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }
            var noCredential="";
            $.each(selRowIds, function()
            {
                var id = this;
                var server=grid.jqGrid('getCell', id, 'MappingID'); //No I18N
                var isCredentialEnabled=grid.jqGrid('getCell', id, 'Credential'); //No I18N
                if(isCredentialEnabled.indexOf("Apply Credentials") == -1 )
                {
                if(servers!=="")
                {
                    servers=servers+","+server;//No I18N
                }
                else
                {
                    servers=server;
                }
                }
                else
                {
                    if(noCredential!=="")
                    {
                        noCredential=noCredential+","+server;//No I18N
                    }
                    else
                    {
                        noCredential=server;
                    }                                        
                }
            });
            if(servers=="")
            {
                messageNotification("messageNotifyFailure",I18N.getMsg("js.deploy.credential.notavailable"));
            }
            else if(noCredential!="")
            {
                var val=vConfirmation(I18N.getMsg('js.deploy.credential.notavailable.failure'),function(){//NO I18N
            var ajaxRequestUrl = '/api/pki/request/deployCertificateToWildcardServers'; //No I18N
            var reqParams = "mapping_id="+servers+"&cert_id="+App.InventoryListDetailsController.cert_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            ajaxapicall(ajaxRequestUrl,reqParams,true,"")//No I18N
                });
            }
            else if(servers!="")
            {
                var ajaxRequestUrl = '/api/pki/request/deployCertificateToWildcardServers'; //No I18N
                var reqParams = "mapping_id="+servers+"&cert_id="+App.InventoryListDetailsController.cert_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
                ajaxapicall(ajaxRequestUrl,reqParams,true,"")//No I18N
            }
        },
        exportDeploymentInfo:function(){
            var grid = jQuery("#wildcardList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var servers="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }
            $.each(selRowIds, function()
            {
                var id = this;
                var server=grid.jqGrid('getCell', id, 'MappingID'); //No I18N
                if(servers!=="")
                {
                    servers=servers+","+server;//No I18N
                }
                else
                {
                    servers=server;
                }
            });
            var ajaxRequestUrl = '/api/pki/Inventory/getWildCardServers'; //No I18N
            var reqParams = "mapping_id="+servers;//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                var content="";
                for(var i=0;i<jsonData.DomainNames.length;i++)
                {
                    content+=jsonData.DomainNames[i]+"\r\n";//No I18N
                }
                downloadAsCertificateFile(content,"servers.txt");//No I18N
            });
        }
    }
});

App.DomainExpiryController = Ember.ObjectController.extend({
   needs: 'application',//NO I18N
   actions:{
       close: function() {
          return this.send('closeModal');//NO I18N
            }               
               }
           });

App.EditCertDetailsController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        submit: function() {
            var certNameNew = $('#resourcename').val();
            var description = $('#description').val();
            var cert_type=$("#cert_type").val();
            if(!$.trim(certNameNew).length>0)
            {
                showAlert(I18N.getMsg("js.editssl.validname"));//NO I18N
                return;
            }
            var close=this;
            var app=this.get('controllers.application');
            var ajaxRequestUrl = '/api/pki/Inventory/setSslDetails'; //No I18N
            var reqParams = "certNameNew="+certNameNew+"&certNameOld="+App.InventoryListDetailsController.cert_name+"&ssl_id="+App.InventoryController.res_Id+"&description="+description+"&cert_type="+cert_type;//NO I18N
            if(cert_type=="MSCA")
            {
                if($("#templatename").val()=="" || $("#templatename").val()=="N/A")
                {
                    showAlert(I18N.getMsg("js.editssl.mention.templateName"));//NO I18N
                    return;
                }
                if($("#msca_name").val()=="" || $("#msca_name").val()=="N/A")
                {
                    showAlert(I18N.getMsg("js.editssl.mention.mscaName"));//NO I18N
                    return;
                }
                var isnewkey=document.getElementById("isnewkey").checked;
                reqParams+="&templateName="+$("#templatename").val()+"&msca_name="+$("#msca_name").val()+"&isNewKey="+isnewkey;//NO I18N
            }
            ajaxRequestWithCookie(ajaxRequestUrl,reqParams,false,"",true,function(jsonData){
                if(jsonData.Status === "Success")
                {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N 
                   if(location.href.indexOf("SSLMgmt/certificatesList")>-1)
                   {
                       App.Inventory.getCertificatesListFromGroup(App.InventoryListDetailsController.dGroupId);
                   }else{
                   App.Inventory.listsslsummary();
                }
                app.send('closeModal');//NO I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                }  
            });   
        }
    }
});

App.EditSSHDetailsController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close: function() {
          listusers=true;
          return this.send('closeModal');//NO I18N
        },
        submit: function(){
            var resnameOld=$(App.InventoryListDetailsController.res_name).text();
            var resnameNew= $("#resourcename").val();
            var description = $("#description").val();
            var ipAddress = $("#ipaddress").val();
            var commonpath = $("#path").val();
            var port = $("#port").val();
            var check = false;
            var landingServer = document.getElementById("LSServer").value;
            if(!$.trim(resnameNew).length>0)
            {
                showAlert(I18N.getMsg("js.editresource.validname"));//NO I18N
                return;
            }
            if(!$.trim(description).length>0)
            {
                showAlert(I18N.getMsg("js.editresource.validdescription"));//NO I18N
                return;
            }
            if(kmpStandAlone)
            {
            if(!ValidateIPaddress(ipAddress))
            {
                showAlert(I18N.getMsg("js.IPAddress.enterValidIP"));//NO I18N
                return;
            }
            }
            if(!isValidPort($('#port').val()))
            {
               return; 
            }
            var userids = [];
            var jobj = [];
            if(document.getElementById("showusers").checked)
            {
                $.each($("input[name='usercheckbox']:checked"), function() {
                    var data = {};
                    var userid = $(this).val();
                    var path = $('#text'+userid).val();
                    var username= $('#user'+userid).text();
                    if(path === "")
                    {
                        showAlert(I18N.getMsg("js.editpath.validpath")+" for "+username);//NO I18N
                        check = true;
                        return;
                    }
                    data[userid]=path;
                    jobj.push(data);
                    userids.push(userid);
                });
                if(check)
                {
                    return;
                }
            }
            var jsonstring = JSON.stringify(jobj);
            var close=this;
            var ajaxRequestUrl = '/api/pki/Inventory/editSSHDetails'; //No I18N
            var reqParams = "commonpath="+commonpath+"&port="+port+"&resid="+App.InventoryController.res_Id+"&userids="+userids+"&paths="+jsonstring+"&resnameOld="+resnameOld+"&resnameNew="+resnameNew+"&description="+description+"&ipaddress="+ipAddress+"&landingServer="+landingServer+"&oldPath="+App.InventoryController.path;//NO I18N
            ajaxRequestWithCookie(ajaxRequestUrl,reqParams,false,"",true,function(jsonData){
                if(jsonData.Status === "Success")
                {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N  
                   App.Inventory.listsshsummary();
                   close.send('closeModal');//NO I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                }                    
            });
            listusers=true;
            this.send('closeModal');//NO I18N
        }
    }
});

App.AssociateLandingServerController = Ember.ObjectController.extend({
   actions:{
       close: function()
       {
           return this.send('closeModal');//NO I18N
       },
       submit: function()
       {
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var res_id = App.InventoryController.res_Ids;
            var ls_id = document.getElementById("LSServer").value;
            if(ls_id==="-1")
            {
                showAlert(I18N.getMsg("landingserver.discovery.selectone"));//NO I18N
                return;
            }
            var ajaxRequestUrl = '/api/pki/landingserver/landingServerAssociation';//NO I18N
            var params = "RIds="+res_id+"&LSId="+ls_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
               if(jsonData.Status==="Success")
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                   App.Inventory.listsshsummary();
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }     
            });
            return this.send('closeModal');//NO I18N
        }
   } 
});

App.AddSSHDetailsController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions:{
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        submit: function(){            
            var resnameNew= $("#resourcename").val();
            var description = $("#description").val();
            var ipAddress = $("#ipaddress").val();
            var commonpath = $("#path").val();
            var port = $("#port").val();
            var lsid = document.getElementById("LSServer").value;
            if(!$.trim(resnameNew).length>0)
            {
                showAlert(I18N.getMsg("js.editresource.validname"));//NO I18N
                return;
            }
            if(!$.trim(description).length>0)
            {
                description="NA";//NO I18N
            }
            if(!ValidateIPaddress(ipAddress))
            {
                showAlert(I18N.getMsg("js.IPAddress.enterValidIP"));//NO I18N
                return;
            }
            if(!isValidPort($('#port').val()))
            {
               return; 
            }
            if(lsid!=="-1")
            {
                if(resnameNew.toLowerCase()==="localhost"||ipAddress.indexOf('127')===0)
                {
                    showAlert(I18N.getMsg("loopback.address.cantadd"));//NO I18N
                    return;
                }
            }
            var ajaxRequestUrl = '/api/pki/Inventory/addSSHResource'; //No I18N
            var close=this;
            var reqParams = "commonpath="+commonpath+"&port="+port+"&resnameNew="+resnameNew+"&description="+description+"&ipaddress="+ipAddress+"&lsid="+lsid;//NO I18N            
            getAjaxApiRequest(ajaxRequestUrl,reqParams,function(jsonData){
                if(jsonData.Status === "Success")
                {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N  
                   App.Inventory.listsshsummary();
                   close.send('closeModal');//NO I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                }                    
            });
        },
        submit1: function()
        {
            var FILE_CONTENT=window.FILE_CONTENT;
            var browse = $('#importCsv');
            if(FILE_CONTENT==="")
            {
               showAlert(I18N.getMsg('js.file.selectaFileWithProperFormat'));//No I18N
                return;
        }
            if ($('#textfile').val() == '') {
            showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
            return;

    }
            var fileName=$('#textfile').val();
            var reqUrl = "/api/pki/Inventory/addSSHFromFile";//NO I18N
            var req_params='&FILE_CONTENT='+FILE_CONTENT+'&FILE_NAME='+fileName;//NO I18N
            var textfile=document.getElementById('textfile');
            clearfileElt(browse,textfile);
            getAjaxApiRequest(reqUrl,req_params,function(jsonData){
                if(jsonData.Status === "Success")
                {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N  
                   App.Inventory.listsshsummary();
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                }     
});
            return this.send('closeModal');//NO I18N
        }
    }
});

App.SSHResourcesController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        openCredentialDialog:function(){
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                   showAlert(I18N.getMsg('js.resource.selectAtleastOneResource')); //No I18N
                    return;
            }
            var app=this.get('controllers.application');
            app.send('opendialog','ResourceCredentials');//NO I18N
        },
        showDialog:function()
        {
            var app=this.get('controllers.application');
            app.send('opendialog','addUsersView');//NO I18N
        },
        getUsersListForEnumeration:function()
        {
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length > 1) {
                   showAlert(I18N.getMsg('js.resource.selectOneResource')); //No I18N
                    return;
            }
        var app=this.get('controllers.application'); 
            var id = selRowIds;
                    var res_Id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                    App.InventoryController.res_Id=res_Id;
                    App.SettingsCommonController.isFromCredential=true;
                var ajaxRequestUrl = '/api/pki/ssh/getResUsersWithCredentials?res_id='+res_Id; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    if(jsonData.ResUsersCred.length===0)
                {
                    showAlert(I18N.getMsg("js.resources.enumerate.NoUserwithcredentialavailable"));//NO I18N
                    return;
                }
                else
                {
                    app.send('opendialog','DissociateUserToKeyView');//NO I18N
                }
                });
        },
        resUsersList:function()
        {
            var grid = jQuery("#PKIInventoryList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length > 1) {
                   showAlert(I18N.getMsg('js.resource.selectOneResource')); //No I18N
                    return;
        }
            var id = selRowIds;
                    var res_Id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
               location.href = window.apiclientUrl+"Inventory/ResUsersList/"+res_Id; //No I18N
        },
    }
});

App.CertificateHistoryController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        showCertVersionDialog:function()
        {
            var app=this.get('controllers.application');
            app.send('opendialog','SSLMultipleServersForCertVersion');//NO I18N
        }
    }
});
