// $Id$
App.SettingsController = Ember.ObjectController.extend({});

App.SettingsUserController = Ember.Object.create({
    user_id:"",
    key_id:"",
    id:"",
    login_name: "", //No I18N
    email:"",
    user_role:"",
    operator:false,
    admin:false,
    user_name:"",
    kGroupId:"",
    QUERYID:"",
    type:"",
    parameterMap:{},
    conditionMap:{},
    comparatorMap:{},
    AllUnselectedHostMap:{},
    roleId:"",
    roleName:""
});

App.SettingsCommonController = Ember.Object.create({
    selectedTab:"",
    selectedCMDBTab:"",
    grid:"",
    from:"",
    cGruop:false,
    rGroup:false,
    uGroup:false,
    userGroupUsersView:false,
    uGroupName:"",
    treeContent:"",
    ouUrl:"",
    groupUrl:"",
    asso_flag:"",
    user_id:"",
    dir_path:"",
    isSingleCredential:false,
    keyStateId:"",
    keyName:"",
    keyType:"",
    associatefrom:"",
    disassociatefrom:"",
    isFromCredential:false,
    pmpDashHideKeyOptions:true
});

App.UserManagementController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        signUserCertificate: function(){
            var grid = $("#PKIUserManagement"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                    return;
            }
            var app=this.get('controllers.application');//No I18N
            app.send('opendialog','SignUserWithRootCertificate');//NO I18N            
        }
    }
});

App.SettingsMailServerController = Ember.ObjectController.extend({
/*    mailServerObserver: function(){
    }.observes('mailServer'),*/
    actions: {
        updateMailServer: function(){
            var SERVER_NAME=$("#MAIL_SERVER_NAME").val();//NO I18N
            var PORT=$("#MAIL_SERVER_PORT").val();//NO I18N
            var USER_NAME="";
            var PASSWORD="";
            if(SERVER_NAME==='')
            {
                showAlert(I18N.getMsg('js.serverSettings.enterServerName'));//No I18N
                return;
            }
            if(!isValidPort(PORT))
                            {
                               return; 
                            }
            if(document.getElementById("REQ_AUTH").checked)//NO I18N
            {
                USER_NAME=$("#MAIL_ACCOUNT_NAME").val().trim();//NO I18N
                PASSWORD=$("#MAIL_ACCOUNT_PASSWORD").val().trim();//NO I18N
                if(USER_NAME==="" || PASSWORD==="")
                {
                    showAlert(I18N.getMsg('js.serverSettings.enterUsernameAndPassword'));//NO I18N
                    return;
                }
            }
            var FROM_ADDRESS=$("#FROM_ADDRESS").val();//NO I18N
            if(!validateEmail(FROM_ADDRESS)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
		return;
            }
            var reqUrl="/api/pki/settings/updateMailServer";//No I18N
            var reqparams=$( "form" ).serialize();//NO I18N
            ajaxRequestWithCookie(reqUrl,reqparams,true,"Settings/MailServer",false,"");//NO I18N
        },
        testMail: function(){
            var SERVER_NAME=$("#MAIL_SERVER_NAME").val();//NO I18N
            var PORT=$("#MAIL_SERVER_PORT").val();//NO I18N
            var USER_NAME=$("#MAIL_ACCOUNT_NAME").val();//NO I18N
            var PASSWORD=$("#MAIL_ACCOUNT_PASSWORD").val();//NO I18N
            var FROM_ADDRESS=$("#FROM_ADDRESS").val();//NO I18N
            var TO_ADDRESS=$("#TO_ADDRESS").val();//NO I18N
            if(SERVER_NAME==='')
            {
                showAlert(I18N.getMsg('js.serverSettings.enterServerName'));//No I18N
                return;
            }
            if(!isValidPort(PORT))
                            {
                               return; 
                            }
                            if(document.getElementById("REQ_AUTH").checked)//NO I18N
            {
                USER_NAME=$("#MAIL_ACCOUNT_NAME").val().trim();//NO I18N
                PASSWORD=$("#MAIL_ACCOUNT_PASSWORD").val().trim();//NO I18N
                if(USER_NAME==="" || PASSWORD==="")
                {
                    showAlert(I18N.getMsg('js.serverSettings.enterUsernameAndPassword'));//NO I18N
                    return;
                }
            }
            if(!validateEmail(FROM_ADDRESS)|| !validateEmail(TO_ADDRESS)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
		return;
            }
            var reqUrl="/api/pki/settings/testMail";//No I18N
            var reqparams='SERVER_NAME='+SERVER_NAME+'&PORT='+PORT+'&USER_NAME='+USER_NAME+'&PASSWORD='+encodeURIComponent(PASSWORD)+'&FROM_ADDRESS='+FROM_ADDRESS+'&TO_ADDRESS='+TO_ADDRESS+"&pmpcp="+Get_Cookie('pmpcc'); //No I18N
            ajaxapicall(reqUrl,reqparams,true,"");//NO I18N
        },
        clearPassword:function()
        {
            $("#MAIL_ACCOUNT_PASSWORD").attr("placeholder","");
        }
    }
});

App.SettingsSNMPController= Ember.ObjectController.extend({
    actions: {
          saveServerSettings:function(){
              var isSnmp = document.getElementById("syslog_server_div").style.display == "none";
              var params = 'isSnmp='+isSnmp+'&pmpcp='+Get_Cookie('pmpcc');//No I18N
              var port;
              if(isSnmp){
                  port = document.getElementById("snmp_port").value;//NO I18N
                  params+='&snmp_ip='+document.getElementById("snmp_ip").value+'&snmp_port='+port+'&snmp_collector='+document.getElementById("snmp_collector").value;//NO I18N
              }else{
                   port = document.getElementById("syslog_port").value;//NO I18N
                  params+='&syslogip='+document.getElementById("syslog_ip").value+'&syslog_port='+port;//NO I18N
              }
            if (port === "" || validatePort(port))
            {
                showAlert(I18N.getMsg("server.port.validport"));//NO I18N
                return;
            }
              var reqUrl="/api/pki/settings/setSnmpSyslogServerSettings";//NO I18N
              ajaxapicall(reqUrl,params,true,"");
          }
    }
});
App.SettingsSyslogController = Ember.ObjectController.extend({
    needs:'SettingsSNMP',//NO I18N
    actions: {
          saveServerSettings:function(){
            var app=this.get('controllers.SettingsSNMP');
            app.send('saveServerSettings');//NO I18N
          }
    }
});

App.SettingsRadiusServerController = Ember.ObjectController.extend({
   actions: {
       updateserver: function()
       {
            var server = $("#server_name").val();
            if(!isNotEmpty(server))
            {
                showAlert(I18N.getMsg('js.radius.validserver')); //No I18N
                return; 
            }
            var port = $("#server_port").val();
            if(!isNotEmpty(port))
            {
                showAlert(I18N.getMsg('js.port.specifyaValidPort')); //No I18N
                return; 
            }  
            var protocol = document.getElementById("protocol").value;
            var retries = document.getElementById("retries").value;
            var secret = $("#server_secret").val();
            if(secret=="")
            {
                showAlert(I18N.getMsg('js.radius.entersecret'));//NO I18N
                return;
            }
            var params="server="+server+"&port="+port+"&protocol="+protocol+"&retries="+retries+"&secret="+secret+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            var url = "/api/pki/settings/updateRadiusServer";//No I18N
             getAjaxApiRequest(url,params,function(jsonData){
                 if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    $("#enableDisable").css("display","block");
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
             });            
       },
       clearPassword:function()
        {
            $("#server_secret").attr("placeholder","");
        }
   } 
});

App.VulnerabilitiesSettingsController = Ember.ObjectController.extend({
   actions: {
       saveSettings: function(app){
            var data={};
            data.scheduleType=$("input[name='scheduleType']:checked").val();
            if(data.scheduleType==="daily")
            {
                data.daySchedule=$('#daySchedule').val();
            }
            else if(data.scheduleType==="weekly")
            {
                data.weeklySchedule=$('#weeklySchedule').val();
            }
            var check_san = "no";//NO I18N
            var deployed_servers = "no";//NO I18N
            var mail_address = "";//NO I18N
            if(document.getElementById("checksan").checked)
            {
                check_san = "yes";//NO I18N
            }
            if(document.getElementById("checkip").checked)
            {
                deployed_servers = "yes";//NO I18N
            }
            if(document.getElementById("sendmail").checked)
            {
                mail_address = document.getElementById("scheduleMail").value;
                if(mail_address==="")
                {
                    showAlert(I18N.getMsg("js.email.enteraValidEmailAddress"));//NO I18N
                    return;
                }
                else
                {
                    var mail=mail_address.split(/,|;/);
                    for (var i = 0; i < mail.length; i++) 
                    {
                        if (!validateEmail(mail[i])) 
                        {
                            showAlert(I18N.getMsg('js.email.enteraValidEmailAddress')); //No I18N
                            return;
                        }
                    }
                }
            }
            if(document.getElementById("enable").checked)
            {
                data.SSLv3="enable";//NO I18N
            }
            else
            {
                data.SSLv3="disable";//NO I18N
            }
            if(document.getElementById("senable").checked)
            {
                data.Schedule="enable";//NO I18N
            }
            else
            {
                data.Schedule="disable";//NO I18N
            }
            data.Check_SAN=check_san;
            data.Deployed_Servers=deployed_servers;
            data.Mail_Address=mail_address;
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            var ajaxRequestUrl = '/api/pki/settings/saveSSLVulnerabilitiesSettings'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                    if(app!=undefined)
                    {
                        app.send('closeModal');//No I18N
                }

                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
             });     
       }
   } 
});

App.ServerCertificateController = Ember.ObjectController.extend({
   actions: {
       saveSettings: function(){
           importServerCertificate();           
                }
                    }
                });                
App.GeneralSettingsController = Ember.ObjectController.extend({
   actions: {
        updateMSCARenewalTask: function(app){
            var params="";//NO I18N
            if(document.getElementById("senable").checked)
            {
                if($("#Mins").val()=="" || $("#Hrs").val()=="")
                {
                    showAlert(I18N.getMsg("js.inputtime.enteraValidTime"));//NO I18N
                    return;
                }
                params="renewalStatus=Enabled"+"&Hours="+$("#Hrs").val()+"&Minutes="+$("#Mins").val();//NO I18N
            }
            else
            {
                params="renewalStatus=Disabled";//NO I18N
            }
            var ajaxRequestUrl = '/api/pki/settings/updateMSCARenewalTask'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                    if(app!=undefined)
                    {
                        app.send('closeModal');//No I18N
                }
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
             });     

        }
    }
});            

App.ReportsPasswordController = Ember.ObjectController.extend({
   actions: {
       submit: function(){
           var isAdmin = App.ApplicationController.isAdmin;
           var isEncryptionEnabled=false;
           var isUserPasswordEnabled=false;
           var globalPassword="";
           var userPassword="";
           var ajaxRequestUrl = '/api/pki/settings/setExportPasswordSettings'; //No I18N
           if(isAdmin==true)
           {
               if( document.getElementById("enablePasswordEncryption").checked)
               {
                   isEncryptionEnabled=true;
                   globalPassword = $.trim(document.getElementById("globalpassword").value);
                   if(globalPassword=="")
                   {
                       showAlert(I18N.getMsg("settings.exportpassword.enterglobalpassword"));//NO I18N
                       return;
   }
                   if(globalPassword.length<8)
                   {
                       showAlert(I18N.getMsg("js.Password.passwordLength"));//NO I18N
                       return;
                   }
               }
               if(document.getElementById("enableUserPassword").checked)
               {
                   isUserPasswordEnabled=true;
                   userPassword=$.trim(document.getElementById("userpassword").value);
                   if(userPassword!=="" && userPassword.length<8)
                   {
                       showAlert(I18N.getMsg("js.Password.passwordLength"));//NO I18N
                       return;
                   }
               }
           }
           else
           {
               userPassword=$.trim(document.getElementById("userpassword").value);
               if(userPassword==="")
               {
                   showAlert(I18N.getMsg("settings.exportpassword.enteruserpassword"));//NO I18N
                   return;
               }
               if(userPassword.length<8)
               {
                   showAlert(I18N.getMsg("js.Password.passwordLength"));//NO I18N
                   return
               }
           }
           var params="isAdmin="+isAdmin+"&isEncryptionEnabled="+isEncryptionEnabled+"&isUserPasswrodEnabled="+isUserPasswordEnabled+"&globalPassword="+encodeURIComponent(globalPassword)+"&userPassword="+encodeURIComponent(userPassword);//NO I18N
           getAjaxApiRequest(ajaxRequestUrl,params,function(jsonData){
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N                       
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
});
       }
   }
});

App.UnMappedMailsController = Ember.ObjectController.extend({
   actions : {
       submit: function(){
           var grid = $('#UnMappedList');
           var selRowIds = grid.jqGrid('getGridParam', 'selarrrow'); //No I18N 
            if (selRowIds == undefined || selRowIds.length == 0 ) {
                showAlert(I18N.getMsg('settings.unmappedmails.selectatleast')); //No I18N
                return;
            }
            var jobj = [];
            var abort = false;
            $.each(selRowIds, function ()
            {
                var rowid = this;
                var id = grid.jqGrid('getCell', rowid, 'ID'); //No I18N
                var type = grid.jqGrid('getCell', rowid, 'TYPE'); //No I18N
                var mail = grid.jqGrid('getCell', rowid, 'MAIL_ID'); //No I18N
                if(type==="GODADDYORDER" || type==="SSLSTORE")
                {
                    abort=true;
                    showAlert(I18N.getMsg("godaddy.delete.unmappedemail.alert",new Array(mail)));//NO I18N
                    return;
                }
                var data={"ID":id,"TYPE":type,"MAIL":mail};//NO I18N
                jobj.push(data);
            });
            if(abort)
            {
                return;
            }
            var jsonstring = JSON.stringify(jobj);
            var ajaxRequestUrl = '/api/pki/settings/deleteUnmappedMails'; //No I18N
            var reqParams = "data="+jsonstring;//NO I18N
            ajaxRequestWithCookie(ajaxRequestUrl,reqParams,false,"",true,function(jsonData){   
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
                {{App.Settings.getUnmappedMailsView();}}
            });
       }
   } 
});

App.PIIDataController = Ember.ObjectController.extend({
   actions: {
       submit: function(){
           var jobj = [];
           var grid = $('#PIIDataList');
           var allRowsInGrid =  grid.getDataIDs()
           $.each(allRowsInGrid, function (){
                var id = this;
                var settings_id = grid.jqGrid('getCell', id, 'Settings_Id'); //No I18N
                var Mask_In_Report=false;
                if(document.getElementById("Mask_In_Report_"+settings_id).checked)
                {
                    Mask_In_Report=true;
                }
                var Mask_In_Schedule=false;
                if(document.getElementById("Mask_In_Schedule_"+settings_id).checked)
                {
                    Mask_In_Schedule=true;
                }
                var Hide_In_Report=false;
                if(document.getElementById("Hide_In_Report_"+settings_id).checked)
                {
                    Hide_In_Report=true;
                }
                var Hide_In_Schedule=false;
                if(document.getElementById("Hide_In_Schedule_"+settings_id).checked)
                {
                    Hide_In_Schedule=true;
                }
                var data={"Settings_ID":settings_id,"Mask_In_Report":Mask_In_Report,"Mask_In_Schedule":Mask_In_Schedule,"Hide_In_Report":Hide_In_Report,"Hide_In_Schedule":Hide_In_Schedule};//NO I18N
                jobj.push(data);
            });
            var jsonstring = JSON.stringify(jobj);
            var ajaxRequestUrl = '/api/pki/settings/setPIIData'; //No I18N
            var reqParams = "data="+jsonstring;//NO I18N
            ajaxRequestWithCookie(ajaxRequestUrl,reqParams,false,"",true,function(jsonData){             
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });    
       },
       reset: function(){
           $('input:checkbox').attr("checked",false);
       }
   }
});

App.PurgeAuditController = Ember.ObjectController.extend({
   actions: {
       saveSettings: function(){
           var operationAudit = $.trim(document.getElementById("operation").value);
           if(operationAudit=="")
           {
               operationAudit=0;
           }           
           if(!operationAudit.match(/^\d+$/))
           {
               showAlert(I18N.getMsg("js.schedule.validdays"));//NO I18N
               return;
           }
           var discoveryAudit = $.trim(document.getElementById("discoveryaudit").value);
           if(discoveryAudit=="")
           {
               discoveryAudit=0;
           }
           if(!discoveryAudit.match(/^\d+$/))
           {
               showAlert(I18N.getMsg("js.schedule.validdays"));//NO I18N
               return;
           }
           var associationAudit = $.trim(document.getElementById("keyassociation").value);
           if(associationAudit=="")
           {
               associationAudit=0;
           }
           if(!associationAudit.match(/^\d+$/))
           {
               showAlert(I18N.getMsg("js.schedule.validdays"));//NO I18N
               return;
           }
           var rotationAudit = $.trim(document.getElementById("keyrotation").value);
           if(rotationAudit=="")
           {
               rotationAudit=0;
           }
           if(!rotationAudit.match(/^\d+$/))
           {
               showAlert(I18N.getMsg("js.schedule.validdays"));//NO I18N
               return;
           }
           var scheduleAudit = $.trim(document.getElementById("scheduleaudit").value);
           if(scheduleAudit=="")
           {
               scheduleAudit=0;
           }
           if(!scheduleAudit.match(/^\d+$/))
           {
               showAlert(I18N.getMsg("js.schedule.validdays"));//NO I18N
               return;
           }  
           var ajaxRequestUrl = '/api/pki/settings/setPurgeAuditConfig?operationAudit='+operationAudit+'&discoveryAudit='+discoveryAudit+'&associationAudit='+associationAudit+'&rotationAudit='+rotationAudit+'&scheduleAudit='+scheduleAudit; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"pmpcp="+Get_Cookie('pmpcc'),function(jsonData){     //NO I18N           
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });       
       }
   } 
});

App.METrackerController = Ember.ObjectController.extend({
   actions: {
       saveSettings: function(){
            var tracker = "disable";//NO I18N           
            if(document.getElementById("enable").checked)
            {
                tracker="enable";//NO I18N
            }
            var ajaxRequestUrl = '/api/pki/settings/setMETrack?track='+tracker; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){                
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });            
        }
    }
});

App.SDPServerController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
   actions:{
       saveSettings: function(){
           var Url="";
            var Key = document.getElementById("techniciankey").value;
               if(Key==="")
               {
                   Key=$("#techniciankey").attr("placeholder");                   
                   if(Key!==I18N.getMsg("js.sdp.placeholder.KeyAvailable"))
                   {
                       showAlert(I18N.getMsg("settings.cmdb.entertechniciankey"));//NO I18N
                       return;
                   }else{
                       Key='Key Available';//NO I18N
                   }
               }
               Url = document.getElementById("sdpserverurl").value;
               if(Url==="")
               {
                   showAlert(I18N.getMsg("settings.cmdb.entersdpurl"));//NO I18N
                   return;
               }
               var app=this.get("controllers.application");
            var ajaxRequestUrl = '/api/pki/settings/setSDPServer?Key='+Key+"&Url="+Url; //No I18N
            vConfirmation1(I18N.getMsg("js.gdpr.cmdp.consent"),function(){//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){      
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                        app.send('closeModal');//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            })
            },I18N.getMsg("js.ack.req"),500);//NO I18N
       }
   } 
});

App.CMDBController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
   actions: {
       saveSettings: function(){
           var data={};
           var cmdb=false;
           var ciType="";
           var parentCiType="";
           var ci="new";//NO I18N
           if(document.getElementById("enable").checked)
           {
               cmdb=true;               
               ciType = document.getElementById("citype").value;
               if(ciType==="")
               {
                   showAlert(I18N.getMsg("cmdb.alert.entercitype"));//NO I18N
                   return;
           }
               if(document.getElementById("showParent").checked)
               {
                   parentCiType = document.getElementById("parentcitype").value;
               }
               else
               {
                   ci="existing";//NO I18N
                   var object = {};
                   var mandatory=true;
                   object.type=document.getElementById("commonName").value;
                   object.value=document.getElementById("commonName").options[document.getElementById("commonName").selectedIndex].text;
                   data.commonName = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("dnsName").value;
                   object.value=document.getElementById("dnsName").options[document.getElementById("dnsName").selectedIndex].text;
                   data.dnsName = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("sigAlg").value;
                   object.value=document.getElementById("sigAlg").options[document.getElementById("sigAlg").selectedIndex].text;
                   data.sigAlg = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("org").value;
                   object.value=document.getElementById("org").options[document.getElementById("org").selectedIndex].text;
                   data.organization = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("validFrom").value;
                   object.value=document.getElementById("validFrom").options[document.getElementById("validFrom").selectedIndex].text;
                   data.validFrom = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("expiryDate").value;
                   object.value=document.getElementById("expiryDate").options[document.getElementById("expiryDate").selectedIndex].text;
                   data.expiryDate = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("keySize").value;
                   object.value=document.getElementById("keySize").options[document.getElementById("keySize").selectedIndex].text;
                   data.keySize = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("keyAlg").value;
                   object.value=document.getElementById("keyAlg").options[document.getElementById("keyAlg").selectedIndex].text;
                   data.keyAlg = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("creationTime").value;
                   object.value=document.getElementById("creationTime").options[document.getElementById("creationTime").selectedIndex].text;
                   data.creationTime = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   object = {};
                   object.type=document.getElementById("description").value;
                   object.value=document.getElementById("description").options[document.getElementById("description").selectedIndex].text;
                   data.description = JSON.stringify(object);
                   if(object.value==="CI Name")
                   {
                       mandatory=false;
                   }
                   
                   if(mandatory)
                   {
                       showAlert(I18N.getMsg("cmdb.alert.mapciname"));//NO I18N
                       return;
                   }
               }               
                data.ci=ci;           
                data.ciType=ciType;
                data.parentCiType=parentCiType;
           }         
           data.cmdb=cmdb;
           data.pmpcp=Get_Cookie('pmpcc');//NO I18N
           var ajaxRequestUrl = '/api/pki/settings/setCMDB'; //No I18N
           var app=this.get("controllers.application");
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){                
                if(jsonData.Status ===  "Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N   
                    app.send('closeModal');//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });  
       }
   }
});

App.SettingsProxyController = Ember.ObjectController.extend({
    actions: {
        updateProxyServer: function(){
            var params="";
            if($("#radio2").prop("checked")===true)//NO I18N
            {
                var SERVER_NAME=$("#SERVER_NAME").val();//NO I18N
                var PORT=$("#PORT").val();//NO I18N
                var USER_NAME=$("#USER_NAME").val();//NO I18N
                var PASSWORD=$("#PASSWORD").val();//NO I18N
                if(SERVER_NAME==='')
                {
                    showAlert(I18N.getMsg('js.serverSettings.enterServerName'));//No I18N
                    return;
                }
                if(!isValidPort(PORT))
                {
                    return; 
                }
//                if(USER_NAME==="" || PASSWORD==="")
//                {
//                    showAlert(I18N.getMsg('js.serverSettings.enterUsernameAndPassword'));//NO I18N
//                    return;
//                }
                params='SERVER_NAME='+SERVER_NAME+'&PORT='+PORT+'&USER_NAME='+USER_NAME+'&PASSWORD='+encodeURIComponent(PASSWORD)+"&DIRECT_CONNECTION=0";//NO I18N
            }
            else
            {
                params="DIRECT_CONNECTION=1";//NO I18N
            }
            var reqUrl="/api/pki/settings/updateProxyServer";//No I18N
            ajaxRequestWithCookie(reqUrl,params,true,"Settings/Proxy",false,"");//NO I18N
        },
        clearPassword:function()
        {
            $("#PASSWORD").attr("placeholder","");
        }
    }
});

App.SettingsRolesController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
   actions: {
        EditRoles: function () {
            var grid = $('#PKIRoleManagement');
            var selRowIds = grid.jqGrid('getGridParam', 'selarrrow'); //No I18N 
            if (selRowIds == undefined || selRowIds.length == 0 && selRowIds.length != 1) {
                showAlert(I18N.getMsg('js.roleselection.selectOneRole')); //No I18N
                return;
            }
            var roleId = "";
            $.each(selRowIds, function ()
            {
                var id = this;
                roleId = grid.jqGrid('getCell', id, 'roleId'); //No I18N
            });
            if (roleId !== null && roleId !== "")
            {
                App.SettingsUserController.roleId = roleId;
            }
            var app = this.get("controllers.application");
            app.send('opendialog',"AddRoles");//NO I18N         
       },
       deleteRoles: function () {
            var grid = $('#PKIRoleManagement');
            var selRowIds = grid.jqGrid('getGridParam', 'selarrrow'); //No I18N 
            if (selRowIds == undefined || selRowIds.length == 0 && selRowIds.length != 1) {
                showAlert(I18N.getMsg('js.roleselection.selectOneRole')); //No I18N
                return;
            }
            var roleId = "";
            var roleName = "";
            $.each(selRowIds, function ()
            {
                var id = this;
                roleId = grid.jqGrid('getCell', id, 'roleId'); //No I18N
                roleName = grid.jqGrid('getCell', id, 'RoleName'); //No I18N
            });
            if (roleId !== null && roleId !== "")
            {
                App.SettingsUserController.roleId = roleId;
                App.SettingsUserController.roleName = roleName;
       }
            var app = this.get("controllers.application");
            app.send('opendialog',"DeleteRoles");//NO I18N     
   } 
   } 
});

App.AddRolesController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
   actions: {
       close: function() {
            App.SettingsUserController.roleId="";
          return this.send('closeModal');//NO I18N
        },
        saveRole: function() {
            var categoryIndices = $('input:checkbox.CategorySelection').filter(':checked').map(function () {
                return this.id;
            }).get();
            var roleName=$('#rolename').val();
             var description=$('#roleDescription').val();
            var reqUrl="/api/pki/settings/addRole";//No I18N
            var reqparams='rolename='+roleName+'&description='+description+'&categories='+categoryIndices; //No I18N
            //ajaxRequestWithCookie(reqUrl,reqparams,true,"",false,"");//NO I18N
            var close=this;
            ajaxRequestWithCookie(reqUrl,reqparams,false,"",true,function(jsonData){
                if(jsonData.Status === "Success")
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    App.Settings.getPKIRolesList();
                    close.send('closeModal');//NO I18N
                }else{
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
        },
        updateRole: function() {
            var categoryIndices = $('input:checkbox.CategorySelection').filter(':checked').map(function () {
                return this.id;
            }).get();
            var roleid=App.SettingsUserController.roleId;
             var description=$('#roleDescription').val();
            var reqUrl="/api/pki/settings/updateRole";//No I18N
            var reqparams='roleid='+roleid+'&description='+description+'&categories='+categoryIndices+"&pmpcp="+Get_Cookie('pmpcc'); //No I18N
            //ajaxRequestWithCookie(reqUrl,reqparams,true,"",false,"");//NO I18N
            var close=this;
            ajaxRequestWithCookie(reqUrl,reqparams,false,"",true,function(jsonData){
                if(jsonData.Status === "Success")
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                     App.Settings.getPKIRolesList();
                     close.send('closeModal');//NO I18N
                }else{
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
             App.SettingsUserController.roleId="";
        }
   } 
});

App.DeleteRolesController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
   actions: {
       close: function() {
            App.SettingsUserController.roleId="";
          return this.send('closeModal');//NO I18N
        },
        deleteRole: function() {
            var roleid=App.SettingsUserController.roleId;
            var newRoleid = $('#newRoleId').val();
            var reqUrl="/api/pki/settings/deleteRole";//No I18N
            var reqparams='roleid='+roleid+'&newRoleid='+newRoleid+"&pmpcp="+Get_Cookie('pmpcc'); //No I18N
            //ajaxRequestWithCookie(reqUrl,reqparams,true,"",false,"");//NO I18N
            var close=this;
            ajaxRequestWithCookie(reqUrl,reqparams,false,"",true,function(jsonData){
                if(jsonData.Status === "Success")
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                     App.Settings.getPKIRolesList();
                     close.send('closeModal');//NO I18N
                }else{
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
             App.SettingsUserController.roleId="";
             App.SettingsUserController.roleName="";
        }
   } 
});

App.SettingsChangePasswordController = Ember.ObjectController.extend({
    actions: {
        changePwdSubmit: function(){
            var oldPassword=$("#oldPassword").val();//NO I18N
            var newPassword=$("#newPassword").val();//NO I18N
            var rePassword=$("#rePassword").val();//NO I18N
            if(oldPassword==="" || newPassword==="")
                {
                    showAlert(I18N.getMsg('js.Password.enterPassword'));//NO I18N
                    return;
                }
            if(newPassword.length<8)
            {
                showAlert(I18N.getMsg('js.Password.passwordLength'));//NO I18N
                return;
            }
            if(newPassword!==rePassword)
            {
                showAlert(I18N.getMsg('js.Password.passwordNotMatched'));//NO I18N
                return;
            }
            var reqUrl="/api/pki/settings/changePassword";//No I18N
            var reqparams='userName='+window.userName+'&oldPassword='+encodeURIComponent(oldPassword)+'&newPassword='+encodeURIComponent(newPassword); //No I18N
            ajaxRequestWithCookie(reqUrl,reqparams,true,"Settings/UserManagement",false,"");//NO I18N
        }
    }
});

var isRGUsed_old=false;
var isUGUsed_old=false;
var isSpecific_old=false;
var isSSL_old=false;
var isSSH_old=false;
App.SettingsUpdateUserController = Ember.ObjectController.extend({
    actions: {
        updateUserSubmit: function()
	{
            var LOGIN_ID=App.SettingsUserController.user_id;
            var LOGIN_NAME=$('#LoginName').val(); //No I18N
            var FIRST_NAME=$('#firstName').val(); //No I18N
            var LAST_NAME=$('#lastName').val(); //No I18N
            var EMAIL=$('#EMail').val(); //No I18N
            var ACC_LEVEL=$('#ACC_LEVEL').val();//No I18N
            var sshvalues  = [];
            var sslvalues = [];
            var resuserids=[];
            var sslGroups = [];
            var reqParams="";            
            var isssh=false;
            var isssl=false;
            var userids=[];
            var isRGUsed = false;
            var isUGUsed = false;
            var isSpecific = false;
            if(LOGIN_NAME.trim()==="")//NO I18N
            {
                showAlert(I18N.getMsg('js.user.enterLoginName'));//NO I18N
                return;
            }
            if($('#firstNameDiv').is(":visible")){
                if (FIRST_NAME.trim() === "")//NO I18N
                {
                    showAlert(I18N.getMsg('settings.createuser.enterfirstName'));//NO I18N
                    return;
                }
                if (LAST_NAME.trim() === "")//NO I18N
                {
                    showAlert(I18N.getMsg('settings.createuser.enterlastName'));//NO I18N
                    return;
                }
            }
            EMAIL=EMAIL.trim();            
            if(!(EMAIL.indexOf("@") > -1))//NO I18N
            {
                showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));//NO I18N
                return;
            }
            if(ACC_LEVEL !="Administrator")
            {
                if(document.getElementById("isssh").checked)
                {
                    
                    if(document.getElementById("RGroup").checked)
                    {
                        isRGUsed = true;
                    var select = document.getElementById('SELECTEDRESOURCEGROUPS');
                    var options = select.getElementsByTagName('option');
                        for (var i=options.length; i--;) {
                            sshvalues.push(options[i].value)
                        }
                        if(sshvalues.toString()=="")
                    {
                            showAlert(I18N.getMsg('js.resourceGroup.SelectAtleastOneGroup'));//No I18N
                        return;
                    }
                        reqParams="&SELECTEDRESOURCEGROUPS="+sshvalues;//No I18N
                    }
                    else if(document.getElementById("UGroup").checked)
                {
                        isUGUsed = true;
                    var select = document.getElementById('SELECTEDUSERGROUPS');
                    var options = select.getElementsByTagName('option');
                        for (var i=options.length;i--;)
                    {
                            sshvalues.push(options[i].value)
                        }
                        if(sshvalues.toString()=="")
                        {
                            showAlert(I18N.getMsg('js.usersGroup.selectatleastonegroup'));//No I18N
                        return;
                    }
                        reqParams="&SELECTEDUSERGROUPS="+sshvalues;//NO I18N
                    }
                else
                {
                        isssh=true;
                        isSpecific=true;
                    var checked_ids = []; 
                    checked_ids=$('#data').jstree(true).get_selected();//NO I18N
                    for(var i=0;i<checked_ids.length;i++)
                    {
                        if(checked_ids[i].indexOf("par") > -1)
                        {
                            var par_split=checked_ids[i].split("_");
                                sshvalues.push(par_split[1]);
                        }
                        else
                        {
                            var user_split=checked_ids[i].split("_");
                                if(!checkArray(sshvalues,user_split[0]))
                            {
                                    sshvalues.push(user_split[0]);
                            }
                                userids.push(user_split[1]); 
                        }
                    }
                        if(userids.length<=0)
                    {
                        showAlert(I18N.getMsg('js.userselection.selectAtleastOneUserFromSshResource'));//No I18N
                    return;
                }
                        reqParams="&SELECTEDDEVICES="+sshvalues+"&USERIDS="+userids; //No I18N
            }
                                     
            }
                if(document.getElementById("isssl").checked)
                {
                    isssl=true;
                    if(document.getElementById("SpecificSelection").checked)
                    {                        
                    var select = document.getElementById('SELECTEDDEVICES');
                    var options = select.getElementsByTagName('option');
                    for (var i=options.length; i--;) {
                    sslvalues.push(options[i].value)
            }
                    if(sslvalues.toString()=="")
                    {
                        showAlert(I18N.getMsg('js.createuser.selectatleast.onsslcertificate'));//No I18N
                        return;
                    }
                    reqParams+="&SELECTEDSSLDEVICES="+sslvalues; //No I18N
                }
                    if(document.getElementById("GroupSelection").checked)
                    {                        
                        var select = document.getElementById('SELECTEDGROUPS');
                        var options = select.getElementsByTagName('option');
                        for (var i=options.length; i--;) {
                        sslGroups.push(options[i].value)
                        }
                        if(sslGroups.toString()=="")
                        {
                            showAlert(I18N.getMsg('js.Group.selectatleastonegroup'));//No I18N
                            return;
                        }
                        reqParams+="&SELECTEDSSLGOUPS="+sslGroups; //No I18N
                    }                    
                    if(!document.getElementById("SpecificSelection").checked && !document.getElementById("GroupSelection").checked)
                    {
                        showAlert(I18N.getMsg("createuser.selectcertificates.alert"));//NO I18N
                        return;
                    }
                }
                
                if(!document.getElementById("isssl").checked && !document.getElementById("isssh").checked)
                {
                    showAlert(I18N.getMsg('js.resource.selectAtleastOneResource'));//No I18N
                    return;
                }
                reqParams+="&isSpecific="+isSpecific+"&isSpecific_old="+isSpecific_old+"&isssh="+isssh+"&isssl="+isssl;//NO I18N
                reqParams+="&isRGUSED="+isRGUsed+"&isUGUSED="+isUGUsed+"&isRGUsed_old="+isRGUsed_old+"&isUGUsed_old="+isUGUsed_old+"&isSSL_old="+isSSL_old+"&isSSH_old="+isSSH_old;//NO I18N
            }
            var reqUrl="/api/pki/settings/updateUser";//No I18N
            reqParams=reqParams+'&FIRST_NAME='+FIRST_NAME+'&LAST_NAME='+LAST_NAME+'&LOGIN_NAME='+LOGIN_NAME+'&EMAIL='+EMAIL+'&ACC_LEVEL='+ACC_LEVEL+'&LOGIN_ID='+LOGIN_ID; //No I18N
            ajaxRequestWithCookie(reqUrl,reqParams,true,"Settings/UserManagement",false,"");//NO I18N
        }
    }
});

App.AssociateMapperController = Ember.ObjectController.extend({
    actions: {
        KeyAssociateMapping: function()
	{
            redirectUrl("SSHMgmt/mappingGraph/"+"key/"+App.SettingsUserController.key_id);//No I18N
        }        
    }
});

function checkArray(arr,value)
{
    for(var i=0;i<arr.length;i++)
    {
        if(arr[i]===value)
        {
            return true;
        }
    }
    return false;
}

App.SettingsCreateUserController = Ember.ObjectController.extend({
    actions: {
        createUserSubmit: function()
	{
            var LOGIN_NAME=$('#LoginName').val(); //No I18N
            var FIRST_NAME=$('#firstName').val(); //No I18N
            var LAST_NAME=$('#lastName').val(); //No I18N
            var PASSWORD=$('#Password').val(); //No I18N
            var CONF_PASSWORD=$('#Conf_Password').val(); //No I18N
            var EMAIL=$('#EMail').val(); //No I18N
            var ACC_LEVEL=$('#ACC_LEVEL').val();//No I18N
            var sshvalues  = [];
            var sslvalues = [];
            var sslGroups = [];
            var userids=[];
            var selectedRGIds=[];
            var isRGUsed=false;
            var isUGUsed=false;
            var isssh=false;
            var isssl=false;
            var reqparams="";
            if(LOGIN_NAME.trim()==="")//NO I18N
            {
                showAlert(I18N.getMsg('js.user.enterLoginName'));//NO I18N
                return ;
            }
            if((/\\/).test(LOGIN_NAME.trim())){
                showAlert(I18N.getMsg('settings.createuser.loginNameMustNotContainBackslash'));//NO I18N
                return ;
            }
            if(FIRST_NAME.trim()==="")//NO I18N
            {
                showAlert(I18N.getMsg('settings.createuser.enterfirstName'));//NO I18N
                return ;
            }
            if(LAST_NAME.trim()==="")//NO I18N
            {
                showAlert(I18N.getMsg('settings.createuser.enterlastName'));//NO I18N
                return ;
            }

            if(PASSWORD.length<8)
            {
                showAlert(I18N.getMsg('js.Password.passwordLength'));//NO I18N
                return;
            }
            if(PASSWORD!==CONF_PASSWORD)
            {
                showAlert(I18N.getMsg('js.Password.passwordNotMatched'));//NO I18N
                return;
            }
            EMAIL=EMAIL.trim();            
            if(!validateEmail(EMAIL)) {
		showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
                return;
            }
            if(ACC_LEVEL !="Administrator")
            {
                if(document.getElementById("isssh").checked)
                {
                    isssh=true;
                    if(document.getElementById("RGroup").checked)
                    {
                    isRGUsed=true;
                    isUGUsed = false;
                    var select = document.getElementById('SELECTEDRESOURCEGROUPS');
                    var options = select.getElementsByTagName('option');
                    for (var i=options.length; i--;) {
                            sshvalues.push(options[i].value)
                    }
                        if(sshvalues.toString()=="")
                        {
                            showAlert(I18N.getMsg('js.resourceGroup.SelectAtleastOneGroup'));//No I18N
                            return;
                }
                        reqparams="&isUGUsed=false&isRGUSED=true&SELECTEDRESOURCEGROUPS="+sshvalues;//No I18N
                    }
                    else if(document.getElementById("UGroup").checked)
                {
                    isUGUsed = true;
                    isRGUsed=false;
                    var select = document.getElementById('SELECTEDUSERGROUPS');
                    var options = select.getElementsByTagName('option');
                    for (var i=options.length;i--;)
                    {
                            sshvalues.push(options[i].value)
                    }
                        if(sshvalues.toString()=="")
                {
                            showAlert(I18N.getMsg('js.usersGroup.selectatleastonegroup'));//No I18N
                            return;
                }
                        reqparams="&isRGUsed=false&isUGUsed=true&SELECTEDUSERGROUPS="+sshvalues;//NO I18N
                }
                    else
                {
                    var checked_ids = []; 
                    checked_ids=$('#data').jstree(true).get_selected();//NO I18N
                    for(var i=0;i<checked_ids.length;i++)
                    {
                        if(checked_ids[i].indexOf("par") > -1)
                        {
                            var par_split=checked_ids[i].split("_");
                                sshvalues.push(par_split[1]);
                        }
                        else
                        {
                            var user_split=checked_ids[i].split("_");
                                if(!checkArray(sshvalues,user_split[0]))
                            {
                                    sshvalues.push(user_split[0]);
                            }
                            userids.push(user_split[1]); 
                        }
                    }
                    if(userids.length<=0)
                    {
                        showAlert(I18N.getMsg('js.userselection.selectAtleastOneUserFromSshResource'));//No I18N
                        return;
                    }
                        reqparams="&isRGUSED=false&isUGUSED=false&SELECTEDDEVICES="+sshvalues+"&USERIDS="+userids; //No I18N
                }
                                     
                }
                if(document.getElementById("isssl").checked)
                {
                    isssl=true;
                    if(document.getElementById("SpecificSelection").checked)
                    {                        
                    var select = document.getElementById('SELECTEDDEVICES');
                    var options = select.getElementsByTagName('option');
                    for (var i=options.length; i--;) {
                    sslvalues.push(options[i].value)
                    }
                    if(sslvalues.toString()=="")
                    {
                        showAlert(I18N.getMsg('js.createuser.selectatleast.onsslcertificate'));//No I18N
                        return;
                    }
                    reqparams+="&SELECTEDSSLDEVICES="+sslvalues; //No I18N
                }
                    if(document.getElementById("GroupSelection").checked)
                    {                        
                        var select = document.getElementById('SELECTEDGROUPS');
                        var options = select.getElementsByTagName('option');
                        for (var i=options.length; i--;) {
                        sslGroups.push(options[i].value)
                        }
                        if(sslGroups.toString()=="")
                        {
                            showAlert(I18N.getMsg('js.Group.selectatleastonegroup'));//No I18N
                            return;
                        }
                        reqparams+="&SELECTEDSSLGOUPS="+sslGroups; //No I18N
                    }                    
                    if(!document.getElementById("SpecificSelection").checked && !document.getElementById("GroupSelection").checked)
                    {
                        showAlert(I18N.getMsg("createuser.selectcertificates.alert"));//NO I18N
                        return;
                    }                    
                }
                
                if(!document.getElementById("isssl").checked && !document.getElementById("isssh").checked)
                {
                    showAlert(I18N.getMsg('js.resource.selectAtleastOneResource'));//No I18N
                    return;
                }
                reqparams+="&isssh="+isssh+"&isssl="+isssl;//NO I18N
            }
            var reqUrl="/api/pki/settings/createUser";//No I18N
            reqparams=reqparams+'&FIRST_NAME='+FIRST_NAME+'&LAST_NAME='+LAST_NAME+'&LOGIN_NAME='+encodeURIComponent(LOGIN_NAME)+'&PASSWORD='+encodeURIComponent(PASSWORD)+'&CONF_PASSWORD='+encodeURIComponent(CONF_PASSWORD)+'&EMAIL='+EMAIL+'&ACC_LEVEL='+ACC_LEVEL;//No I18N
            ajaxRequestWithCookie(reqUrl,reqparams,true,"Settings/UserManagement",false,"");//NO I18N
        }
    }
});

App.SettingsADAuthController = Ember.ObjectController.extend({
    needs:['application','ADOUList'],//NO I18N
    actions: 
    {
        openADOUdialog:function(template)
        {
            var app = this.get("controllers.application");
            app.send('opendialog',template);//NO I18N                        
        },
        generateTree:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Feature doesn't work in Linux");//NO I18N
                return;
            }
            var str = $( "form" ).serialize();
            var domainName = document.getElementById('DOMAINNAME');//No I18N
            var domainController = document.getElementById('DOMAINCONTROLLER');//No I18N
            var secDCName = document.getElementById('SECDOMAINCONTROLLER');//No I18N
            var userName = document.getElementById('LOGINNAME');//No I18N
            var password = document.getElementById('PASSWORD');//No I18N
            var users = document.getElementById('cusers');//No I18N
            var cusergroups = document.getElementById('cusergroups');//No I18N
            var cous = document.getElementById('cous');//No I18N
                var cousvalue = cous.value;
            var conn_mode_ssl1 = document.getElementById("connection_mode_ssl");//No I18N
            var isSSL1 = "false";//No I18N
            if(domainName.value==="")//NO I18N
            {
                showAlert(I18N.getMsg('js.adAuth.enterDomainName'));//NO I18N
                return;
            }
            if(domainController.value==='' && secDCName.value==='')
            {
                showAlert(I18N.getMsg('js.adAuth.enterPrimaryOrSecondaryDomain'));//NO I18N
                return;
            }
            if(userName.value=="")//NO I18N
            {
                showAlert(I18N.getMsg('js.adAuth.enterUserName'));//NO I18N
                return;
            }
            if(password.value==="")//NO I18N
            {
                showAlert(I18N.getMsg('js.adAuth.enterPassword'));//NO I18N
                return;
            }
            if(users.value==='' && cusergroups.value==='' && cous.value==='')
            {
                showAlert(I18N.getMsg('js.adAuth.enterUsersOrUserGroupsOrOUs'));//No I18N
                return;
            }
            if(conn_mode_ssl1.checked)
            {
                    isSSL1 = "true";//No I18N
            }
            var secDCName = document.getElementById('SECDOMAINCONTROLLER');//No I18N
            var reqUrl="/api/pki/settings/importUsers";//No I18N
            var params = "RequestType="+'OUSINDOMAIN'+"&DOMAINNAME="+domainName.value+"&COUSVALUE="+cousvalue+"&DCNAME="+domainController.value+"&UNAME="+userName.value+"&PWD="+encodeURIComponent(password.value)+"&SECDCNAME="+secDCName.value+"&ISSSL="+isSSL1;; // NO I18N
            if((users!=undefined && (users.value).trim()!="") || (cusergroups!=undefined && (cusergroups.value).trim()!="") || (cous!=undefined && (cous.value).trim()!="") )//No I18N
            {
                var cugvalue = cusergroups.value;
                var cousvalue = cous.value;
                var day = "";//document.getElementById("day_id").value;//No I18N
                var hour = "";//document.getElementById("hour_id").value;//No I18N
                var min = "";//document.getElementById("mins_id").value;//No I18N

                var params1 = "RequestType=IMPORTADUSERS&DOMAINNAME="+domainName.value+"&USERS="+users.value+"&DCNAME="+domainController.value+"&LOGINNAME="+userName.value+"&PASSWORD="+encodeURIComponent(password.value)+"&SECDCNAME="+secDCName.value+"&CUGVALUE="+cugvalue+"&COUSVALUE="+cousvalue+"&DAY="+day+"&HOUR="+hour+"&MIN="+min+"&ISSSL="+isSSL1;//No I18N
                var successUrl="Settings/UserManagement";//NO I18N 
                if(window.cur_path.indexOf("Discovery") > -1)
                {
                    params1=params1+"&CERTIMPORT=true";//No I18N
                    if(document.getElementById("userimp_type").checked)
                    {
                        params1=params1+"&USERIMPORT=true";//No I18N
                }
                else
                {
                        params1=params1+"&USERIMPORT=false";//No I18N
                    }
                }
                else
                {
                    params1=params1+"&USERIMPORT=true";//No I18N
                    if(document.getElementById("userimp_type").checked)
                    {
                        params1=params1+"&CERTIMPORT=true";//No I18N
                    }
                    else
                    {
                    params1=params1+"&CERTIMPORT=false";//No I18N
                }
            }
                
                getAjaxApiRequest(reqUrl,params1+"&pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
                    if(window.cur_path.indexOf("Discovery") > -1)
                    {
                        if(jsonData.licenseExceed==true)
                        {
                            successUrl="Discovery/ADUserCert";//NO I18N 
                        }
                        else if(jsonData.Status=="Success")
                        {
                            successUrl="SSLMgmt/SSL";//NO I18N 
                        }
                        else{
                            successUrl="Discovery/AD";//"Discovery/DetailedAuditDiscovery/"+jsonData.discoveryAuditId;//NO I18N 
                        }
                    }
                    if(jsonData.Status==="Success")//NO I18N
                    {
                        messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                        redirectUrl(successUrl);
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                        if(window.cur_path.indexOf("Discovery") > -1)
                        {
                            redirectUrl(successUrl);
                        }
                    }
                });
            }
        },
        
        importUsersFromAD:function()
        {
            var str = $( "form" ).serialize();

            var domainName = document.getElementById('DOMAINNAME');//No I18N
            var domainController = document.getElementById('DOMAINCONTROLLER');//No I18N
            var secDCName = document.getElementById('SECDOMAINCONTROLLER');//No I18N
            var userName = document.getElementById('LOGINNAME');//No I18N
            var password = document.getElementById('PASSWORD');//No I18N
                var elements = document.getElementsByName('selectedOUs');//No I18N
            var _no_Of_Groups = document.getElementById('_no_of_groups_').value;//No I18N
            if(domainName.value==="")//NO I18N
            {
                showAlert(I18N.getMsg('js.adAuth.enterDomainName'));//NO I18N
                return;
            }
            if(domainController.value==='' && secDCName.value==='')
            {
                showAlert(I18N.getMsg('js.adAuth.enterPrimaryOrSecondaryDomain'));//NO I18N
                return;
            }
            if(userName.value=="")//NO I18N
            {
                showAlert(I18N.getMsg('js.adAuth.enterUserName'));//NO I18N
                return;
            }
            if(password.value==="")//NO I18N
            {
                showAlert(I18N.getMsg('js.adAuth.enterPassword'));//NO I18N
                return;
            }
                var len = elements.length;
                var params = "";//No I18N
                var check = false;
                for( var i = 0; i < len; i ++ )
                {
                   if(elements[i].checked)
               {
                    check = true;
                    params = params + elements[i].value + ",";//No I18N
               }
            }
            var ugparams = "";//No I18N
            var ucheck = false;
            for ( var j = 0; j < _no_Of_Groups; j++ )
            {
                var ug = document.getElementById('checkbox_'+j);//No I18N
                if(ug.checked)
                {
                    ucheck = true;
                    ugparams = ugparams + "&_USERGROUPS="+ug.value;//No I18N
                }
            }
            var day = "";//document.getElementById("day_id").value;//No I18N
            var hour = "";//document.getElementById("hour_id").value;//No I18N
            var min = "";//document.getElementById("mins_id").value;//No I18N
                var conn_mode_ssl = document.getElementById("connection_mode_ssl");//No I18N
                var isSSL = "false";//No I18N
                if(conn_mode_ssl.checked)
                {
                        isSSL="true"//No I18N
                }
                var reqparams = "RequestType=IMPORTADUSERS&DOMAINNAME="+domainName.value+"&DCNAME="+domainController.value+"&LOGINNAME="+userName.value+"&PASSWORD="+encodeURIComponent(password.value)+"&selectedOUs="+params+"&SECDCNAME="+secDCName.value+ugparams+"&DAY="+day+"&HOUR="+hour+"&MIN="+min+"&ISSSL="+isSSL;//No I18N
            if(window.cur_path.indexOf("Discovery") > -1)
            {
                reqparams=reqparams+"&CERTIMPORT=true";//No I18N
                    if(document.getElementById("userimp_type").checked)
                    {
                        reqparams=reqparams+"&USERIMPORT=true";//No I18N
            }
            else
            {
                        reqparams=reqparams+"&USERIMPORT=false";//No I18N
                    }
                }
                else
                {
                    reqparams=reqparams+"&USERIMPORT=true";//No I18N
                    if(document.getElementById("userimp_type").checked)
                    {
                        reqparams=reqparams+"&CERTIMPORT=true";//No I18N
                    }
                    else
                    {
                reqparams=reqparams+"&CERTIMPORT=false";//No I18N
            }
                }

            var ugcheck = document.getElementById('ad_user_groups');//No I18N
            var ouints = document.getElementById('ounits');//No I18N
            if(ugcheck.checked && !ucheck)
            {
            showAlert(I18N.getMsg('js.adAuth.selectGroup'));//No I18N
                return false;
            }
            else if(!check && ounits.checked){
            showAlert(I18N.getMsg('js.adAuth.selectOrganizationalUnit'));//No I18N
                return false;
            }
            else
            {
                if(ugcheck.checked)
                {
                    reqparams = reqparams + "&ADIMPORTTYPE=USERGROUPS";//No I18N
                }
                if(ounits.checked)
                {
                    reqparams = reqparams + "&ADIMPORTTYPE=OUNITS";//No I18N
                }
                var reqUrl="/api/pki/settings/importUsers";//No I18N
                var successUrl="Settings/UserManagement";//NO I18N 
                var app = this.get("controllers.ADOUList");
                getAjaxApiRequest(reqUrl,reqparams+"&pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
                    if(window.cur_path.indexOf("Discovery") > -1)
                    {
                        if(jsonData.licenseExceed==true)
                        {
                            successUrl="Discovery/ADUserCert";//NO I18N 
                        }
                        else if(jsonData.Status=="Success")
                        {
                            successUrl="SSLMgmt/SSL";//NO I18N 
                        }
                        else{
                            successUrl="Discovery/AD";//"Discovery/DetailedAuditDiscovery/"+jsonData.discoveryAuditId;//NO I18N 
                        }
                        
                    }
                    if(jsonData.Status==="Success")//NO I18N
                    {
                        messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                        redirectUrl(successUrl); 
                        app.send('close');//NO I18N
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                        if(window.cur_path.indexOf("Discovery") > -1)
                        {
                            redirectUrl(successUrl); 
                        }
                        //app.send('close');//NO I18N
                    }
                });
            }
        },
        close: function() {
          if (window.cur_path.indexOf("Discovery") > -1)//No I18N
            {
                redirectUrl("Discovery/AD");//No I18N
            } else {
                redirectUrl("Settings/UserManagement");//No I18N
            }
        }
    }
});

App.SettingsPolicyController = Ember.ObjectController.extend({
    actions: 
    {
        updateKeyFilePolicyConfiguration:function(app)
        {
            var reqparams;
            var operType="append";//No I18N 
            if (document.getElementById('append').checked) {
                operType = document.getElementById('append').value;
            }
            else if (document.getElementById('overwrite').checked) {
                operType = document.getElementById('overwrite').value;
            }
            reqparams="operType="+operType+"&pmpcp="+Get_Cookie('pmpcc');//No I18N 
            var reqUrl="/api/pki/settings/updateKeyFilePolicyConfiguration";//No I18N
                    ajaxRequestWithCookie(reqUrl,reqparams,true,"",false,"");//NO I18N 
            if(app!=undefined)
            {
                app.send('closeModal');//No I18N
        }
    }
    }
});

App.NotificationPolicyController = Ember.ObjectController.extend({
    actions: 
    {
        updateNotificationConfig:function(app)
        {
            var hrs=$("#Hrs").val();
            var min=$("#Mins").val();
            var isSSL=document.getElementById("SSL_NOTIFY").checked;
            var isSSH=false;
            var isDomain=document.getElementById("DOMAIN_NOTIFY").checked;
            if(!App.ApplicationController.isStandardEdition){
                   isSSH=document.getElementById("SSH_NOTIFY").checked;
                }
                    var reqparams = "ISSSL=" + isSSL + "&ISSSH=" + isSSH + "&ISDOMAIN="+isDomain;//No I18N
                    if (isSSL == true)
                {
                        var ssl_days = $("#Exp_day_count").val();
                        reqparams = reqparams + "&CERT_EXP=" + ssl_days;//No I18N
                        if (!document.getElementById("Email").checked && !document.getElementById("SysLog").checked)
                        {
                            showAlert(I18N.getMsg('js.notificationPolicy.selectOneNotification')); //No I18N
                            return;
                }
                    }
                    if (isSSH == true)
                {
                        var ssh_days = $("#key_day_count").val();
                        reqparams = reqparams + "&KEY_EXP=" + ssh_days;   //No I18N                 
                }
                if(isDomain)
                {
                    var domain_days = $("#domain_day_count").val();
                    reqparams = reqparams + "&DOMAIN_DAYS=" + domain_days;   //No I18N  
                }
            if(document.getElementById("Email").checked)
            {
                var email=$("#toAddress").val();
                var from=$("#fromAddress").val();
                var mail=email.split(/,|;/);
                if(email.trim()=="")
                {
                    showAlert(I18N.getMsg('js.email.enteraValidEmailAddress')); //No I18N
                    return;
                }
                for(var i = 0;i < mail.length;i++) {
                    if(!validateEmail(mail[i])) {
                        showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
                        return;
                    }
                }
                if(kmpStandAlone){
                    if(from.trim()=="")
                {
                    showAlert(I18N.getMsg('js.email.enteraValidEmailAddress')); //No I18N
                    return;
                }
                 if(!validateEmail(from)) 
                {
                    showAlert(I18N.getMsg('js.email.enteraValidEmailAddress'));   //No I18N
                    return;
                }
                reqparams=reqparams+"&FROMADDRESS="+from;//NO I18N
                }
                var isEmptyNotifyCheckEnabled=document.getElementById("notify_emptyCertMail").checked;
                reqparams=reqparams+"&TOADDRESS="+mail+"&ISEMAIL="+true+"&isEmptyNotifyCheckEnabled="+isEmptyNotifyCheckEnabled;//No I18N 
                }
            else
            {
                reqparams=reqparams+"&ISEMAIL="+false;//No I18N 
            }
                    if (kmpStandAlone) {
                        var val = $("#syslogdiv").val();
                        if (document.getElementById("SysLog").checked && val === 'SyslogNotConfigured') {//No I18N
                            vConfirmation1(I18N.getMsg('pki.js.configuresyslog'),function(){//No I18N
                                redirectUrl('Settings/Syslog');//No I18N
                            },'Notification'); //No I18N
                    return;
                }
                }
            if(min>=60 || hrs>=24 || isNaN(hrs) ||isNaN(min) || min<0 || hrs<0 || min=="" ||hrs=="")
            {
                showAlert(I18N.getMsg('js.inputtime.enteraValidTime')); //No I18N
                return;
            }
            reqparams=reqparams+"&MINS="+min+"&HRS="+hrs+"&ISSYSLOG="+document.getElementById("SysLog").checked;//No I18N 
            var reqUrl="/api/pki/settings/updateNotificationConfig";//No I18N
                    ajaxRequestWithCookie(reqUrl,reqparams,true,"",false,"");//NO I18N            
            if(app!=undefined)
            {
                app.send('closeModal');//No I18N
        }

    }
    }
});
App.NotificationAuditController = Ember.ObjectController.extend({
    needs:['application','AuditNotify'],//No I18N
    actions:
            {
                saveAuditNotify: function ()
                {
                    var app = this.get('controllers.AuditNotify');
                    app.send('saveAuditNotify');//No I18N
                },
                close: function () {
                    return this.send("closeModal");//No I18N
                }
            }
});
App.SettingsClientConfigController = Ember.ObjectController.extend({
    actions:
    {
        updateDashboardConfig:function()
        {
            var ajaxRequestUrl = '/api/pki/settings/updateDashboardType'; //No I18N
            var data="dashboardType=";//No I18N
            if(document.getElementById("both").checked)
            {
                data+="full";//No I18N
            }
            else if(document.getElementById("ssh").checked)
            {
                data+="ssh";//No I18N
            }
            else
            {
                data+="ssl";//No I18N
            }
                    ajaxRequestWithCookie(ajaxRequestUrl,data+"&pmpcp="+Get_Cookie('pmpcc'),false,"",true,function(jsonData){//NO I18N
               if(jsonData.Status==="Success")//No I18N
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    location.reload();
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });        
        }
    }
})
App.ApiKeyGenerationController = Ember.ObjectController.extend({
    actions:
    {
        generateAPIKey:function()
        {
            var ajaxRequestUrl = '/api/pki/settings/generateAPIKey'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,"pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//No I18N
                $("#apiKeyGenerate").text(I18N.getMsg('js.api.key.regenerate'));//No I18N
                 $("#nokeyDiv").css("display","none");
                 $("#keyDiv").css("display","block");
                 $("#apikeyval").text(jsonData.apiKey);
                    
            });        
        }
    }
});

App.SettingsBackupDBController = Ember.ObjectController.extend({
    actions: 
    {
        backupSchedule:function()
        {
            var data={};
            data.scheduleType=$("input[name='scheduleType']:checked").val();
            if(data.scheduleType==="daily")
            {
                data.daySchedule=$('#daySchedule').val();
            }
            else if(data.scheduleType==="weekly")
            {
                data.weeklySchedule=$('#weeklySchedule').val();
            }
            else if(data.scheduleType==="monthly")
            {
                data.monthlySchedule=$('#monthlySchedule').val();
            }
            data.timerHours= $('#timerHours').val();
            data.timerMinutes = $('#timerMinutes').val();
            var maintainBackup=$('#backUpDur').val();
            if(maintainBackup==="false")
            {
                data.maintainBckUps=false;
            }
            else
            {
                data.maintainBckUps=true;
                data.backUpDur=$('#backUpDur').val();
            }
            data.backupPath=$("#backupPath_ID").val();
            data.emailRecipients=$("#emailRecipients").val();
            data.pmpcp=Get_Cookie('pmpcc');//No I18N
            var ajaxRequestUrl = '/api/pki/schedule/backupSchedule'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
               if(jsonData.Status==="Success")//No I18N
            {
                messageNotification("messageNotifySuccess",I18N.getMsg("js.backup.update.success"));//No I18N
            }
            else
            {
                messageNotification("messageNotifyFailure",I18N.getMsg("js.backup.update.failed"));//No I18N
            }
            });
        }
    }
});

App.KeysGroupKeysController = Ember.ObjectController.extend({
    needs:'SSHMgmtKeys',//NO I18N
    actions: {
        showDialog:function()
        {
            this.get('controllers.SSHMgmtKeys').send('showDialog');//No I18N
        },                        
        disassociatekey: function(){
            this.get('controllers.SSHMgmtKeys').send('disassociatekey');//No I18N
        },
        deleteKey: function(){
            this.get('controllers.SSHMgmtKeys').send('deleteKey');//No I18N
        },
        KeyRotation: function(){
            this.get('controllers.SSHMgmtKeys').send('KeyRotation');//No I18N
        },
        creategroup:function(){
            this.get('controllers.SSHMgmtKeys').send('creategroup');//No I18N
        },
        placeKey:function() {
            this.get('controllers.SSHMgmtKeys').send('placeKey');//NO I18N
        }
    }
});

App.SSHMgmtKeysController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        showDialog:function()
        {
            var grid = $("#PKISSHKeys"); //No I18N
            App.SettingsCommonController.associatefrom="SSHMgmtKeys";//No I18N
            keyAssociationProcess(grid,this);
        },                        
        disassociatekey: function(){
            var grid = $("#PKISSHKeys"); //No I18N
            App.SettingsCommonController.disassociatefrom="SSHMgmtKeys";//No I18N
            keyDisassociationProcess(grid,this);
        },
        deleteKey: function(){
            var grid = $("#PKISSHKeys"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_ids="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKey')); //No I18N
                return;
            }
//            $.each(selRowIds, function()
//            {
//                var id = this;
//                var key_id = grid.jqGrid('getCell', id, 'KeyID'); //No I18N 
//                var key_name=grid.jqGrid('getCell',id,'KeyName');//NO I18N
//                var reqUrl="/api/pki/ssh/getResourceUsersWithKey";//No I18N
//                var reqParams="KeyId="+key_id; //No I18N 
//                getAjaxApiRequest(reqUrl,reqParams,function(jsonData){
//                    if(jsonData.data.length!==0)
//                    {
//                        showAlert("Key "+key_name+" is associated with some users, please disassociate users before deleting key.");//NO I18N
//                        return;
//                    }
//                    
//                });
//            });
            App.InventoryController.deleteWithoutDisassociationoption=true;
            vConfirmation(I18N.getMsg('js.deletesshkeys.deleteTheSlelectedKeys'),function(){//NO I18N
            $.each(selRowIds, function()
            {
                var id = this;
                var key_id = grid.jqGrid('getCell', id, 'KeyID'); //No I18N
                if(key_ids!=="")
                {
                    key_ids=key_ids+","+key_id;
                }
                else
                {
                    key_ids=key_id;
                }
            });
            var data = {

            };
            data.isdeleteWithoutDisassociation=document.getElementById("deleteWithoutDisassociation").checked;
            data.KEYIDS = key_ids;
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            var ajaxRequestUrl = '/api/pki/ssh/deleteKeys'; //No I18N

            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
            if(jsonData.Status==="Success")//No I18N
            {
                messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                {{App.Settings.listsshkeys();}}
                $('#PKISSHKeys').trigger('reloadGrid'); //No I18N
            }
            else
            {
                messageNotification("messageNotifyFailure","Delete Keys Failed");//No I18N
            }
        });        
        });        
        },
        KeyRotation: function(){
            var grid = jQuery("#PKISSHKeys"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_ids="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKey')); //No I18N
                return;
            }
            if( selRowIds.length >=50) {
                showAlert(I18N.getMsg('js.sshkeyRotation.CanRotateOnlyUpto50KeysataTime')); //No I18N
                return;
            }
            App.SettingsCommonController.grid=grid;
            App.SettingsCommonController.from="keyrotation";//NO I18N
            var app = this.get("controllers.application");
            app.send('opendialog','RotateKeyWithFile');//NO I18N
        },
        creategroup:function(){
            var grid = $("#PKISSHKeys"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKey')); //No I18N
                return;
        }
            var app=this.get('controllers.application');
            App.SettingsCommonController.uGroup=false;
            App.SettingsCommonController.cGroup=false;
            app.send('opendialog','CreateGroup');//NO I18N
        },
        placeKey:function(){
            var app=this.get('controllers.application');
            app.send('opendialog','PlaceKeyFile');//NO I18N
    }
    }
});


App.PlaceKeyFileController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        copy: function() {
            var privateKeyFileName = document.getElementById("privFileName").value;
            var publicKeyFileName = document.getElementById("pubFileName").value;
            var key_id = App.SettingsCommonController.key_id;
            var reqParams = "";
            var push = true;
            if(document.getElementById("privcheckbox").checked)
            {
                if(privateKeyFileName =="")
                {
                    showAlert(I18N.getMsg("js.private.validfilename"));//NO I18N
                    return;
                }
                reqParams="&privateKeyFileName="+privateKeyFileName;//NO I18N
                push=false;
            }
            
            if(document.getElementById("pubcheckbox").checked)
            {
                if(publicKeyFileName == "")
                {
                    showAlert(I18N.getMsg("js.public.validfilename"));//NO I18N
                    return;
                }
                if(document.getElementById("privcheckbox").checked && publicKeyFileName==privateKeyFileName)
                {
                    showAlert(I18N.getMsg("js.privatepublic.filenamesame"));//NO I18N
                    return;
                }
                reqParams+="&publicKeyFileName="+publicKeyFileName;//NO I18N
                push=false;
            }
            if(push)
            {
                showAlert(I18N.getMsg("js.general.selectonefile"));//NO I18N
                return;
            }
            var userids = [];
            $.each($("input[name='users']:checked"), function() {
                var data = {};
                var userid = $(this).val();
                userids.push(userid);
            });
            
            
            if(userids == "")
            {
                showAlert(I18N.getMsg("js.userselection.selectAtleastOneUser"));//NO I18N
                return;
            }
            reqParams+="&userids="+userids+"&key_id="+key_id;//NO I18N
            var ajaxRequestUrl='/api/pki/ssh/placeKeyFileAtUser'; //No I18N
            ajaxRequestWithCookie(ajaxRequestUrl,reqParams,true,"",false,"");//NO I18N
            this.send('closeModal');//NO I18N
        }
    }
});

App.RotateKeyWithFileController = Ember.ObjectController.extend({
    needs : 'application',//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        rotate: function() {
            var grid = App.SettingsCommonController.grid;            
            var data={};
            data.pushkeyfile=0;
            data.defaultfilename=true;
            if(document.getElementById("showoptions").checked)
            {
                if(document.getElementById("privatekeyfile").checked && document.getElementById("publickeyfile").checked)
                {
                    data.pushkeyfile=3;
                }
                else if(document.getElementById("privatekeyfile").checked)
                {
                    data.pushkeyfile=1;
                }
                else if(document.getElementById("publickeyfile").checked)
                {
                    data.pushkeyfile=2;
                }

                if(document.getElementById("filename").checked)
                {
                    data.defaultfilename=false;
                }
                else
                {
                    data.defaultfilename=true;
                }
            }
            this.send('closeModal');//NO I18N
            var from = App.SettingsCommonController.from;
            keyRotationProcess(grid,data,from);
        }
    }    
});

App.SSHMgmtCreateSSHKeyController = Ember.ObjectController.extend({
    actions: {
        cancelOperation:function()
        {
            redirectUrl("SSHMgmt/Keys");//NO I18N
        },
        createKey: function(){
            var KEY_NAME=$("#keyName").val();//NO I18N
            var KEY_PASS=$("#passPhrase").val();//NO I18N
            var COMMENT=$("#comment").val();//NO I18N
            var LENGTH=$("#length").val();
            if(KEY_NAME=='')
            {
                showAlert(I18N.getMsg('js.sshkey.enterkeyname'));//No I18N
                return;
            }
            var reqUrl="/api/pki/ssh/createSSHKey";//No I18N
            var reqparams=$( "#createKeyForm" ).serialize();//NO I18N
            ajaxRequestWithCookie(reqUrl,reqparams,true,"SSHMgmt/Keys",false,"");//NO I18N
        }
    }
});

App.AddCommandController = Ember.ObjectController.extend({
    needs : 'application',//NO I18N
   actions:{
       close: function() {
            return this.send('closeModal');//NO I18N
        },
        push: function(){
        var editcommand = document.getElementById("editcommand").value;
        var userid = App.SettingsCommonController.user_id;
//        if(editcommand == "false")
//        {
//            showAlert(I18N.getMsg("js.pushcommand.nootherkey"));//NO I18N
//            return;
//        }
        var keyids = [];
        var jobj = [];
        $("#keys :input").each(function(){
            var data = {};
            var keyid = $(this).attr('id');
            var command = this.value;
            
                data[keyid]=command;
                jobj.push(data);
                keyids.push(keyid);
            
        });
        var jsonstring = JSON.stringify(jobj);
        var reqUrl = '/api/pki/ssh/getAuthFile'; //No I18N
        var reqParams = "userid="+userid+"&keyids="+keyids+"&commands="+jsonstring;//NO I18N
        $("#addcommand .modal-dialog").css('display','none');
        getAjaxApiRequest(reqUrl,reqParams, function(jsonData){         
            if(jsonData.Status==="Success")
            {
                var $confirm = $("#authfile");//NO I18N
                $confirm.modal('show');//NO I18N
                $("#title").text(I18N.getMsg("js.authorizedkeys.file"));//NO I18N
                $("#contentDiv").text(jsonData.filecontent);
                $("#authfile").click(function(e){
                   if(e.target.id=="authfile")
                   {
                       document.getElementById("close_paushcommand").click();
                   }
                });
            }
            else
            {
                document.getElementById("close_paushcommand").click();
                messageNotification("messageNotifyFailure",jsonData.filecontent);//No I18N
            }
        });
        
       
     },
     cancel: function(){
         var $confirm = $("#authfile");
         $confirm.modal('hide');//NO I18N
     },
     confirm: function(){
        var keyids = [];
        var userid = App.SettingsCommonController.user_id;
        var jobj = [];
        $("#keys :input").each(function(){
            var data = {};
            var keyid = $(this).attr('id');
            var command = this.value;
            
                data[keyid]=command;
                jobj.push(data);
                keyids.push(keyid);
            
        });
        var jsonstring = JSON.stringify(jobj);
        var reqUrl = '/api/pki/ssh/pushAuthFile'; //No I18N
        var contentData = {

                };
        var object = {

        };
        object.FILE_CONTENT = $("#contentDiv").text();
        contentData.FILECONTENT = JSON.stringify(object);
        contentData.userid=userid;
        contentData.keyids=keyids.toString();
        contentData.commands=jsonstring;
        contentData.pmpcp=Get_Cookie('pmpcc');//NO I18N
        ajaxapicall(reqUrl,contentData,true,"");//NO I18N
        this.send('closeModal');//NO I18N
     }
   } 
});

App.CiphersController = Ember.ObjectController.extend({
    needs : 'application',//NO I18N
   actions:{
       close:function(){
           return this.send('closeModal');//NO I18N
       },
       save:function(){
            var reqUrl = '/api/pki/settings/updateCiphers'; //No I18N
            var contentData = {

                    };
            var object = {

            };
            var modal = this;
            var app=this.get('controllers.application');
            object.FILE_CONTENT = $("#contentDiv").text();
            contentData.FILECONTENT = JSON.stringify(object);
            getAjaxApiRequest(reqUrl,contentData,function(jsonData){
                modal.send('closeModal');//NO I18N
                if(jsonData.Status === "Success")
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N                           
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                }  
                if(!kmpStandAlone){
                app.send('opendialog','KMPVulnerabilitiesSettings');//NO I18N
            }
            });
       }
   }
   });
App.ShowCertificatesController = Ember.ObjectController.extend({
    actions:{
        close:function(){
        return this.send('closeModal');//NO I18N
        }    
    }
});

App.EditAuthFileController = Ember.ObjectController.extend({
   actions:{
       close:function(){
           return this.send('closeModal');//NO I18N
       },
       save:function(){
        var reqUrl = '/api/pki/ssh/pushEditAuthFile'; //No I18N
        var contentData = {

                };
        var object = {

        };
        var modal = this;
        object.FILE_CONTENT = document.getElementById("contentDiv").innerText;
        contentData.FILECONTENT = JSON.stringify(object);
        contentData.userid=App.SettingsCommonController.user_id;
        contentData.pmpcp=Get_Cookie('pmpcc');//NO I18N
        getAjaxApiRequest(reqUrl,contentData,function(jsonData){
            if(jsonData.confirm!==undefined)
            {
                vConfirmation(I18N.getMsg('js.user.dissasociate.confirm',new Array(jsonData.confirm)),function(){//NO I18N
                    reqUrl = '/api/pki/ssh/confirmPushEditAuthFile'; //No I18N
                    contentData.disKeyIds=jsonData.keyids;
                    getAjaxApiRequest(reqUrl,contentData,function(jsonData){
                        modal.send('closeModal');//NO I18N
                        if(jsonData.Status === "Success")
                        {
                            messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N       
                            {{App.Settings.getAllResourceUsers();}}
                            $('#PKIAllResourceUsers').trigger('reloadGrid'); //No I18N
                        }
                        else
                        {
                            messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                        }    
                    });                    
                });
            }
            else
            {
                modal.send('closeModal');//NO I18N
                if(jsonData.Status === "Success")
                {
                   messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N                              
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                }                
            }
        });   
        
       }       
   } 
});

App.AuthFileController = Ember.ObjectController.extend({
   needs: 'application',//NO I18N 
   actions:{
       close: function() {
            return this.send('closeModal');//NO I18N
        }
    }
});

App.UsersGroupUsersController = Ember.ObjectController.extend({
    needs : 'application',//NO I18N
   actions:{
       close: function() {
            return this.send('closeModal');//NO I18N
        },
        push: function(){
        var editcommand = document.getElementById("editcommand").value;
        var userid = App.SettingsCommonController.user_id;
        if(editcommand == "false")
        {
            showAlert(I18N.getMsg("js.pushcommand.nootherkey"));//NO I18N
            return;
        }
        var keyids = [];
        var jobj = [];
        $("#keys :input").each(function(){
            var data = {};
            var keyid = $(this).attr('id');
            var command = this.value;
            
                data[keyid]=command;
                jobj.push(data);
                keyids.push(keyid);
            
        });
        var jsonstring = JSON.stringify(jobj);
        var reqUrl = '/api/pki/ssh/getAuthFile'; //No I18N
        var reqParams = "userid="+userid+"&keyids="+keyids+"&commands="+jsonstring;//NO I18N
        $("#addcommand .modal-dialog").css('display','none');
        getAjaxApiRequest(reqUrl,reqParams, function(jsonData){         
            if(jsonData.filecontent!=undefined)
            {
                var $confirm = $("#authfile");//NO I18N
                $confirm.modal('show');//NO I18N
                $("#title").text(I18N.getMsg("js.authorizedkeys.file"));//NO I18N
                $("#contentDiv").text(jsonData.filecontent);
                $("#authfile").click(function(e){
                   if(e.target.id=="authfile")
                   {
                       document.getElementById("close_pushcommand").click();
                   }
                });
            }
        });
        
       
     },
     cancel: function(){
         var $confirm = $("#authfile");
         $confirm.modal('hide');//NO I18N
     },
     confirm: function(){
        var keyids = [];
        var userid = App.SettingsCommonController.user_id;
        var jobj = [];
        $("#keys :input").each(function(){
            var data = {};
            var keyid = $(this).attr('id');
            var command = this.value;
            
                data[keyid]=command;
                jobj.push(data);
                keyids.push(keyid);
            
        });
        var jsonstring = JSON.stringify(jobj);
        var reqUrl = '/api/pki/ssh/pushAuthFile'; //No I18N
        var contentData = {

                };
        var object = {

        };
        object.FILE_CONTENT = $("#contentDiv").text();
        contentData.FILECONTENT = JSON.stringify(object);
        contentData.userid=userid;
        contentData.keyids=keyids.toString();
        contentData.commands=jsonstring;
        contentData.pmpcp=Get_Cookie('pmpcc');//NO I18N
        ajaxapicall(reqUrl,contentData,true,"");//NO I18N
        this.send('closeModal');//NO I18N
     }
   } 
});

App.AuthFileController = Ember.ObjectController.extend({
   needs: 'application',//NO I18N 
   actions:{
       close: function() {
            return this.send('closeModal');//NO I18N
        }
    }
});

App.UsersGroupUsersController = Ember.ObjectController.extend({
    needs : 'AllResourceUsers',//NO I18N
    actions: {
        credentialDialogCall: function(){
            this.get('controllers.AllResourceUsers').send('credentialDialogCall');//No I18N
        },
        disassociate:function()
        {
            this.get('controllers.AllResourceUsers').send('disassociate');//No I18N
        },
        deleteResourceUser:function()
        {
            this.get('controllers.AllResourceUsers').send('deleteResourceUser');//No I18N
        },
        createAndDeployKey:function ()
        {
            this.get('controllers.AllResourceUsers').send('createAndDeployKey');//No I18N
        },
        exportCred:function(){
            this.get('controllers.AllResourceUsers').send('exportCred');//No I18N
        },
        creategroup:function(){
            this.get('controllers.AllResourceUsers').send('creategroup');//No I18N
        }
        
    }
});

App.TransferFileController = Ember.ObjectController.extend({
needs:'application',//NO I18N
actions:{
    close:function(){
        return this.send('closeModal');//NO I18N
    },
    submit: function(){
            var fileData = new FormData();
            var browse="";
            var textfield="";
            if ($('#filename').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
            }  
            var path = $('#Path').val();
            if(!$.trim(path).length>0)
            {
                showAlert(I18N.getMsg("js.editpath.validpath"));//NO I18N 
                return;
            }
            var fileinput = document.getElementById("uploadFile");
            var file = fileinput.files[0];
            fileData.append("File",file);//NO I18N
            browse=$('#uploadFile');
            textfield=document.getElementById("filename");
            if (!textfield.value.match(/^[0-9a-zA-Z\.]*$/)) 
            {
                showAlert(I18N.getMsg("filetransfer.special.character"));//NO I18N
                return;
            }
            var ajaxRequestUrl = '/api/pki/settings/transferFile?Path='+path+'&userid='+App.SettingsCommonController.user_id+'&fileName='+textfield.value; //No I18N
                fileData.append("pmpcp",Get_Cookie('pmpcc'));//No I18N
                getAjaxApiRequestForFile(ajaxRequestUrl,fileData,browse,textfield,true,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        location.href="#/SSHMgmt/AllUsers";
                    }
                });
                        
                this.send('closeModal');//NO I18N 
    }    
}
});

App.EditUserPathController = Ember.ObjectController.extend({
    needs : 'application',//NO I18N
    actions:{
        close: function() {
            App.SettingsCommonController.rGroup=false;
            App.SettingsCommonController.uGroup=false;
            App.SettingsCommonController.cGroup=false;
            return this.send('closeModal');//NO I18N
        },
        submit: function() {
            var path = $('#Path').val();
            if($.trim(path).length>0)
            {
                if(App.SettingsCommonController.uGroup)
                {
                    var ajaxRequestUrl = '/api/pki/Inventory/setUserPathForUserGroup'; //No I18N
                    var reqParams="path="+path+"&groupName="+App.SettingsCommonController.uGroupName+"&groupid="+App.SettingsCommonController.user_id;//NO i18N
                    ajaxRequestWithCookie(ajaxRequestUrl,reqParams,false,"",true,function(jsonData){
                        if(jsonData.Status === "Success")
                        {
                           messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N                              
                        }
                        else
                        {
                            messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                        }                    
                    });
                }
                else if(App.SettingsCommonController.rGroup)
                {
                    var ajaxRequestUrl = '/api/pki/Inventory/setUserPathForResourceGroup'; //No I18N
                    var reqParams="path="+path+"&groupName="+App.InventoryController.rGroupName+"&groupid="+App.InventoryController.res_Id;//NO i18N
                    ajaxRequestWithCookie(ajaxRequestUrl,reqParams,false,"",true,function(jsonData){
                        if(jsonData.Status === "Success")
                        {
                           messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N                              
                        }
                        else
                        {
                            messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                        }                    
                    });
                }
                else
                {
                    var reqParams="path="+path+"&userid="+App.SettingsCommonController.user_id;//NO i18N
                    var ajaxRequestUrl = '/api/pki/Inventory/setUserPath'; //No I18N
                    ajaxRequestWithCookie(ajaxRequestUrl,reqParams,false,"",true,function(jsonData){
                        if(jsonData.Status === "Success")
                        {
                           messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//NO I18N 
                           if(App.SettingsCommonController.userGroupUsersView===true)
                           {
                               App.Settings.listusersgroupusers();
                           }
                           else
                           {
                           App.Settings.getAllResourceUsers();   
                            }
                        }
                        else
                        {
                            messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N 
                        }                    
                    });
                }             
                
            }
            else
            {
                showAlert(I18N.getMsg("js.editpath.validpath"));//NO I18N 
                return;
            }
            this.send('closeModal');//NO I18N 
        }
        
    }
});

App.AllResourceUsersController = Ember.ObjectController.extend({
    needs : 'application',//NO I18N
    actions: {
        credentialDialogCall: function(){
            var grid = $("#PKIAllResourceUsers"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var user_ids="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }
           var app=this.get('controllers.application');
           App.SettingsCommonController.isSingleCredential=false;
           app.send('opendialog','ResourceUserCredential');//NO I18N
        },
        disassociate:function()
        {
            var user_id = App.SettingsCommonController.user_id;
            var reqparams="USERID="+user_id;//NO I18N  
            var app=this.get('controllers.application'); 
            App.SettingsCommonController.isFromCredential=false;
            var reqUrl="/api/pki/ssh/getAssociatedUserKeys";//No I18N
            getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
                if(jsonData.data.length===0)
                {
                    showAlert(I18N.getMsg('js.sshkeyDisassociation.NoKeysAssociated'));//NO I18N
                    return;
                }else if(jsonData.data.length===1)
                {
                    vConfirmation(I18N.getMsg('js.vconfirmation.dissociation.DoYoureallywanttodisassociatethekey',new Array(jsonData.data.get(0).text)),function(){//NO I18N
                        UserToKeyDisassociation(user_id,jsonData.data.get(0).id);
                    });
                    return;
                }
                else
                {
                   
                   app.send('opendialog','DissociateUserToKeyView');//NO I18N
                }
            });
            
        },
        deleteResourceUser:function()
        {
            var grid = $("#PKIAllResourceUsers"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var user_ids="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
        }
            App.InventoryController.deleteWithoutDisassociationoption=true;
            var val=vConfirmation(I18N.getMsg('js.deleteUser.deleteSelectedUser'),function(){//NO I18N
            $.each(selRowIds, function()
            {
                var id = this;
                var user_id = grid.jqGrid('getCell', id, 'UserID'); //No I18N
                if(user_ids!=="")
                {
                    user_ids=user_ids+","+user_id;
                }
                else
                {
                    user_ids=user_id;
                }
});
            var reqparams="USERIDS="+user_ids;//NO I18N
            reqparams+="&isdeleteWithoutDisassociation="+document.getElementById("deleteWithoutDisassociation").checked;//NO I18N
            var reqUrl="/api/pki/ssh/deleteResourceUser";//No I18N
                ajaxRequestWithCookie(reqUrl,reqparams,false,"",true,function(jsonData){
                if(jsonData.Status==="Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//NO I18N
        }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//NO I18N
    }
                App.Settings.getAllResourceUsers();
});
            });
        },
        createAndDeployKey:function ()
        {
            var grid = $("#PKIAllResourceUsers"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var user_ids="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
            }
            var msg="";
            $.each(selRowIds, function()
            {
                var id = this;
                var user_id = grid.jqGrid('getCell', id, 'UserID'); //No I18N
                var isCred = grid.jqGrid('getCell', id, 'isCredAvailable'); //No I18N
                if(isCred==="true")
                {
                    if(user_ids!=="")
                    {
                        user_ids=user_ids+","+user_id;
                    }
                    else
                    {
                        user_ids=user_id;
                    }
                }
                else
                {
                    if(kmpStandAlone)
                    {
                    var userName=grid.jqGrid('getCell', id, 'UserName'); //No I18N
                    var resName=grid.jqGrid('getCell', id, 'ResourceName'); //No I18N
                    msg="Give Credential For a user " + userName +" from " + resName; //No I18N
                    return;
                }
                }
            });
            if(msg!=="")
            {
                showAlert(msg); //No I18N
            }
            else
            {
                var app=this.get('controllers.application');
                app.send('opendialog','createAndDeploy');//NO I18N
            }
        },
        exportCred:function(){
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var grid = jQuery("#PKIAllResourceUsers"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var user_ids="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
        }
            $.each(selRowIds, function()
            {
                var id = this;
                var user_id=grid.jqGrid('getCell', id, 'UserID'); //No I18N
                if(user_ids!=="")
                    {
                        user_ids=user_ids+","+user_id;
    }
                    else
                    {
                        user_ids=user_id;
                    }
            });
            var reqParams=user_ids;
            locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportTextFile&ReportType=usercredential&fileContent="+reqParams);//NO I18N
    },
    creategroup:function(){
        var grid = $("#PKIAllResourceUsers"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                return;
    }
            var app=this.get('controllers.application');
            App.SettingsCommonController.uGroup=true;
            app.send('opendialog','CreateGroup');//NO I18N
        }
    }
});


App.CreateGroupController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        creategroup:function(){
            var app=this.get('controllers.application');
            var reqUrl;
            var reqParams;
            var groupname;
            var description=document.getElementById("description").value;//NO I18N
            if(App.SettingsCommonController.uGroup)
            {
                var grid = $("#PKIAllResourceUsers"); //No I18N
                var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                if(selRowIds == undefined || selRowIds.length == 0) {
                    showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                    return;
                }
                var groupname = document.getElementById("groupname").value;
                if(groupname === '')
                {
                    showAlert(I18N.getMsg("js.usersGroup.entervalidgroupname"));//NO I18N                    
                    return;
                }
                var user_ids="";
                $.each(selRowIds, function()
                {
                    var id = this;
                    var user_id = grid.jqGrid('getCell', id, 'UserID'); //No I18N
                    if(user_ids!=="")
                    {
                        user_ids=user_ids+","+user_id;
                    }
                    else
                    {
                        user_ids=user_id;
                    }
                });
                reqParams="groupname="+groupname+"&userids="+user_ids+"&description="+description;//NO I18N
                reqUrl="/api/pki/ssh/createUserGroupBySelectedUsers";//No I18N                
            }
            else if(App.SettingsCommonController.cGroup)
            {
                var grid = jQuery("#PKIInventoryList"); //No I18N
                var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                if(selRowIds == undefined || selRowIds.length == 0) {
                    showAlert(I18N.getMsg('js.resource.selectAtleastOneCertificate')); //No I18N
                    return;
                }
                var groupname = document.getElementById("groupname").value;
                if(groupname === '')
                {
                    showAlert(I18N.getMsg("js.commonstr.giveKeysGroupName"));//NO I18N
                    return;
                }
                var key_ids="";
                $.each(selRowIds, function()
                {
                    var id = this;
                    var key_id = grid.jqGrid('getCell', id, 'ResourceID'); //No I18N
                    if(key_ids!=="")
                    {
                        key_ids=key_ids+","+key_id;
                    }
            else
            {
                        key_ids=key_id;
                    }
                });
                reqParams="groupname="+groupname+"&sslids="+key_ids+"&description="+description;//NO I18N
                reqUrl="/api/pki/Inventory/createCertsGroupBySelectedCerts";//No I18N        
            }
            else
            {
                var grid = $("#PKISSHKeys"); //No I18N
                var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                if(selRowIds == undefined || selRowIds.length == 0) {
                    showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKey')); //No I18N
                    return;
                }
                var groupname = document.getElementById("groupname").value;
                if(groupname === '')
                {
                    showAlert(I18N.getMsg("js.commonstr.giveKeysGroupName"));//NO I18N
                    return;
                }
                var key_ids="";
                $.each(selRowIds, function()
                {
                    var id = this;
                    var key_id = grid.jqGrid('getCell', id, 'KeyID'); //No I18N
                    if(key_ids!=="")
                    {
                        key_ids=key_ids+","+key_id;
                    }
                    else
                    {
                        key_ids=key_id;
                    }
                });
                reqParams="groupname="+groupname+"&keyids="+key_ids+"&description="+description;//NO I18N
                reqUrl="/api/pki/ssh/createKeyGroupBySelectedKeys";//No I18N            
            }
            
             ajaxRequestWithCookie(reqUrl,reqParams,false,"",true,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                        app.send("closeModal");//No I18N
                    }
                    else if(jsonData.Message === "js.usersGroup.alreadyexists" || jsonData.Message === "pki.keyGroup.alreadyexist" || jsonData.Message === "pki.certGroup.alreadyexist")
                    {
                        showAlert(I18N.getMsg(jsonData.Message));
                    }
                    else
                    {
                        messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//NO I18N
                        app.send("closeModal");//No I18N
                    }
                 
             });
        }
    }
    
});

App.AllUsersKeysController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        exportPdf:function()
        {
            if(App.ApplicationController.demo)
            {
                showAlert("Operation disabled for demo");//NO I18N
                return;
            }
            var resourcename=document.getElementById("gs_Resource Name").value;
            var username=document.getElementById("gs_User Name").value;
            var discoveredkey=document.getElementById("gs_Discovered Keys").value;
            App.ReportController.scheduleType="DiscoveredKeys";//No I18N
            var reqParams="&resourcename="+resourcename+"&username="+username+"&discoveredkey="+discoveredkey;//No I18N
            var count=$("#AllUsersKeys").getGridParam("reccount");
            if(count==0)
            {
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.export.noDataAvailableToExport"));//No I18N
                return;
            }
            else
            {
                locReplaceURL("/apiclient/ajaxResponse.jsp?RequestType=exportPdf&ReportType=DiscoveredKeys"+reqParams);//NO I18N
            }
            
        },
        dataCheck:function()
        {
            App.ReportController.scheduleType="DiscoveredKeys";//No I18N
            var app=this.get('controllers.application');
            var count=$("#AllUsersKeys").getGridParam("reccount");
            if(count==0)
            {
                messageNotification("messageNotifyFailure",I18N.getMsg("js.report.datacheck.noDataAvailable"));//No I18N
                return;
            }
            else
            {
                app.send('opendialog','EmailNotify');//NO I18N
            }
        
        },
      importUsersKeys:function()
        {
            var grid = $("#AllUsersKeys"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKey')); //No I18N
                return;
            }
            var arr = new Array();
            var resArr=new Array();
            var isCredentialAvail=true;
            $.each(selRowIds, function()
            {
                var id = this;
                var user_id = grid.jqGrid('getCell', id, 'UserID'); //No I18N
                var res_id = grid.jqGrid('getCell', id, 'ResID'); //No I18N
                var user_name = grid.jqGrid('getCell', id, 'User Name'); //No I18N
                var resource_name = grid.jqGrid('getCell', id, 'Resource Name'); //No I18N
                var credential = grid.jqGrid('getCell', id,'isCredAvailable'); //No I18N
//                if(credential === "true")
//                {
                            arr.push(user_id);
                            resArr.push(res_id);
//                }
//                else
//                {
//                    showAlert(I18N.getMsg('js.importuserskeys.entercredentialToGetKey',new Array(user_name,resource_name)));//No I18N
//                    isCredentialAvail=false;
//                }
            });
//            if(!isCredentialAvail)
//                { return;}
            var data = {

            };
             var newarr = [];
    for(var i = 0; i < resArr.length; i++) {
        if(!newarr.contains(resArr[i])) {
            newarr.push(resArr[i]);
        }
    }
            data.USERIDS = JSON.stringify(arr);
            data.RES_IDS = JSON.stringify(newarr);
            data.pmpcp=Get_Cookie('pmpcc');//No I18N
            var ajaxRequestUrl = '/api/pki/ssh/createUserSSHKeys'; //No I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            });
        }
    }
});

App.AddKeysController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        addSSHKey:function(){
            var browse="";
            var textfield="";
            var FILE_CONTENT=""; 
            var fileData = new FormData();
            var param='?userName=userName';//NO I18N
                var file = document.getElementById("uploadKeyFile").files[0];
                fileData.append("File", file);//NO I18N
                browse=$('#uploadKeyFile');
                textfield=document.getElementById("textfile");
                fileData.append("pmpcp",Get_Cookie('pmpcc'));//No I18N
                var keyName=document.getElementById("keyName").value;
                if(keyName=='')
                    {
                        showAlert(I18N.getMsg('js.sshkey.enterkeyname'));//NO I18N
                        return;
                    }
                    if ($('#textfile').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                var close=this;
                param=param+'&textfield='+textfield.value+'&PASSPHRASE='+encodeURIComponent(document.getElementById("passPhrase").value)+'&keyName='+keyName;//NO I18N
                var ajaxRequestUrl = '/api/pki/ssh/addKeys'+param; //No I18N
                getAjaxApiRequestForFile(ajaxRequestUrl, fileData, browse, textfield, true, function (jsonData) {
                if (jsonData.Status.toLowerCase() === "success")
                    {
                       App.Settings.listsshkeys();
                        //document.getElementById("keyName").value="";
                        //document.getElementById("passPhrase").value="";
                        close.send('closeModal');//NO I18N  
                       }
                });
              
        }
    }
});

App.AddKeysGroupController = Ember.ObjectController.extend({
    needs : 'application',//NO I18N
    actions: {
            cancelOperation:function() {
                redirectUrl("SSHMgmt/keysGroup"); //No I18N
            },
            saveKeysGroup: function() {
                var data = {

		};
                var exit=false;
		var ajaxRequestUrl = '/api/pki/ssh/addkeysgroup'; //No I18N
		var kGroupId = App.SettingsUserController.kGroupId;
		if(kGroupId != "new") {
			data.KEYS_GROUP_ID = kGroupId;
			data.IS_EDIT_VIEW = true;
		} else {
			data.IS_EDIT_VIEW = false;
		}
                var kgName=$('#kGroupName').val().trim();
                if(kgName=="")
                {
                    showAlert(I18N.getMsg("js.commonstr.giveKeysGroupName",this)); // No I18N
                    return;                    
                }
                data.KEYS_GROUP_NAME = kgName;
                data.KG_DESCRIPTION = $('#kGroupDesc').val();
                if (data.KG_DESCRIPTION.length>=255)
                {
                	showAlert(I18N.getMsg("js.general.description_length",this))//NO I18N
                	return;
                }
                var componentSelection = $("input[name='ComponentSelection']:checked").val();//No I18N
		data.ComponentSelection = componentSelection;
                if(componentSelection == "KeysByCriteria") {
                    var CRITERIA_LIST = new Array();
                    var emptyValue = false;
                    $("#critetriaTable").find('tr').each(function (i, el) {
                            var id = $(this).attr("id");
                            var cri = {

                            };
                            cri.Condition = $("#CONDITION_"+id).val();
                            cri.Field = $("#PARAMETER_"+id).val();
                            if($("#COMPARATOR_"+id).val() == undefined || $("#COMPARATOR_"+id).val() == "") {
                                    cri.Comparator = "and"; // No I18N
                            } else {
                                    cri.Comparator = $("#COMPARATOR_"+id).val();
                            }

                            var val = $("#PATTERN_"+id).val();
                            if(val == "") {
                                    emptyValue = true;
                            }
                            cri.Value = val;
                            if(cri.Field==="ENCRYPTION_BITS")
                            {
                                var numbers = /^[0-9]+$/;  
                                if(!val.match(numbers))  
                                {
                                    showAlert(I18N.getMsg("keylength.numberinput.alert"));//No I18N
                                    exit=true;
                                    return;
                                }
                            }  
                            CRITERIA_LIST.push(cri);
                    });
                    if(exit)
                    {
                        return;
                    }
                    var rowcount = $('#PKIMatchingKeysList').jqGrid('getGridParam', 'reccount');
                        if (rowcount != undefined && rowcount <= 0) {
                            showAlert(I18N.getMsg("js.sshkey.selectAtleastOneKey", this)); //No I18N 
                            return;
                        }
                    if(emptyValue == true) {
                            showAlert(I18N.getMsg("js.keysGroup.criteriaempty",this)); // No I18N
                            return;
                    }
                    data.CRITERIA_LIST = JSON.stringify(CRITERIA_LIST);
                    
                }
                else{
                    var selected = "";
                    $("#SELECTEDKEYS option").each(function()
                    {
                        if(selected=="")
                        {
                            selected=$(this).val();
                        }
                        else
                        {
                            selected=selected+","+$(this).val();
                        }
                    });
                    if(selected == "") {
                            showAlert(I18N.getMsg("js.sshkey.selectAtleastOneKey",this)); //No I18N 
                            return;
                    }
                    data.SELECTEDKEYS = selected;                    
                }
                data.QUERYID = App.SettingsUserController.QUERYID;
                data.pmpcp=Get_Cookie('pmpcc');//No I18N
                ajaxapicall(ajaxRequestUrl,data,true,"SSHMgmt/keysGroup");//NO I18N
            },
            placeKey:function(){
            var app=this.get('controllers.application');
            app.send('opendialog','PlaceKeyFile');//NO I18N
            }
		
    }
});

App.AddUsersGroupController = Ember.ObjectController.extend({
    needs: ["AllResourceUsers","application"],//NO I18N
    actions: {
            cancelOperation:function() {
                redirectUrl("SSHMgmt/usersGroup"); //No I18N
            },
            saveUsersGroup: function() {
                var data = {};
                var userids=[];
                var values = [];                
                var uGroupId = App.SettingsUserController.kGroupId;
                if(uGroupId != "new") {
			data.USERS_GROUP_ID = uGroupId;
			data.IS_EDIT_VIEW = true;
		} else {
			data.IS_EDIT_VIEW = false;
		}
                var ugName=$('#uGroupName').val().trim();
                if(ugName=="")
                {
                    showAlert(I18N.getMsg("js.usersGroup.entervalidgroupname",this)); // No I18N
                    return;                    
                }
		data.USERS_GROUP_NAME = ugName;
		data.UG_DESCRIPTION = $('#uGroupDesc').val();
		var componentSelection = $("input[name='ComponentSelection']:checked").val();//No I18N
		data.ComponentSelection = componentSelection;
                if(componentSelection == "UsersByCriteria") {
                    var CRITERIA_LIST = new Array();
			var emptyValue = false;
			$("#critetriaTable").find('tr').each(function (i, el) {
				var id = $(this).attr("id");
				var cri = {
						
				};
				cri.Condition = $("#CONDITION_"+id).val();
				cri.Field = $("#PARAMETER_"+id).val();
				if($("#COMPARATOR_"+id).val() == undefined || $("#COMPARATOR_"+id).val() == "") {
					cri.Comparator = "and"; // No I18N
				} else {
					cri.Comparator = $("#COMPARATOR_"+id).val();
				}
				
				var val = $("#PATTERN_"+id).val();
				if(val == "") {
					emptyValue = true;
				}
				cri.Value = val;
				CRITERIA_LIST.push(cri);
			});
                        var rowcount = $('#PKIMatchingUsersList').jqGrid('getGridParam', 'reccount');
                        if (rowcount != undefined && rowcount <= 0) {
                            showAlert(I18N.getMsg("js.userselection.selectAtleastOneUserFromSshResource", this)); //No I18N 
                            return;
                        }
			if(emptyValue == true) {
				showAlert(I18N.getMsg("js.usersGroup.emptyvaluesalert",this)); // No I18N
				return;
			}
			data.CRITERIA_LIST = JSON.stringify(CRITERIA_LIST);
                }
                else
                {                   
                    var checked_ids = []; 
                    checked_ids=$('#data').jstree(true).get_selected();//NO I18N
                    for(var i=0;i<checked_ids.length;i++)
                    {
                        if(checked_ids[i].indexOf("par") > -1)
                        {
                            var par_split=checked_ids[i].split("_");
                            values.push(par_split[1]);
                        }
                        else
                        {
                            var user_split=checked_ids[i].split("_");
                            if(!checkArray(values,user_split[0]))
                            {
                                values.push(user_split[0]);
                            }
                            userids.push(user_split[1]); 
                        }
                    }
                    if(userids.length<=0)
                    {
                        showAlert(I18N.getMsg('js.userselection.selectAtleastOneUserFromSshResource'));//No I18N
                        return;
                    }                        
                }
                var ajaxRequestUrl = '/api/pki/ssh/addusersgroup?USERIDS='+userids+'&RESOURCEIDS='+values; //No I18N
                data.QUERYID = App.SettingsUserController.QUERYID;
                data.pmpcp=Get_Cookie('pmpcc');//No I18N
                ajaxapicall(ajaxRequestUrl,data,true,"SSHMgmt/usersGroup");//NO I18N
            },
            disassociate:function()
            {
                this.get('controllers.AllResourceUsers').send('disassociate');//No I18N
            }
        }    
});

App.KeysGroupController = Ember.ObjectController.extend({
    needs : "application",//NO I18N
     actions: {
        deleteGroup: function() {
            var ajaxRequestUrl = '/api/pki/ssh/deleteKeysGroup'; //No I18N
            var data = {

            };
            var grid = $("#PKIKeysGroupList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                   showAlert(I18N.getMsg('js.keysGroup.SelectAtleastOneGroup')); //No I18N
                    return;
            }
            var arr = "";
            var namesArr="";
            var val=vConfirmation(I18N.getMsg('js.deletekeysgroup.deletetheSelectedKeysGroup'),function(){//NO I18N
            $.each(selRowIds, function()
            {
                var id = this;
                var kg_id = grid.jqGrid('getCell', id, 'GROUP ID'); //No I18N
                var kg_name = grid.jqGrid('getCell',id,'GROUP NAME');//NO I18N
                if(arr=="")
                {
                    arr=kg_id;
                    namesArr=kg_name;
                }
                else
                {
                    arr=arr+","+kg_id;
                    namesArr+=","+kg_name;
                }
            });
            data.KEYS_GROUP_ID=arr;
            data.KEYS_GROUP_NAMESARR=namesArr;
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    App.Settings.listkeysgroup();
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
            });
        },
        KeyRotation:function(){
            var grid = jQuery("#PKIKeysGroupList");//No I18N 
            App.SettingsCommonController.grid=grid;
            App.SettingsCommonController.from="keygrouprotation";//NO I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_ids="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.keysGroup.SelectAtleastOneGroup')); //No I18N
                return;
        }
            var app = this.get("controllers.application");
            app.send('opendialog','RotateKeyWithFile');//NO I18N           
    
        }
    }

});

App.UsersGroupController = Ember.ObjectController.extend({
    needs :'application',//NO I18N
     actions: {
        deleteGroup: function() {
            var ajaxRequestUrl = '/api/pki/ssh/deleteUsersGroup'; //No I18N
            var data = {

            };
            var grid = $("#PKIUsersGroupList"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds == undefined || selRowIds.length == 0) {
                   showAlert(I18N.getMsg('js.usersGroup.selectatleastonegroup')); //No I18N
                    return;
            }
            var arr = "";
            var nameArr="";
            var val=vConfirmation(I18N.getMsg('js.usersGroup.deletegroup'),function(){//NO I18N
            $.each(selRowIds, function()
            {
                var id = this;
                var ug_id = grid.jqGrid('getCell', id, 'GROUP ID'); //No I18N
                var ug_name=grid.jqGrid('getCell',id, 'GROUP NAME');//NO I18N
                
                if(arr=="")
                {
                    arr=ug_id;
                    nameArr=ug_name;
                }
                else
                {
                    arr=arr+","+ug_id;
                    nameArr+=","+ug_name;
                }
            });
            data.USERS_GROUP_ID=arr;
            data.USERS_GROUP_NAMESARR=nameArr;
            data.pmpcp=Get_Cookie('pmpcc');//NO I18N
            getAjaxApiRequest(ajaxRequestUrl,data,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    App.Settings.listusersgroup();
                }
                else
                {
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
            });
        }
//        editUserPath: function(){
//            var grid = $("#PKIUsersGroupList"); //No I18N
//            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
//            if(selRowIds == undefined || selRowIds.length == 0 || selRowIds.length>1) {
//                   showAlert(I18N.getMsg('js.selectone.group')); //No I18N
//                    return;
//            }
//            var ug_id = grid.jqGrid('getCell', selRowIds, 'GROUP ID'); //No I18N
//            var ug_name= grid.jqGrid('getCell',selRowIds,'GROUP NAME');//NO I18N
//            App.SettingsCommonController.uGroup=true;
//            App.SettingsCommonController.user_id=ug_id;
//            App.SettingsCommonController.uGroupName=ug_name;
//            var app=this.get('controllers.application');
//            app.send('opendialog','EditUserPath');//NO I18N
//        }
    },
    credentialDialogCall:function(){
        var grid = $("#PKIUsersGroupList");//NO I18N
        var selRowIds = grid.jqGrid('getGridParam','selarrrow');//NO I18N
        
        if(selRowIds == undefined || selRowIds.length == 0)
        {
            showAlert(I18N.getMsg("js.usersGroup.selectatleastonegroup"));//No I18N 
            return;
    }
        App.SettingsCommonController.uGroup=true;
        var app=this.get('controllers.application');
        App.SettingsCommonController.isSingleCredential=false;
        app.send('opendialog','ResourceUserCredential');//NO I18N
    },
    associate:function(){
        var grid = $("#PKIUsersGroupList");//NO I18N
        var selRowIds = grid.jqGrid('getGridParam','selarrrow');//NO I18N
        if(selRowIds == undefined || selRowIds.length == 0)
        {
            showAlert(I18N.getMsg("js.usersGroup.selectatleastonegroup"));//No I18N 
            return;
        }
        App.SettingsCommonController.uGroup=true;
        var app=this.get('controllers.application');
        app.send('opendialog','AssociateUserToKeyView');//NO I18N
    },
    createAndDeploy:function(){
        var grid = $("#PKIUsersGroupList");//NO I18N
        var selRowIds = grid.jqGrid('getGridParam','selarrrow');//NO I18N
        
        if(selRowIds == undefined || selRowIds.length == 0)
        {
            showAlert(I18N.getMsg("js.usersGroup.selectatleastonegroup"));//No I18N 
            return;
        }
        App.SettingsCommonController.uGroup=true;
        var app=this.get('controllers.application');
        app.send('opendialog','createAndDeploy');//NO I18N
    }
    
});

App.ImportCredentialController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        importCred:function(){
            var browse="";
            var textfield="";
            var fileData = new FormData();
            
                var file = document.getElementById("uploadKeyFile").files[0];
                fileData.append("File", file);//NO I18N
                browse=$('#uploadKeyFile');
                textfield=document.getElementById("textfile");
                    if ($('#textfile').val() == '') {
                    showAlert(I18N.getMsg('js.file.selectaFile'));//NO I18N
                    return;
                }
                var param='textfield='+textfield.value;//NO I18N
                fileData.append("pmpcp",Get_Cookie('pmpcc')); //No I18N
                var ajaxRequestUrl = '/api/pki/ssh/importCredentials?'+param; //No I18N
                getAjaxApiRequestForFile(ajaxRequestUrl, fileData, browse, textfield, true,false)
                this.send('closeModal');//NO I18N
        }
    }
});

function keyRotationProcess(grid,data,from)
{
    var goToUrl="SSHMgmt/KeyRotationAudit/2";//NO I18N
            if(localStorage.getItem("homeTab")=="PassTrixQuickView"){
                goToUrl=""
            }
    if(from == "keyrotation")
    {
    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_ids="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKey')); //No I18N
                return;
        }
            if( selRowIds.length >=50) {
                showAlert(I18N.getMsg('js.sshkeyRotation.CanRotateOnlyUpto50KeysataTime')); //No I18N
                return;
    }
    var isfingerprintAvail=true;
            $.each(selRowIds, function()
            {
                var id = this;
                var key_id = grid.jqGrid('getCell', id, 'KeyID'); //No I18N
            var fingerPrint = grid.jqGrid('getCell',id, 'FingerPrint'); //No I18N
            if(fingerPrint === ""||fingerPrint===undefined)
            {
                showAlert(I18N.getMsg('js.sshkeyRotation.KeyCannotBeRotated'));  //No I18N
                isfingerprintAvail = false;
            }
                if(key_ids!=="")
                {
                    key_ids=key_ids+","+key_id;
                }
                else
                {
                    key_ids=key_id;
                }
});
        if(isfingerprintAvail)
        {
            //            var data = {
            //
            //            };
            data.KEYIDS = key_ids;
	data.pmpcp=Get_Cookie('pmpcc');//No I18N
            var ajaxRequestUrl = '/api/pki/ssh/rotateKeys'; //No I18N
            ajaxapicall(ajaxRequestUrl,data,true,goToUrl);
        }
        
}
    else if(from == "keygrouprotation")
    {
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        var KG_Ids="";
        if(selRowIds == undefined || selRowIds.length == 0)
        {
            showAlert(I18N.getMsg('js.keysGroup.SelectAtleastOneGroup'));///NO I18N
            return;
        }
        $.each(selRowIds,function()
        {
                var id=this;
                var gid= grid.jqGrid('getCell',id,'GROUP ID');//NO I18N
                if(KG_Ids!=="")
                {
                    KG_Ids=KG_Ids+","+gid;
                }
                else
                {
                    KG_Ids=gid;
                }

        });
        var ajaxRequestUrl = '/api/pki/ssh/rotatekeygroups'; //No I18N
        var reqParams="GroupIds="+KG_Ids+"&pushkeyfile="+data.pushkeyfile+"&defaultfilename="+data.defaultfilename+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
        ajaxapicall(ajaxRequestUrl,reqParams,true,goToUrl);
    }
    else if(from == "dashboardkeyrotation")
    {
        var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
        if(selRowIds === undefined || selRowIds.length === 0) {
            showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKey')); //No I18N
            return;
            }
        var arr = new Array();
        $.each(selRowIds, function()
        {
            var id = this;
           var key_id = grid.jqGrid('getCell', id, 'KeyID'); //No I18N
            var userId = grid.jqGrid('getCell',id, 'RESUSERID'); //No I18N
            arr.push(key_id+"_"+userId);
        });
//                var data = {
//
//                };
        data.KEYIDS = JSON.stringify(arr);
        data.pmpcp=Get_Cookie('pmpcc');//NO I18N
        var ajaxRequestUrl = '/api/pki/ssh/rotateUserKeys'; //No I18N
        ajaxapicall(ajaxRequestUrl,data,true,goToUrl);
    }
}
    
function changeRestApiStatus(state)
    {
        var ajaxRequestUrl = '/api/pki/settings/enableDisableRestAPI'; //No I18N
        var params;
        if(state){
            params="RestAPIStatus="+true;//NO I18N
        }else{
            params="RestAPIStatus="+false;//NO I18N
}
        ajaxRequestWithCookie(ajaxRequestUrl,params,false,false,true,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {
                    if(state){
                        $("#enabledKeyDiv").show();
                        $("#apiKeyGenerate").show();
                    }else{
                        $("#enabledKeyDiv").hide();
                        $("#apiKeyGenerate").hide();
                    }
                }
            });
    }
