//$Id:$

//JS Plumb Tree Generation

var defaultWidth = 900;
var defaultHeight =900;

function showSelectedDiscoveryMode(DISC_TYPE)
{
    $("#single_row").hide();//NO I18N
    $("#addr_range_row").hide();//NO I18N
    $("#host_file_row").hide();//NO I18N
    if(DISC_TYPE==='SINGLE_DEVICE')
    {
        $("#single_row").show();//NO I18N
        $("#ipHostName").focus();
        $("#port_input").show();
    }
    else if(DISC_TYPE==='ADDR_RANGE')
    {
        $("#addr_range_row").show();//NO I18N
        $("#START_ADDR").focus();
        $("#port_input").show();
    }
    else if(DISC_TYPE==='HOST_FILE')
    {
        $("#host_file_row").show();//NO I18N
        $("#port_input").hide();
    }
}

function showSelectedCSRType(CSR_TYPE)
{
    $("#CNameSelection").hide();//NO I18N
    $("#CSRContentDiv").hide();//NO I18N
    $("#CSRFileDiv").hide();//NO I18N
    if(CSR_TYPE==='CSR_Select')
    {
        $("#CNameSelection").show();//NO I18N
    }
    else if(CSR_TYPE==='CSR_Content')
    {
        $("#CSRContentDiv").show();//NO I18N
    }
    else if(CSR_TYPE==='CSR_File')
    {
        $("#CSRFileDiv").show();//NO I18N
    }
}

function associationGraphView(jsonData)
{
	var width = 960,height = 600;

	var tooltip = $("#tooltip_div"); //No I18N
	var par="";
	var svg = d3.select("#MapBGImg").append("svg")//NO I18N
		.attr("width", width)//NO I18N
		.attr("height", height);//NO I18N

	var force = d3.layout.force()
		.gravity(.05)
		.distance(250)
		.charge(-100)
		.size([width, height]);

	force.nodes(jsonData.nodes)
	   .links(jsonData.links)
       .start();

	var link = svg.selectAll(".link")//NO I18N
		.data(jsonData.links)
		.enter().append("line")//NO I18N
		.attr("class", "link");//NO I18N

	var node = svg.selectAll(".node")//NO I18N
		.data(jsonData.nodes)
		.enter().append("g")//NO I18N
		.attr("class", "node")//NO I18N
		.call(force.drag)
		.on("click", function(d) {//NO I18N
                    if(d.group===1)
                    {
                        var resName = d.name; //No I18N
                        var keyName=par; //No I18N
                        var ajaxRequestUrl='/api/pki/ssh/getUsers?res_name='+resName+'&keyName='+keyName;//No I18N
                        getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                                    App.ApplicationController.res_id=0;
                                    document.getElementById("listUsers").click();//NO I18N
                                    $(".icon-add-user").hide();
                                    $( "#modalDialog" ).draggable();//NO I18N    
                                    if(jsonData.associated_users.length===0 )
                                    {
                                        var text1="No Users Found";//NO I18N
                                        $( "#nousers" ).text( text1 );//NO I18N
                                    }
                                    else
                                    {
                                        var asso_users=jsonData.associated_users;
                                        var non_asso_users=jsonData.non_associated_users;
                                        var colNamesList = ['UserID',I18N.getMsg('js.general.username'),'','','',I18N.getMsg('js.userterminalConnection'),I18N.getMsg('js.table.search')]; //No I18N
                                        if(!kmpStandAlone)
                                        {
                                            colNamesList = ['UserID',I18N.getMsg('js.general.username'),I18N.getMsg('js.table.search')]; //No I18N
                                        }
                                        var colModelList = [];
                                                colModelList.push({ name: 'UserID', index: 'UserID',hidden:true}); //No I18N
                                                colModelList.push({ name: 'UserName', index: 'UserName',width:'100'}); //No I18N
                                                if(kmpStandAlone){
                                                    colModelList.push({ name: 'credential', index: 'credential',hidden:true}); //No I18N
                                                    colModelList.push({ name: 'credential', index: 'credential',title:'Edit Credential',classes:'pointer',formatter:'editCredentialFormatter',width:'50px',search:false}); //No I18N
                                                    colModelList.push({ name: 'Connect', index: 'Connect',hidden:true});//No I18N
                                                    colModelList.push({ name: 'Connect', index: 'Connect',search:false,formatter:"openTerminalFormatter",classes:"pointer",width:'50'}); //No I18N
                                                }
                                                colModelList.push({ name: 'search',width:30,sortable: false,search:false,fixed:true});//NO I18N
                                        var defaultOptions={multiselect:true,rowNumNeeded:false,searchOption:true};
                                        loadJQgridWithData("#ListResourceUsers", jsonData.associated_users, colNamesList, colModelList, "", "", "ResourceUsersTerminal",defaultOptions,"#associateListUsers");//No I18N
                                        var DataGrid = $('#ListResourceUsers');
                                        DataGrid.jqGrid('setGridWidth', '460');//NO I18N
                                        DataGrid.jqGrid('setGridHeight', '250');//No I18N
                                    }
                        });
                    }
		})
		.on("mouseover", function(d) {//NO I18N
			// The class is used to remove the additional text later
			tooltip.css('background-color','#000000'); //No I18N
			tooltip.css('top',d3.event.pageY-20+ "px"); //No I18N
			tooltip.css('left',d3.event.pageX+20+ "px"); //No I18N
			tooltip.css('visibility','visible'); //No I18N
                        if(d.group===0)
                        {
			tooltip.html('Privatekey Name'+":"+d.name+"</br>"); //No I18N
                        }
                        else
                        {
                            tooltip.html('Resource Name'+":"+d.name+"</br>"); //No I18N
                        }
		})
		.on("mouseout", function() {//No I18N	
			// Remove the info text on mouse out.
			$("#tooltip_div").css('visibility','hidden'); //No I18N	
		});
	
		node.append("image")//NO I18N
		.attr("xlink:href", function(d) {//NO I18N
			if(d.group===0)
			{
				par=d.name;
				return "/pki/images/private-key-mapping.png";//NO I18N
			}	
			else
			{
				return "/pki/images/resource.png";//NO I18N
			}
		})
		.attr("x", -8)//NO I18N
		.attr("y", -8)//NO I18N
		.attr("width", 25)//NO I18N
		.attr("height", 25);//NO I18N

		node.append("text")//NO I18N
		.attr("dx", -15)//NO I18N
		.attr("dy", 28)//NO I18N
		.text(function(d) { return d.name });

	force.on("tick", function() {//NO I18N
		link.attr("x1", function(d) { return d.source.x; })//NO I18N
			.attr("y1", function(d) { return d.source.y; })//NO I18N
			.attr("x2", function(d) { return d.target.x; })//NO I18N
			.attr("y2", function(d) { return d.target.y; });//NO I18N
	
		node.attr("transform", function(d) { return "translate(" + d.x + "," + d.y + ")"; });//NO I18N
	});    
}

function userAssociationGraphView(jsonData)
{
	var width = 960,height = 600;
        var userid= jsonData.nodes[0].userid;
        var resourcename = jsonData.nodes[0].resource_name;
	var tooltip = $("#tooltip_div"); //No I18N
	var par="";
	var svg = d3.select("#MapBGImg").append("svg")//NO I18N
		.attr("width", width)//NO I18N
		.attr("height", height);//NO I18N

	var force = d3.layout.force()
		.gravity(.05)
		.distance(250)
		.charge(-100)
		.size([width, height]);

	force.nodes(jsonData.nodes)
	   .links(jsonData.links)
       .start();

	var link = svg.selectAll(".link")//NO I18N
		.data(jsonData.links)
		.enter().append("line")//NO I18N
		.attr("class", "link");//NO I18N

	var node = svg.selectAll(".node")//NO I18N
		.data(jsonData.nodes)
		.enter().append("g")//NO I18N
		.attr("class", "node")//NO I18N
		.call(force.drag)
		.on("click", function(d) {//NO I18N
            
                    if(d.group===1)
                    {
                        var keyid = d.keyid;                       
                        openTerminal(userid,keyid);
                    }
                    else
                    {
                        openTerminal(userid);
                    }
		})
		.on("mouseover", function(d) {//NO I18N
			// The class is used to remove the additional text later
			tooltip.css('background-color','#000000'); //No I18N
			tooltip.css('top',d3.event.pageY-20+ "px"); //No I18N
			tooltip.css('left',d3.event.pageX+20+ "px"); //No I18N
			tooltip.css('visibility','visible'); //No I18N
                        if(d.group===0)
                        {
                            tooltip.html('User Name'+":"+d.name+"</br>"+'Resource Name:'+resourcename); //No I18N
                        }
                        else
                        {
                            tooltip.html('Privatekey Name'+":"+d.name+"</br>"); //No I18N
                        }
		})
		.on("mouseout", function() {//No I18N	
			// Remove the info text on mouse out.
			$("#tooltip_div").css('visibility','hidden'); //No I18N	
		});
	
		node.append("image")//NO I18N
		.attr("xlink:href", function(d) {//NO I18N
			if(d.group===0)
			{
				par=d.name;
				return "/pki/images/user.png";//NO I18N
			}	
			else
			{
                            return "/pki/images/private-key-mapping.png";//NO I18N				
			}
		})
		.attr("x", -8)//NO I18N
		.attr("y", -8)//NO I18N
		.attr("width", 25)//NO I18N
		.attr("height", 25);//NO I18N

		node.append("text")//NO I18N
		.attr("dx", -15)//NO I18N
		.attr("dy", 28)//NO I18N
		.text(function(d) { return d.name });

	force.on("tick", function() {//NO I18N
		link.attr("x1", function(d) { return d.source.x; })//NO I18N
			.attr("y1", function(d) { return d.source.y; })//NO I18N
			.attr("x2", function(d) { return d.target.x; })//NO I18N
			.attr("y2", function(d) { return d.target.y; });//NO I18N
	
		node.attr("transform", function(d) { return "translate(" + d.x + "," + d.y + ")"; });//NO I18N
	});    
}

function generateResourceUserTree(jsonData)
{
    treeObj=jsonData;
    $('#data').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
    $('#data').jstree({
            "plugins" : [ "themes", "html_data", "checkbox","search","sort"],//NO I18N
            'core' : jsonData,//NO I18N
            "search":{//NO I18N
                "case_insensitive":true,//NO I18N
                "show_only_matches":true//NO I18N
            }
    });
    var to = false;
    $('#plugins4_q').keyup(function () {//NO I18N
        if(to) { clearTimeout(to); }
        to = setTimeout(function () {
                var v = $('#plugins4_q').val();//NO I18N
                $('#data').jstree('search',v);//NO I18N
        }, 250);
    });    
}

function generateAuditNotifyTree(jsonData,id)
{
    //treeObj=jsonData;
    $(id).slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
    $(id).jstree({
            "plugins" : [ "themes", "html_data", "checkbox","search","sort"],//NO I18N
            'core' : jsonData,//NO I18N
            "search":{//NO I18N
                "case_insensitive":true,//NO I18N
                "show_only_matches":true//NO I18N
            }
    });
    var to = false;
    $('#plugins4_q').keyup(function () {//NO I18N
        if(to) { clearTimeout(to); }
        to = setTimeout(function () {
                var v = $('#plugins4_q').val();//NO I18N
                $(id).jstree('search',v);//NO I18N
        }, 250);
    });    
}

function zoomIn()
{
	var value = $("#slider_map").slider('value');
	$("#slider_map").slider('value',value+1);
	rescaleMap(value+1,$('#MapBGImg'));
}
function zoomOut()
{
	var value = $("#slider_map").slider('value');
	$("#slider_map").slider('value',value-1);
	if(value > 1)
	{
		rescaleMap(value-1,$('#MapBGImg'));
	}
	else
	{
		rescaleMap(0.5,$('#MapBGImg'));	
	}
}
function loadSlideMapBar()
{
	$( "#slider_map" ).slider();
	$( "#slider_map" ).slider({ orientation: "vertical" });
	$( "#slider_map" ).slider({ animate: "fast" });
	$( "#slider_map" ).slider({ max: 5 });
	$( "#slider_map" ).slider({ min: 0.5 });
	$( "#slider_map" ).slider({ step: 0.25 });
	$( "#slider_map" ).slider({ value: 1.0 });
	$( "#slider_map" ).slider({
	change: function( event, ui ) {
			zoomSize = $( "#slider_map" ).slider( "value" );

	//document.getElementById('MapBGImg').innerHTML="<div id='tooltip_div' style='position:absolute;z-index:10;visibility:invisible;font-family:Open Sans;font-size:"+12*zoomSize+"px;font-weight:bold;color:white;border-radius:5px;padding:5px;'></div>";
	//drawDeviceRelationshipMap(tempJSON, zoomSize);
		rescaleMap(zoomSize,$('#MapBGImg'));
	
	}
});
}

function loadSlideUCSMapBar()
{	
    $( "#slider_ucs" ).slider();
    $( "#slider_ucs" ).slider({ orientation: "vertical" });
    $( "#slider_ucs" ).slider({ animate: "fast" });
    $( "#slider_ucs" ).slider({ max: 5 });
    $( "#slider_ucs" ).slider({ min: 0.25 });
    $( "#slider_ucs" ).slider({ step: 0.25 });
    $( "#slider_ucs" ).slider({ value: 1 });
    $( "#slider_ucs" ).slider({
        change: function( event, ui ) {
            zoomSize = $( "#slider_ucs" ).slider( "value" );
            //document.getElementById('MapBGImg').innerHTML="<div id='tooltip_div' style='position:absolute;z-index:10;visibility:invisible;font-family:Open Sans;font-size:"+12*zoomSize+"px;font-weight:bold;color:white;border-radius:5px;padding:5px;'></div>";
            //drawDeviceRelationshipMap(tempJSON, zoomSize);
            rescaleMap(zoomSize,$('#UCSTreeView'));
        }
    });
}

function rescaleMap(zoomSize, elem) 
{
    var height = parseInt(elem.css('height'));//No I18N
    var width = parseInt(elem.css('width'));//No I18N
    var ratioX = zoomSize;
    var ratioY = zoomSize;

    elem.css('-moz-transform', 'scale('+ratioX +', '+ratioY+')');   //No I18N
    elem.css('-webkit-transform', 'scale('+ratioX +', '+ratioY+')');//No I18N
    elem.css('-ms', 'scale('+ratioX +', '+ratioY+')');   //No I18N
    elem.css('-o', 'scale('+ratioX +', '+ratioY+')');   //No I18N
    elem.css('transform', 'scale('+ratioX +', '+ratioY+')');   //No I18N

    elem.css('-moz-transform-origin', '0 0');//No I18N
    elem.css('-webkit-transform-origin', '0 0');//No I18N
    elem.css('-ms-transform-origin', '0 0');   //No I18N
    elem.css('-o-transform-origin', '0 0'); //No I18N
    elem.css('transform-origin', '0 0'); //No I18N

    var finalWidth =  parseInt(defaultWidth*ratioX);
    var finalHeight = parseInt(defaultHeight*ratioY);

    if(finalWidth<defaultWidth)
    {
            finalWidth = defaultWidth;
    }
    if(finalHeight<defaultHeight)
    {
            finalHeight = defaultHeight;
    }
    elem.css('width', finalHeight + 'px');//No I18N
    elem.css('height', finalHeight + 'px');//No I18N
}

function changeTaskType() {
	var index = $('#SCHEDULE_TYPE').val(); //No I18N
        $("#adDetailsForm").hide();
        $("#msCertStoreForm").hide();
	if(index == 'SSH_Discovery'||index=='SSL_Discovery') {
		$("#schedule-discovery-div").css('display','block');  //No I18N
	} else {
		$("#schedule-discovery-div").css('display','none');   //No I18N
	}
         if(index=='Key_Rotation')
         {
                $("#schedule-keyrotation-div").css('display','block');
                 $("#schedule-keyrotation-mail-div").css('display','block');
}
         else
         {
                $("#schedule-keyrotation-div").css('display','none');
                  $("#schedule-keyrotation-mail-div").css('display','none');
         }
         if(index=='Schedule_Report')
         {
             $("#schedule-report-div").css('display','block');
         }
         else{
             $("#schedule-report-div").css('display','none');
         }
         
         if(index== 'SSL_Discovery')
         {
             $("#ssl_port_label").show();
}
         else
         {
             $("#ssl_port_label").hide();
         }
         if(index == 'SSL Expiry' || index==='SSL Vulnerabilities')
         {
             changeSSLScheduleSelection();
             $("#ssl-expiry-div").show();
             if(index === 'SSL Vulnerabilities')
             {
                 $("#vulnerabilities").show();
                 $("#expiry_days").hide();
                 $("#schedule-mailformat-div").hide();
}
         else
         {
                 $("#vulnerabilities").hide();
                 $("#expiry_days").show();
                 $("#schedule-mailformat-div").show();
             }
}
         else
         {
             if(index==="CMDB_Sync")
             {
                 $("#schedule-mailformat-div").hide();
             }
             else
             {
             $("#schedule-mailformat-div").show();
             }
             $("#vulnerabilities").hide();
             $("#ssl-expiry-div").hide();
         }
        if(index == 'AD_UserCert_Import')
        {
            $("#adDetailsForm").show();
            App.Settings.getDomains();//For getting Domains
            App.ScheduleDetailsController.adImportType="";
            App.ScheduleDetailsController.adSelectedValues="";
            $("#adOUFetch").show();
            $("#step1_id").hide();
            $("#step2_id").remove();
            $("#userimp_id").hide();
            $("#importType_id").hide();
}
        if(index == 'MSCA_And_MSStore_Discovery')
        {
            $("#msCertStoreForm").show();
            $("#msstore_action_div").hide();
            mscaDiscoveryFilter();
        }
}
            
function mscaDiscoveryFilter()
{
            $("#FROM_DATE").datepicker().datepicker("setDate", new Date());
            $("#TO_DATE").datepicker().datepicker("setDate", new Date());
            $("#CACertTypeID3").on('change', function() {
                $("#time_filter").toggle();
            });
            App.DiscoveryDataController.isPasswordNeeded=true;
            $("#CACertTypeID4").on('change', function() {
                $("#template_filter").toggle();
            });
            $("#machineName").on('change', function() {
                App.DiscoveryDataController.isPasswordNeeded=true;
            });
            getMSCertStoreServer(false);
}

function changeAlgType() {
    var algType=document.getElementById("ALG_TYPE").value;//NO I18N
    if(algType==="DSA")
    {
        //Key Length
        $('#ALG_LEN').find('option').remove();//NO I18N
        $("#ALG_LEN").append(new Option("1024", "1024"));//NO I18N
        $("#ALG_LEN").append(new Option("512", "512"));//NO I18N
        
        //Signature Algorithm
        $('#SIG_ALG').find('option').remove();//NO I18N
        $("#SIG_ALG").append(new Option("SHA1", "SHA1"));//NO I18N
    }
    else if(algType==="EC")
    {
        $('#ALG_LEN').find('option').remove();//NO I18N
        $("#ALG_LEN").append(new Option("256", "256"));//NO I18N
        $("#ALG_LEN").append(new Option("128", "128"));//NO I18N

        //Signature Algorithm
        $('#SIG_ALG').find('option').remove();//NO I18N
        $("#SIG_ALG").append(new Option("SHA256", "SHA256"));//NO I18N
        $("#SIG_ALG").append(new Option("SHA384", "SHA384"));//NO I18N
        $("#SIG_ALG").append(new Option("SHA512", "SHA512"));//NO I18N
    }
    else
    {
        $('#ALG_LEN').find('option').remove();//NO I18N
        $("#ALG_LEN").append(new Option("4096", "4096"));//NO I18N
        $("#ALG_LEN").append(new Option("2048", "2048"));//NO I18N
        $("#ALG_LEN").append(new Option("1024", "1024"));//NO I18N

        //Signature Algorithm
        $('#SIG_ALG').find('option').remove();//NO I18N
        $("#SIG_ALG").append(new Option("SHA256", "SHA256"));//NO I18N
        $("#SIG_ALG").append(new Option("SHA384", "SHA384"));//NO I18N
        $("#SIG_ALG").append(new Option("SHA512", "SHA512"));//NO I18N
    }
}

function changeLetsAlgType() {
    var algType=document.getElementById("ALG_TYPE").value;//NO I18N
    if(algType==="EC")
    {
        $('#ALG_LEN').find('option').remove();
        $("#ALG_LEN").append(new Option("256", "256"));
        $("#ALG_LEN").append(new Option("384", "384"));

        //Signature Algorithm
        $('#SIG_ALG').find('option').remove();
        $("#SIG_ALG").append(new Option("SHA256", "SHA256"));
        $("#SIG_ALG").append(new Option("SHA384", "SHA384"));
        $("#SIG_ALG").append(new Option("SHA512", "SHA512"));
    }
    else
    {
        $('#ALG_LEN').find('option').remove();
        $("#ALG_LEN").append(new Option("4096", "4096"));
        $("#ALG_LEN").append(new Option("2048", "2048"));

        //Signature Algorithm
        $('#SIG_ALG').find('option').remove();
        $("#SIG_ALG").append(new Option("SHA256", "SHA256"));
        $("#SIG_ALG").append(new Option("SHA384", "SHA384"));
        $("#SIG_ALG").append(new Option("SHA512", "SHA512"));
    }
}


function mask_in_report_formatter(cellValue,options,rowdata,action)
{
    if(cellValue===true)
    {
        return '<input type="checkbox" style="margin-left:30px" id="Mask_In_Report_'+rowdata.Settings_Id+'"checked>';//NO I18N
    }
    else
    {
        return '<input type="checkbox" style="margin-left:30px" id="Mask_In_Report_'+rowdata.Settings_Id+'">';//NO I18N
    }
}

function mask_in_schedule_formatter(cellValue,options,rowdata,action)
{
    if(cellValue===true)
    {
        return '<input type="checkbox" style="margin-left:50px" id="Mask_In_Schedule_'+rowdata.Settings_Id+'"checked>';//NO I18N
    }
    else
    {
        return '<input type="checkbox" style="margin-left:50px" id="Mask_In_Schedule_'+rowdata.Settings_Id+'">';//NO I18N
    }
}

function hide_in_report_formatter(cellValue,options,rowdata,action)
{
    if(cellValue===true)
    {
        return '<input type="checkbox" style="margin-left:30px" id="Hide_In_Report_'+rowdata.Settings_Id+'"checked>';//NO I18N
    }
    else
    {
        return '<input type="checkbox" style="margin-left:30px" id="Hide_In_Report_'+rowdata.Settings_Id+'">';//NO I18N
    }
}

function hide_in_schedule_formatter(cellValue,options,rowdata,action)
{
    if(cellValue===true)
    {
        return '<input type="checkbox" style="margin-left:50px" id="Hide_In_Schedule_'+rowdata.Settings_Id+'"checked>';//NO I18N
    }
    else
    {
        return '<input type="checkbox" style="margin-left:50px" id="Hide_In_Schedule_'+rowdata.Settings_Id+'">';//NO I18N
    }
}

function pipeFormatter(cellValue,options,rowdata,action)
{
    return '<span style="border-left:1px dotted #aaa;padding-right:5px"></span>'+cellValue;//NO I18N
}

function challengeStateFormatter(cellValue,options,rowdata,action)
{
    var status = rowdata.status;
    if(status === "pending")
    {
        return '<div style="width:70%;background-color:#fdc006;color: #fff;border-radius:.25em;text-align: center;margin-bottom:5px">Pending</div>';//NO I18N
    }
    else if(status === "invalid")
    {
        return '<div style="width:70%;background-color:#f35f62;color: #fff;border-radius:.25em;text-align: center;margin-bottom:5px">Failed</div>';//NO I18N
    }
    else
    {
        return '<div style="width:70%;background-color:#10bc83;color: #fff;border-radius:.25em;text-align: center;margin-bottom:5px">Verified</div>';//NO I18N
    }
}

function agentFormatter(cellValue,options,rowdata,action)
{
      return '<span class="icon-pmpagents" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Agent Mapping\',this);" onmouseout="UnTip(this);"></span>';//NO I18N
    }

function deployStatusFormatter(cellValue,options,rowdata,action)
{
    var status = rowdata.status;
    if(status==='pending')
    {
    return '<span class="icon-deploy-status" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Deploy Status\',this)" onmouseout="UnTip(this);"></span>';//NO I18N    
}
    else
    {
        return '<span class="icon-deploy-status fontIcon-disable" style="color:#CECECE;font-size:16px;" onmouseover="Tip(\'Deploy Status\',this)" onmouseout="UnTip(this);"></span>';//NO I18N    
    }
}

function deployChallengeFormatter(cellValue,options,rowdata,action)
{
    return '<span class="icon-push-file" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Push Challeng File\',this)" onmouseout="UnTip(this);"></span>';//NO I18N    
}

function deployCertificateFormatter(cellValue,options,rowdata,action)
{
    var status=rowdata.CERTIFICATE;
    if(status==="yes")
    {
        return '<span class="icon-push-file" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Push Ceritifcate\',this)" onmouseout="UnTip(this);"></span>';//NO I18N    
    }
    else
    {
        return '<span class="icon-push-file fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//NO I18N    
    }
}

function ProcessRequestFormatter(cellValue,options,rowdata,action)
{
      return '<span class="icon-pmpagents" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Auto Process Request\',this)" onmouseout="UnTip(this);"></span>';//NO I18N
}

function newRequestFormatter(cellValue,options,rowdata,action)
{
    var status = rowdata.status;
    if(status==='invalid')
    {
        return '<span class="icon-ssl-cerreq" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'New Challenge\',this)" onmouseout="UnTip(this);"></span>';//NO I18N
    }
    else
    {
       return '<span class="icon-ssl-cerreq fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//NO I18N 
    }
}

function challengeDownlaodFormatter(cellValue,options,rowdata,action)
{
    var token = rowdata.token;
    var challengeContent = rowdata.challengeContent;
    if(rowdata.status === "pending")
    {
        return '<div class="icon-export" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Challenge File\',this)" onmouseout="UnTip(this);" onclick=downloadChallengeFile(\''+token+'\',\''+challengeContent+'\')></div>';//NO I18N
    }
    else
    {
       return '<div class="icon-export fontIcon-disable" style="color:#CECECE;font-size:16px;"></div>';//NO I18N 
    }
}

function letsCertHistoryFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.CERTIFICATE==='yes')
    {
        return '<span class="icon-ssl-history" style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Certificate History\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
    else
    {
        return '<span class="icon-ssl-history fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function godaddyCheckCertificate(cellValue,options,rowdata,action)
{
    return '<span class="icon-ssl-cert" style="font-color:black;font-size:14px;cursor:pointer;" onmouseover="Tip(\'Check Certificate Availability\',this)" onmouseout="UnTip(this);"></span>';//NO I18N
}

function godaddyHistoryFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.History_Status==='yes')
    {
        return '<span class="icon-ssl-history" style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Certificate History\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
    else
    {
        return '<span class="icon-ssl-history fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function certStatusFormatter(cellValue ,options,rowdata,action)
{
    if(rowdata.CERT_STATUS==="Renewed")
    {
       return '<div style="width:70%;background-color:#f68300;color: #fff;border-radius:.25em;text-align: center;margin-bottom:5px">Renewed</div>';
    }
    else if(rowdata.CERT_STATUS==="Available")
    {
        return '<div style="width:70%;background-color:#10bc83;color: #fff;border-radius:.25em;text-align: center;margin-bottom:5px">Available</div>';
    }
    else if(rowdata.CERT_STATUS==="Saved")
    {
        return '<div style="width:70%;background-color:#008ffb;color: #fff;border-radius:.25em;text-align: center;margin-bottom:5px">Saved</div>';
    }
    else if(rowdata.CERT_STATUS==="Revoked")
    {
        return '<div style="width:70%;background-color:#f35f62;color: #fff;border-radius:.25em;text-align: center;margin-bottom:5px">'+cellValue+'</div>';
    }
    else
    {
        return '<div style="width:70%;background-color:#b8c0c8;color: #fff;border-radius:.25em;text-align: center;margin-bottom:5px">'+cellValue+'</div>';
    }
        
}

function godaddyReportStatusFormatter(cellValue ,options,rowdata,action)
{
    if(rowdata.STATUS==="CERTIFICATE SAVED")
    {
        return '<div class="sslorderstatus" style="background-color:#5ca555;color: #fff;border-radius:1.25em;text-align: center;margin-bottom:5px">CERTIFICATE SAVED</div>';     
    }
    else if(rowdata.STATUS==="CERTIFICATE ISSUED")
    {
        return '<div class="sslorderstatus" style="background-color:#fdcd6d;color: #a56902;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.STATUS+'</div>';
    }
    else if(rowdata.STATUS==="ORDER CANCELED" || rowdata.STATUS==="CERTIFICATE REVOKED" || rowdata.STATUS==="FRAUD DETECTED")
    {
        return '<div class="sslorderstatus" style="background-color:#fe9772;color: #b9481f;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.STATUS+'</div>';
    }    
    else
    {
        return '<div class="sslorderstatus" style="background-color:#a6cdfb;color: #2876cf;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.STATUS+'</div>';
    }
}

function godaddyCertStatusFormatter(cellValue ,options,rowdata,action)
{
    if(rowdata.STATUS==="CERTIFICATE SAVED")
    {
        return '<div class="sslorderstatus" style="background-color:#5ca555;color: #fff;border-radius:1.25em;text-align: center;margin-bottom:5px">CERTIFICATE SAVED</div>';
    }
    else if(rowdata.STATUS==="CERTIFICATE ISSUED")
    {
        return '<div class="sslorderstatus" style="background-color:#fdcd6d;color: #a56902;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.STATUS+'</div>';
    }
    else if(rowdata.STATUS==="ORDER CANCELED" || rowdata.STATUS==="CERTIFICATE REVOKED" || rowdata.STATUS==="FRAUD DETECTED")
    {
        return '<div class="sslorderstatus" style="background-color:#fe9772;color: #b9481f;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.STATUS+'</div>';
    }
    else if(rowdata.AUTHORIZATION==="no")
    {
        return '<span class="sslorderstatus" class="pointer" onclick=authorizeGoDaddyRequest(\''+rowdata.ID+'\')>Authorize</span>';//NO I18N
    }
    else
    {
        return '<div class="sslorderstatus" style="background-color:#a6cdfb;color: #2876cf;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.STATUS+'</div>';
    }
}

function sslStoreCertStatusFormatter(cellValue ,options,rowdata,action)
{
    if(rowdata.Status==="CERTIFICATE SAVED" || rowdata.Status==="COMPLETED")
    {
        return '<div class="sslorderstatus" style="background-color:#5ca555;color: #fff;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.Status+'</div>';
        
    }
    else if(rowdata.Status==="PENDING")
    {
        return '<div class="sslorderstatus" style="background-color:#fdcd6d;color: #a56902;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.Status+'</div>';
    }
    else if(rowdata.Status==="CANCELED" || rowdata.Status==="EXPIRED")
    {
        return '<div class="sslorderstatus" style="background-color:#fe9772;color: #b9481f;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.Status+'</div>';
    }
    else if(rowdata.AUTHORIZATION==="no")
    {
        return '<span class="sslorderstatus" class="pointer" onclick=authorizeGoDaddyRequest(\''+rowdata.ID+'\')>Authorize</span>';//NO I18N
    }
    else
    {
        return '<div class="sslorderstatus" style="background-color:#a6cdfb;color: #2876cf;border-radius:1.25em;text-align: center;margin-bottom:5px">'+rowdata.Status.toUpperCase();+'</div>';
    }
}

function requestNameFormatter(cellValue, options, rowdata, action)
{
    return '<div class="reqsName"><span class="pointer"> '+cellValue+'</span></div>';//No I18N
}

function deployedServersFormatter(cellValue, options, rowdata, action)
{
    if (cellValue === 'Single') {
        return '<div><span class="icon-single-dnsname fontIcon-disable" style="color:#CECECE;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Single Server\',this)" onmouseout="UnTip(this);"</div>';//No I18N
    } else {
    return '<div class="reqsName"><span class="icon-multiple-dnsname" style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Multiple Servers\',this)" onmouseout="UnTip(this);"</div>';//No I18N
    }
    }

function isUsedToSignFormatter(cellValue, options, rowdata, action)
{
    if (cellValue === true) {
        return '<div class="reqsName"><span class="icon-signed-cert" style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\''+I18N.getMsg('js.signed.cert')+'\',this)" onmouseout="UnTip(this);"></div>';//No I18N
    } else {
        return '<div><span class="icon-signed-cert fontIcon-disable" style="color:#CECECE;font-size:16px;cursor:pointer;" ></div>';//No I18N
    }
}

function expiryFormatter(cellValue, options, rowdata, action)
{
    if(rowdata[2] === "yes")
    {
        return '<div><span class="icon-sha-cert" style="color:#f54753;font-size:14px;cursor:pointer" onmouseover="Tip(\'Vulnerable\',this)" onmouseout="UnTip(this);"></div>';//No I18N
    }else if(rowdata[1] === "no")//NO I18N
    {
        return '<div><span class="icon-ssl-cert" style="color:#8B7D6B;font-size:14px;;cursor:pointer" onmouseover="Tip(I18N.getMsg(\'vulnerabilities.button.scan\'),this)" onmouseout="UnTip(this);"></div>';//No I18N
    }else
    {
        return '<div><span class="icon-ssl-cert" style="color: #10bc83;font-size:14px;;cursor:pointer" onmouseover="Tip(\'Not Vulnerable\',this)" onmouseout="UnTip(this);"></div>';//No I18N
    }
}

function letsencryptCertificateFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.CERTIFICATE==="yes")
    {
        return '<div class="pointer">'+cellValue+'</div>';//No I18N
    }
    else
    {
        return '<div>'+cellValue+'</div>';
    }
}

function letsencryptStatusFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.AUTHORIZATION === "yes")
    {
    if(cellValue==="Pending")
    {
        return '<div class="reqClose pointer">Pending</div>';//NO I18N
    }
    else
    {
        return '<div class="">Complete</div>';//NO I18N
    }
}
    else
    {
        if(App.ApplicationController.isAdmin===true)
        {
            return '<span class="pointer" onclick=authorizeRequest(\''+rowdata.REQUEST_ID+'\')>Authorize</span>';//NO I18N
        }
        else
        {
            return '<span>Not Authorized</span>';//NO I18N
        }
    }    
}

function requestStatusFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==='Close')
    {
        return '<div class="">'+I18N.getMsg("js.sslcert.request.processStatusClosed")+'</div>';//No I18N
    }
    else
    {
        return '<div class="reqClose pointer">'+I18N.getMsg("js.commonString.Open")+'</div>';//No I18N
    }
}

function resourceLinkFormatter(cellValue, options, rowdata, action)
{
    if(rowdata.resourceLink===true)
    {
	return '<div class="pointer" onclick="showSSHResourceDetails('+rowdata.ResourceID+');"> '+cellValue+'</div>';//No I18N
    }
    else
    {
        return '<div > '+cellValue+'</div>';//No I18N
    }
    return cellValue;//No I18N
}

function vulStatusFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.Status==="Complete")
    {
        return rowdata.Status;
    }
    else if(rowdata.Status==="Inprogress")
    {
        return "<img src=\"/pki/images/ajax-loader.gif\" alt=\"Inprogress\" height=\"17\" width=\"17\">";
    }
    else 
    {
        return cellValue;
    }
    return cellValue;
}

function vulFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.Status==="Failed")
    {
        return '<div>'+cellValue+'</div>';//No I18N
    }
    else if(rowdata.ID==="-1" && rowdata.IpAddress==="")
    {
        return '<div>'+cellValue+'</div>';//No I18N
    }
    else
    {
        if(rowdata.Flag==="yes")
        {
            return '<div class="pointer" style="color:#f54753 !important" onclick="showVulPopUp('+rowdata.ID+');"> '+cellValue+'</div>';//No I18N 
        }
        else
        {
            return '<div class="pointer" onclick="showVulPopUp('+rowdata.ID+');"> '+cellValue+'</div>';//No I18N 
        }
    }
}

function vulFlagFormatter(cellValue,options,rowdata,action)
{
    if(App.ReportController.scheduleType==="SSLVulnerabilitiesReport")
    {
        if(rowdata.Flag==="yes")
        {
            return '<div class="pointer" style="color:#f54753 !important">'+cellValue+'</div>';//NO I18N
        }
        else
        {
            return cellValue;
        }
    }
}

function domainExpiryFlagFormatter(cellValue,options,rowdata,action)
{
    if(rowdata[10] === 'Expired')//NO I18N
    {
        return '<span style="color: #f84e4e;font-size:14px;" onmouseout="UnTip(this);">'+cellValue+'</span>';//No I18N
    }else if(rowdata[10] === 'Going_To_Expire')//NO I18N
    {
        return '<span style="color:#f69c0e;font-size:14px;"  onmouseout="UnTip(this);">'+cellValue+'</span>';//No I18N
    }else
    {
        return cellValue;
    }
}

function expiryFlagFormatter(cellValue,options,rowdata,action)
{
    if(rowdata[3] === 'Expired')//NO I18N
    {
        return '<span style="color: #f84e4e;font-size:14px;"  onmouseout="UnTip(this);">'+cellValue+'</span>';//No I18N
    }else if(rowdata[3] === 'Going_To_Expire')//NO I18N
    {
        return '<span style="color:#f69c0e;font-size:14px;"  onmouseout="UnTip(this);">'+cellValue+'</span>';//No I18N
    }else
    {
        return cellValue;
    }
}

function isLSFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.isLS!=="-")
    {
        var title = "Landing Server "+rowdata.isLS;//NO I18N
	return '<span class="icon-rs-asland fontIcon-disable" style="color:#000;font-size:16px" onmouseover="Tip(\''+title+'\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
    else
    {
        return '<span class="icon-rs-asland fontIcon-disable" style="color:#CECECE;font-size:16px"></span>';//No I18N
    }
}

function keyLinkFormatter(cellValue, options, rowdata, action)
{
    if(rowdata.keyLink===true)
    {
        
	return '<div class="pointer" onclick="showAssociateMapper(\''+rowdata.KeyName+'\',\''+rowdata.KeyID+'\');"> '+cellValue+'</div>';//No I18N
    }
    else
    {
        return '<div > '+cellValue+'</div>';//No I18N
    }
    return cellValue;//No I18N
}

function moreKeyAssoToUserFormatter(cellValue, options, rowdata, action)
{   
    if(cellValue==="Multiple")
    {
        var user_id=rowdata.UserID;
	return '<a title=\"'+I18N.getMsg("js.AssociatedKeys.MoreKeysAssociatedToAUser.Title")+'\" data-container="body" data-toggle="popover" data-trigger="click" data-placement="right" href="javascript:getAssociatedKeyToUser('+user_id+')"><span class="pointer">'+I18N.getMsg("js.cert.deploy.multiple")+'</span></a>';//No I18N
    }
    return cellValue;//No I18N
}

function showPassPhraseFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.PassPhrase==="roleNotSupported")
    {
        return '';
    }
    if(rowdata.PassPhrase===true)
    {
        return '<a title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" data-container="body" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:getKeyPassPhrase(\''+rowdata.KeyID+'\')"><div class="icon-showpwd fontIcon-disable" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Show Passphrase\',this)" onmouseout="UnTip(this);"></div></a>';//No I18N
    }
    else
    {
        return '<span class="icon-showpwd fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function showSSLVerPassPhraseFormatter(cellValue,options,rowdata,action)
{
    
    if(rowdata.PassPhrase===true)
    {
        return '<a title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" data-container="body" data-content="" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:getSSLVerPassPhrase(\''+rowdata.VersionID+'\')"><div class="icon-showpwd fontIcon-disable" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Show Passphrase\',this)" onmouseout="UnTip(this);"></div></a>';//No I18N
    }
    else
    {
        return '<span class="icon-showpwd fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function showKeyStorePassPhraseFormatter(cellValue,options,rowdata,action)
{
    
    if(rowdata.PassPhrase===true)
    {
        return '<a title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" data-container="body" data-content="" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:getKeyStorePassPhrase(\''+rowdata.EncKeyID+'\')"><div class="icon-showpwd fontIcon-disable" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Show Passphrase\',this)" onmouseout="UnTip(this);"></div></a>';//No I18N
    }
    else
    {
        return '<span class="icon-showpwd fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function showPasswordFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.KEYSTORE_TYPE=="NA")
    {
        return '<a title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" ><div class="icon-showpwd fontIcon-disable" style="font-size:16px;color:#CECECE;" onmouseover="Tip(\'Show Passphrase\',this)" onmouseout="UnTip(this);"></div></a>';//No I18N
    }
    else
    {
        return '<a title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" data-container="body" data-content="" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:getCSRPassword(\''+rowdata.NEWCERTID+'\')"><div class="icon-showpwd" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Show Passphrase\',this)" onmouseout="UnTip(this);"></div></a>';//No I18N        
    }
}

function showLetsEncryptPasswordFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.AUTHORIZATION === "yes")
    {
    return '<a title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" data-container="body" data-content="" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:getLetsEncryptPassword(\''+rowdata.REQUEST_ID+'\')"><div class="icon-showpwd fontIcon-disable" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Show Passphrase\',this)" onmouseout="UnTip(this);"></div></a>';//No I18N
}
    else
    {
        return '<span class="icon-showpwd fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function showGoDaddyPasswordFormatter(cellValue,options,rowdata,action)
{
    
    return '<a title=\"'+I18N.getMsg("js.showpassphrase.title")+'\" data-container="body" data-content="" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:getGoDaddyPassword(\''+rowdata.ID+'\')"><div class="icon-showpwd fontIcon-disable" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Show Passphrase\',this)" onmouseout="UnTip(this);"></div></a>';//No I18N

}

function editCredentialFormatter(cellValue, options, rowdata, action)
{   
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    if (kmpStandAlone)
    {
        if (cellValue === "enabled")
        {
	return '<span class="icon-key" style="color:#000;font-size:18px" onmouseover="Tip(\'Credentials\',this)" onmouseout="UnTip(this);"></span>';//No I18N
        } else
    {
        return '<span class="icon-key" style="color:#929292;font-size:18px;" onmouseover="Tip(\'Apply Credentials\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
    } else {
        return '';
    }
};

function editCertCredentialFormatter(cellValue, options, rowdata, action)
{   
    if (cellValue === "enabled")
    {
	return '<span class="icon-key" style="color:#000;font-size:18px" onmouseover="Tip(\'Credentials\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    } else{
        return '<span class="icon-key" style="color:#929292;font-size:18px;" onmouseover="Tip(\'Apply Credentials\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
};

function sshEnabledFormatter(cellValue, options, rowdata, action)
{   
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    /*if(rowdata.Edit==='enabled')
    {*/
	return '<span class=" icon-usergroup-key-management" style="color:#000;font-size:18px" onmouseover="Tip(\'SSH Users\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    /*}
    else
    {
        return '<span class=" icon-usergroup-key-management" style="color:#CECECE;font-size:18px;"></span>';//No I18N
    }*/
};

function deployFormatter(cellValue, options, rowdata, action)
{   
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    if(rowdata.Edit==='enabled' || !kmpStandAlone)
    {
	return '<span class="icon-deploy deploy" style="color:#000;font-size:18px" onmouseover="Tip(\'Create and deploy\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
    else
    {
        return '<span class="icon-deploy" style="color:#CECECE;font-size:18px;"></span>';//No I18N
    }
};

function sansFormatter(cellValue, options, rowdata, action)
{   
    return '<span class="icon-sudomain" style="color:#000;font-size:16px"></span>';//No I18N
};
function scheduleFormatter(cellValue, options, rowdata, action)
{      
    if(cellValue === "view"){
        return '<span class="pointer">view</span>';//No I18N 
    }
    else{
        return cellValue;//No I18N 
    }
};
function discoveryFormatter(cellValue, options, rowdata, action)
{      
    if(rowdata.Discovery_Status !== "INPROGRESS" && rowdata.Discovery_Status!=='Failure'){
        return '<span class="pointer">'+cellValue+'</span>';//No I18N 
    }
    else{
        if(rowdata.Discovery_Status === "INPROGRESS")
        {
        rowdata.Discovery_Status = "Inprogress";//No I18N
    }
        else{
            rowdata.Discovery_Status = "Failure";//No I18N
        }
        return cellValue;
    }
};
function openTerminalFormatter(cellValue, options, rowdata, action)
{   
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    if(cellValue===true)
    {
	return '<span class="icon-linux" style="color:#000;font-size:16px" onmouseover="Tip(\'Open Connection\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
    else
    {
        return '<span class="icon-linux" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
};

function disassociateFormatter(cellValue, options, rowdata, action)
{   
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    if(cellValue===true)
    {
	return '<span class="icon-disassociate" style="color:#000;font-size:16px" onmouseover="Tip(\'Key Dissociation\',this)" onmouseout="UnTip(this);" ></span>';//No I18N
    }
    else
    {
        return '<span class="icon-disassociate" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
};

function authFileFormatter(cellValue,options,rowdata,action)
{
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    if(rowdata.isDissociate===true)
    {
	return '<span class="icon-add-cmd" style="color:#000;font-size:16px" onmouseover="Tip(\'Add Command\',this)" onmouseout="UnTip(this);" ></span>';//No I18N
    }
    else
    {
        return '<span class="icon-add-cmd" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function associationGraphFormatter(cellValue,options,rowdata,action)
{
    if(rowdata.isDissociate===true)
    {
	return '<div class="pointer" onclick="userAssociationGraph(\''+rowdata.ResourceName+'\',\''+rowdata.UserID+'\');"> '+cellValue+'</div>';//No I18N
        
    }
    else
    {
        return '<div > '+cellValue+'</div>';//No I18N
    }
    return cellValue;
};

function connectFormatter(cellValue, options, rowdata, action)
{   
    return '<span class="icon-linux" style="color:#000;font-size:16px" onmouseover="Tip(\'Open Connection\',this)" onmouseout="UnTip(this);"></span>';//No I18N
};

function AllResourceUserCredentialsFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    if (kmpStandAlone)
    {
        if (cellValue)
        {
	return '<span class="icon-key" style="color:#000;font-size:18px" onmouseover="Tip(\'Credentials\',this)" onmouseout="UnTip(this);"></span>';//No I18N
        } else
    {
        return '<span class="icon-key" style="color:#CECECE;font-size:18px;" onmouseover="Tip(\'Apply Credentials\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }    
    } else {
        return '';
}
}

function auditActionFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==="Terminal")
    {
        if(rowdata[4]===true)
        {
            var audit_id=rowdata[0];
            return '<span class="pointer" onclick="openTerminalAudit('+audit_id+')">Terminal</span>';//NO I18N
    }
    else
    {
        return cellValue;
}
}
    else
    {
        return cellValue;
    }
}

function ipcheckFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==="" || cellValue===undefined || cellValue===null)//No I18N
    {
	return 'NA';//No I18N
    }
    else
    {
        return cellValue;//No I18N
    }    
}

function placeKeyFormatter(cellValue,options,rowdata,action)
{
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    if(rowdata.keyLink===true)
    {
	return '<span class="icon-push-key fontIcon-disable" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Push Key To User\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
    else
    {
        return '<span class="icon-push-key fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function exportKeyFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    var tooltip=I18N.getMsg("js.rolename.EXPORT_KEYS");//No I18N
    if(options.colModel.value=="ExportCSR"){//No I18N
        tooltip=I18N.getMsg("js.export.csr");//No I18N
    }
    return '<span class="icon-export" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\''+tooltip+'\',this)" onmouseout="UnTip(this);"></span>';//No I18N
}

function importCertFormatter(cellValue, options, rowdata, action)
{
    if (window.userRole === "Administrator") {
        if (cellValue === "roleNotSupported")
        {
            return '';
        }
        if(rowdata.KEYSTORE_TYPE=="NA")
        {
            return '<span class="icon-import fontIcon-disable" style="font-size:16px;color:#CECECE;" onmouseover="Tip(\'' + I18N.getMsg("js.csr.import.certificate") + '\',this)" onmouseout="UnTip(this);"></span>';//No I18N
        }
        else
        {
            return '<span class="icon-import importCertForCSR" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'' + I18N.getMsg("js.csr.import.certificate") + '\',this)" onmouseout="UnTip(this);"></span>';//No I18N
        }
    } else {
        return '';
    }
}

function exportKeyFormatterSSLVer(cellValue, options, rowdata, action)
{
    if(rowdata.PassPhrase === true)
    {
        return '<a title=\"'+I18N.getMsg("js.general.export")+'\" data-container="body" data-content="" data-toggle="popover" data-trigger="click" data-placement="left" href="javascript:exportSSLverkey(\''+rowdata.VersionID+'\')"><div class="icon-export fontIcon-disable" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Export\',this)" onmouseout="UnTip(this);"></div></a>';//No I18N
    }
    else
    {
        return '<div onclick="exportSSLVerCert(\''+rowdata.VersionID+'\')" class="icon-export" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Export\',this)" onmouseout="UnTip(this);"></div>';//No I18N
    }
}

function setAsMainCertFormatter(cellValue, options, rowdata, action)
{
    if(rowdata.Main === "false")
    {
        return '<a data-original-title=" " data-container="body" data-toggle="popover" data-trigger="click" data-placement="bottom" href="javascript:manageCertificate('+rowdata.VersionID+')"><div class="icon-setdefault fontIcon-disable" style="font-color:black;font-size:16px;" title="'+"Certificate Settings"+'"></div>';//No I18N
    }
    else
    {
        return '<span class="icon-setdefault" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function manageCertificate(cert_id)
{
    var div = $('<div id="kmp_popover">').append($('<ul><li onclick="setAsMainCert('+cert_id+')"><a style="cursor:pointer">'+I18N.getMsg("setasmaincert.title")+'</a></li><li onclick="manageVersionCertificate('+cert_id+')"><a style="cursor:pointer">'+I18N.getMsg("manage.versioncert.title")+'</a></li></ul>'));//No I18N
    $('.popover-content').attr('style', 'padding:0px !important')//No I18N
    var left = $(".popover").offset().left-105;
    var top = $(".popover").offset().top-25;
    $(".popover").css("left", left+"px")//No I18N
    $(".popover").css("top", top+"px")//No I18N
    $(".popover-content").html(div)//No I18N
    $(".popover-title").hide();
    $(".arrow").hide();//No I18N
    setTimeout(function () {
            $('.popover').popover('hide');//NO I18N
        }, 5000);
}

function updateEncKeyFormatter(cellValue, options, rowdata, action)
{
    return '<div class="updateEncKey"><span class="icon-kmp-edit" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Update Key\',this)" onmouseout="UnTip(this);"></span></div>';//No I18N
}
function versionEncKeyFormatter(cellValue, options, rowdata, action)
{
    return '<span class="icon-key-version" style="cursor:pointer;font-size:16px;" onmouseover="Tip(\'Key Version\',this)" onmouseout="UnTip(this);"></span>';//No I18N
}

function statusFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==="SUCCESS" || cellValue==="Success")
    {
        return '<span class="label label-success" style="cursor:pointer;">Success</span>';//No I18N
    }
    else
    {
        return '<span class="label label-danger" style="cursor:pointer;padding:3px 11px;">Failed</span>';//No I18N
    }
}

function isPassPhraseFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==="true")
    {
	return '<span class="icon-key" style="font-color:black;font-size:16px;"></span>';//No I18N
    }
    else
    {
        return '<span class="icon-key" style="font-color:gray;font-size:16px;"></span>';//No I18N
    }    
}

function isKeyStoreFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==true)
    {
        var id=rowdata[0];
        if(id==undefined){
            id=rowdata.ResourceID;
    }
	return '<a data-original-title=" " data-container="body" data-toggle="popover" data-trigger="click" data-placement="bottom" href="javascript:keyStoreActionMenu('+id+')"><div class="icon-cer-privatekey fontIcon-disable" style="font-color:black;font-size:16px;" onmouseover="Tip(\''+I18N.getMsg("js.cert.keystore")+'\',this)" onmouseout="UnTip(this);"></div>';//No I18N
    }
    else
    {
        return '<span class="icon-cer-privatekey fontIcon-disable" style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }    
}

function checkbox_audit_formatter(cellValue,options,rowdata,action)
{
    if(cellValue===true)
    {
        return '<input type="checkbox" audit_type='+rowdata.audit_type+' value='+rowdata.id+' style="margin-left:30px" name="'+options.colModel.name+'[]" checked>';//NO I18N
    }
    else
    {
        return '<input type="checkbox" audit_type='+rowdata.audit_type+' value='+rowdata.id+' style="margin-left:30px" name="'+options.colModel.name+'[]">';//NO I18N
    }
}

function keyStoreActionMenu(cert_id)
{
    var reqUrl="/api/pki/request/getKeystoreType";//No I18N
    var reqparams="cert_id="+cert_id;//NO I18N
    getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
        if(jsonData.isSHARED!=undefined){
            var isShared=jsonData.isSHARED;
            var div  = $('<div id="kmp_popover">').append($('<ul><li><a href="javascript:requestCertPrivatekey('+cert_id+')">'+I18N.getMsg("pki.js.request.keyfromowner")+'</a></li></ul>'));//No I18N
        }else{
        if(jsonData.keyStoreType!="Key")
        {
             var div = $('<div id="kmp_popover">').append($('<ul onclick="closepopover();"><li><a href="/api/pki/Inventory/exportCertPrivateKey?certId='+cert_id+'&destStoreType=jks">'+I18N.getMsg("js.export.keystore/jks")+'</a></li><li><a href="/api/pki/Inventory/exportCertPrivateKey?certId='+cert_id+'&destStoreType=pkcs12">'+I18N.getMsg("js.export.pkcs12/pfx")+'</a></li><li><a href="/api/pki/Inventory/exportCertPrivateKey?certId='+cert_id+'&privateKey=true">'+I18N.getMsg("js.export.privatekey")+'</a></li></ul>'));//No I18N
        }
        else
        {
             var div = $('<div id="kmp_popover">').append($('<ul onclick="closepopover();"><li><a style="color: #CECECE;">'+I18N.getMsg("js.ssl.KeyStoreorPFX")+'</a></li><li><a href="/api/pki/Inventory/exportCertPrivateKey?certId='+cert_id+'&privateKey=true">'+I18N.getMsg("js.export.privatekey")+'</a></li></ul>'));//No I18N
        }
        
    }
        
        $('.popover-content').attr('style', 'padding:0px !important;')//No I18N
//        var left = $(".popover").offset().left-135;
//        var top = $(".popover").offset().top-25;
//        $(".popover").css("left", left+"px")//No I18N
//        $(".popover").css("top", top+"px")//No I18N
        $(".popover").css("margin-left","-140px");//No I18N
        $(".popover-content").html(div)//No I18N
        $(".popover-title").hide();
        $(".arrow").hide();//No I18N
    });
}
function closepopover(){
    $("#kmp_popover").hide();
}
function requestCertPrivatekey(cert_id)
{
     var reqUrl="/api/pki/Inventory/requestCertPrivatekey";//No I18N
    var reqparams="certId="+cert_id;//NO I18N
    ajaxapicall(reqUrl,reqparams+"&pmpcp="+Get_Cookie('pmpcc'),true,"");//NO I18N
}

function approveOrRejectPrivateKeyRequest(cellValue,options,rowdata,action)
{
    if(cellValue=="approve")
    {
        return '<a class="hand grant" style="margin-left:-9px;" href="javascript:approveOrRejectRequest('+rowdata.CertId+','+rowdata.requesterLoginId+',true)">'+I18N.getMsg("js.request.approve")+'</a>';//No I18N
    }
    else
    {
        return '<a class="hand revoke" style="margin-left: -9px;" href="javascript:approveOrRejectRequest('+rowdata.CertId+','+rowdata.requesterLoginId+',false)">'+I18N.getMsg("pki.js.request.reject")+'</a>';//No I18N
    }
}
function approveOrRejectRequest(certId,requestedUserId,isApprove){
    var ajaxapirequest="/api/pki/Inventory/approveCertPrivatekeyAccessByOwner";//NO I18N
    var reqParams='certId='+certId+'&requestedUserId='+requestedUserId+'&pmpcp='+Get_Cookie('pmpcc')+'&isApprove='+isApprove;//NO I18N
    getAjaxApiRequest(ajaxapirequest,reqParams,function(jsonData){
            if(jsonData.Status==="Success")//No I18N
            {
                messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                {{App.Inventory.getCertificatePrivateKeyAccessRequestsList();}}
                $('#PKICertRequest').trigger('reloadGrid'); //No I18N
}
            else
            {
                messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
            }
        });        
}
function grantRevokeCert(cellValue, options, rowdata, action)
{
    if(cellValue==='Share'){
    return '<button onclick="shareCertToUsersClick(\''+options.rowId+'\',\''+rowdata.shareType+'\');" class="hand grant"  style="cursor:pointer;background-color: #fff;">Share</button>';//No I18N
    }else{
        return '<button onclick="revokeCertsFromUsersClick(\''+options.rowId+'\',\''+rowdata.shareType+'\');" class="hand revoke"  style="cursor:pointer;background-color: #fff;">Revoke</button>';//No I18N
    }
}
function shareCertToUsersClick(rowId,shareType){
    if(!($('#jqg_PKIShareCertToUserDIV_'+rowId).is(":checked"))){
    $("#PKIShareCertToUserDIV").setSelection(rowId);
	}
    if (shareType == 'cert-users') {
        document.getElementById("shareCertToUsersDiv").click();
    } else if (shareType == 'cert-usergroups') {
        document.getElementById("shareCertToUserGroupsDiv").click();
    } else if (shareType == 'certgroup-users') {
        document.getElementById("shareCertGroupToUsersDiv").click();
    } else if (shareType == 'certgroup-usergroups') {
        document.getElementById("shareCertGroupToUserGroupsDiv").click();
    }
}
function revokeCertsFromUsersClick(rowId,shareType){
    if(!($('#jqg_PKIShareCertToUserDIV_'+rowId).is(":checked"))){
    $("#PKIShareCertToUserDIV").setSelection(rowId);
	}
    if (shareType == 'cert-users') {
        document.getElementById("revokeCertFromUsersDiv").click();
    } else if (shareType == 'cert-usergroups') {
        document.getElementById("revokeCertFromUserGroupsDiv").click();
    } else if (shareType == 'certgroup-users') {
        document.getElementById("revokeCertGroupFromUsersDiv").click();
    } else if (shareType == 'certgroup-usergroups') {
        document.getElementById("revokeCertGroupFromUserGroupsDiv").click();
    }
}
function editFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    return '<span class="icon-kmp-edit" style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Edit\',this)" onmouseout="UnTip(this);"></span>';//No I18N
}

function certHistoryFormatter(cellValue, options, rowdata, action)
{
    return '<span class="icon-ssl-history" style="font-color:black;font-size:18px;cursor:pointer;" onmouseover="Tip(\'Certificate History\',this)" onmouseout="UnTip(this);"></span>';//No I18N
}

function editPathFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==="roleNotSupported")
    {
        return '';
    }
    return '<span class="icon-path-edit " style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Edit User Path\',this)" onmouseout="UnTip(this);"></span>';//No I18N
}

function editLSFormatter(cellValue,options,rowdata,action)
{
    return '<span class="icon-kmp-edit " style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Edit\',this)" onmouseout="UnTip(this);"></span>';//No I18N
}

function editAuthFileFormatter(cellValue,options,rowdata,action)
{
    var credential = rowdata.isCredAvailable;
    var isdiss = rowdata.isDissociate;
    if(credential || isdiss)
    {
        return '<span class="icon-kmp-edit " style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Edit Key Authorization File\',this)" onmouseout="UnTip(this);"></span>';//No I18N
    }
    else
    {
        return '<span class="icon-kmp-edit " style="color:#CECECE;font-size:16px;"></span>';//No I18N
    }
}

function scheduleEnableDisableFormatter(cellValue, options, rowdata, action)
{
    if(cellValue==3)
    {
            return '<span class="glyphicon glyphicon-ok" style="color:gray;font-size:12px;"></span>';//No I18N
    }
    else if(cellValue==4)
    {
            return '<span class="glyphicon glyphicon-remove" style="color:#CECECE;font-size:12px;"></span>';//No I18N
    }
}

function eMailFormatter(cellValue, options, rowdata, action)
{
    return '<div class="mailcsrContent"><span class="icon-mail" style="font-color:black;font-size:16px;cursor:pointer;" onmouseover="Tip(\'Mail\',this)" onmouseout="UnTip(this);"></span></div>';//No I18N
}

var isAutoRefresh=false;
function progressStatusFormatter(cellValue, options, rowdata, action)
{
    if(cellValue=='INPROGRESS')//No I18N
    {
        //isAutoRefresh=true;
        return '<img src="/pki/images/ajax-loader.gif" alt="Inprogress" height="20" width="20">';//No I18N
    }
    else if(cellValue.toLowerCase()=='success')//No I18N
    {
        return '<img src="/pki/images/success.png" alt="Inprogress" height="20" width="20">';//No I18N
    }
    else
    {
        return '<img src="/pki/images/failure.png" alt="Inprogress" height="17" width="17">';//No I18N
    }
}

function changePrimAdditional(source, destination) {
	$("#"+source).css('display','none'); //No I18N
	$("#"+destination).css('display','block'); //No I18N
}

function changePrimAdditional1(source1,source2,destination) {
	$("#"+source1).css('display','none'); //No I18N
        $("#"+source2).css('display','none'); //No I18N
	$("#"+destination).css('display','block'); //No I18N
}

function changePrimAdditional(source, destination,matching,view) {
	$("#"+source).css('display','none'); //No I18N
	$("#"+destination).css('display','block'); //No I18N
        $("#"+matching).css('display',view); //No I18N
}
//Link to Device Summary
function addCriteriaToDeviceGroup(rowId)//No I18N
{
	var parameterMap = App.InventoryListDetailsController.parameterMap;
    var conditionMap = App.InventoryListDetailsController.conditionMap;
    var comparatorMap = App.InventoryListDetailsController.comparatorMap;
    var maxId = 1;
    var currentRow ;
    $("#critetriaTable").find('tr').each(function (i, el) {
		var id = $(this).attr("id");
		if(maxId < id) {
			maxId = id;
		} 
		if(id == rowId) {
			currentRow = $(this);
		}
	});
    maxId++;
    
    $row =  $('<tr id="'+maxId+'" style="height: 45px;"></tr>');//No I18N
    $td = $("<td width='100px' align='left'></td>");//No I18N
    $select = $('<select name="COMPARATOR_'+maxId+'" style="width: 80px;" id="COMPARATOR_'+maxId+'" class="form-control"></select>');//No I18N
    for (var i = 0; i < comparatorMap.length; i++) {
    	$select.append($('<option value="'+ comparatorMap[i].value +'">'+ comparatorMap[i].name +'</option>'));  //No I18N
	}
    $td.append($select);
    $row.append($td);
    $parameter = $("<td width='200px' align='left'></td>");//No I18N
    $selectparameter = $('<select onchange="checkConditions(this)" name="PARAMETER_'+maxId+'" style="width: 180px;" id="PARAMETER_'+maxId+'" class="form-control"></select>');//No I18N
    for (var i = 0; i < parameterMap.length; i++) {
    	$selectparameter.append($('<option value="'+ parameterMap[i].Key +'">'+ parameterMap[i].Value +'</option>'));  //No I18N
	}
    $parameter.append($selectparameter);
    $row.append($parameter);
    $comparator = $("<td width='200px' align='left'></td>");//No I18N
    $selectcondition = $('<select name="CONDITION_'+maxId+'" style="width: 180px;" id="CONDITION_'+maxId+'" class="form-control"></select>');//No I18N
    for (var i = 0; i < conditionMap.length; i++) {
    	$selectcondition.append($('<option value="'+ conditionMap[i].Key +'">'+ conditionMap[i].Value +'</option>'));  //No I18N
	}
    $comparator.append($selectcondition);
    $row.append($comparator);
    $valueField = $("<td width='200px' align='left'></td>");//No I18N
    $valueField.append($('<input id="PATTERN_'+maxId+'" type="text" style="width:180px !important;" class="form-control">'));//No I18N
    $row.append($valueField);
    $closeField = $("<td width=50px align='left'></td>");//No I18N
    $closeField.append($('<div><span onmouseover="Tip(\'Delete Criteria\',this)" onmouseout="UnTip(this);" onclick="deleteCriteriaToDeviceGroup('+maxId+');" class="glyphicon glyphicon-remove pointer"></span></div>'));//No I18N
    $row.append($closeField);
    $addCriteria = $("<td align='left'></td>");//No I18N
    $addCriteria.append($('<div><span onmouseover="Tip(\'Add Criteria\',this)" onmouseout="UnTip(this);" onclick="addCriteriaToDeviceGroup('+maxId+');" class="glyphicon glyphicon-plus pointer"></span></div>'));//No I18N
    $row.append($addCriteria);
    currentRow.after($row);
}

//Link to Device Summary
function deleteCriteriaToDeviceGroup(rowId)//No I18N
{
	var currentRow ;
	$("#critetriaTable").find('tr').each(function (i, el) {
		var id = $(this).attr("id");
		if(id == rowId) {
			currentRow = $(this);
		}
	});
	currentRow.remove();
}

function openTerminalAudit(audit_id)
{
    App.AuditCommonController.audit_id=audit_id;
    document.getElementById("terminalAuditShow").click();    
}

function showSelectedCredentialType(type)
{
    $("#login_password").hide();
    $("#key_file_div").hide();
    $("#select_key").hide();
    if(type==="password_based")
    {
        $("#login_password").show();
    }
    else if(type==="key_based")
    {
        $("#key_file_div").show();
    }
    else
    {
        $("#select_key").show();
        var reqUrl="/api/pki/ssh/getkeyslist";//No I18N
        getAjaxApiRequest(reqUrl,"",function(jsonData){
            var key_array=jsonData.keyList;
            if(key_array.length>0)
            {
                var sel=document.getElementById("listofcredentialkeys");//No I18N
                sel.innerHTML="";
                for (var i=0; i<key_array.length; i++)
                {
                    var opt=document.createElement('option');//No I18N
                    opt.innerHTML = key_array[i].KeyName;
                    opt.value = key_array[i].KeyId;
                    sel.appendChild(opt);
                }
            }
        });
    }
}
