// $Id$
/* Settings Routes */
var treeObj=null;
App.SettingsRoute = Ember.Route.extend({
	setupController: function(controller) {
            if(kmpStandAlone)
            {
            getMenusForSideView("Settings");//No I18N
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
            }
	},
	model: function(params) {
            App.SettingsCommonController.selectedTab = "user"; //No I18N
            return this.modelFor('Settings'); //No I18N
	},
	renderTemplate: function() {
        if(kmpStandAlone){
               this.render('Settings',{into: 'application', outlet: 'details'});//No I18N
            }
            else{
                //localStorage.setItem("currentView","Schedule/All");	//NO I18N
                this.render({ outlet: 'keyInfo'});//No I18N
            }   
}
});

App.SDPRoute = Ember.Route.extend({   
    beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "cmdb"; //No I18N
            App.SettingsCommonController.selectedCMDBTab = "server"; //No I18N
	},
        setupController: function(controller) {
            controller.set('content', App.Settings.getSDPTabList());  //No I18N             
             if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
        }else{
            selectKMPTab("sdpinteg");//NO I18N
        }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
               this.render('SDP',{into: 'Settings', outlet: 'settings'});//No I18N
            }
            else{
                this.render('SDP',{ outlet: 'keyInfo'});//No I18N
            }   
        } 
});

App.SettingsAllRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole==="Administrator")
            {
                this.transitionTo('Settings.UserManagement');//No I18N
            }
            else
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "user"; //No I18N
            return this.modelFor('Settings'); //No I18N
	},
	setupController: function(controller) {
		controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render({into: 'application', outlet: 'details'});} //No I18N
});

App.SettingsUserManagementRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "user"; //No I18N
            return this.modelFor('Settings'); //No I18N
	},
	setupController: function(controller) {
            todisplayMenus(App.ApplicationController.viewMenus,"Settings");//No I18N
        controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('UserManagement',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsLetsEncryptRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "lets"; //No I18N
            return this.modelFor('Settings'); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('LetsEncrypt',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsCreateUserRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "user"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('CreateUser',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsRadiusServerRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "radius"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('RadiusServer',{into: 'Settings',outlet: 'settings'});} //No I18N
});


App.SettingsUpdateUserRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsUserController.user_id=params.user_id;
            App.SettingsCommonController.selectedTab = "user"; //No I18N
            return this.modelFor('Settings'); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('UpdateUser',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsRolesRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsUserController.roleId="";
            App.SettingsCommonController.selectedTab = "roles"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('Roles',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsChangePasswordRoute = Ember.Route.extend({
	model: function(params) {
            App.SettingsCommonController.selectedTab = "change_password"; //No I18N
            return this.modelFor('Settings'); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('ChangePassword',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsProxyRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "proxy"; //No I18N
            return this.modelFor('Settings'); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('ProxySetting',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsMailServerRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
        model: function(params) {
            App.SettingsCommonController.selectedTab = "mail"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('MailServer',{into: 'Settings',outlet: 'settings'});} //No I18N
});
App.SettingsSNMPRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
        model: function(params) {
            App.SettingsCommonController.selectedTab = "snmp"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('SNMP',{into: 'Settings',outlet: 'settings'});} //No I18N
});
App.SettingsSyslogRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
        model: function(params) {
            App.SettingsCommonController.selectedTab = "syslog"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('Syslog',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsADAuthRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "ad_auth"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('ADAuthentication',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsPolicyRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "policy"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
        }else{
            selectKMPTab("policy_config");//NO I18N
        }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
               this.render('Policy',{into: 'Settings',outlet: 'settings'});//No I18N
            }
            else{
                this.render('Policy',{ outlet: 'keyInfo'});//No I18N
            }   
        } 
});
App.NotificationRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "notify_policy"; //No I18N
            return this.modelFor('Settings'); //No I18N
	},
	setupController: function(controller) {
            if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
            }else{
            selectKMPTab("notification_policy");//NO I18N
            }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
               this.render('Notification',{into: 'Settings',outlet: 'settings'});//No I18N
            }
            else{
                this.render('Notification',{ outlet: 'keyInfo'});//No I18N
            }   
        }
});

App.NotificationNotificationPolicyRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "notify_policy"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
        }else{
            selectKMPTab("notification_policy");//NO I18N
        }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
               this.render('NotificationPolicy',{into: 'Notification',outlet: 'notification'});//No I18N
            }
            else{
                this.render('NotificationPolicy',{ outlet: 'keyInfo'});//No I18N
            }   
} 
});
App.NotificationNotificationAuditRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "notify_audit"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
        }else{
            selectKMPTab("notification_policy");//NO I18N
        }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
               this.render('NotificationAudit',{into: 'Notification',outlet: 'notification'});//No I18N
            }
            else{
                this.render('NotificationAudit',{ outlet: 'keyInfo'});//No I18N
            }   
} 
});
App.SettingsBackupDBRoute = Ember.Route.extend({
	model: function(params) {
            App.SettingsCommonController.selectedTab = "backupDB"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('BackupDB',{into: 'Settings',outlet: 'settings'});} //No I18N
});
App.SettingsClientConfigRoute = Ember.Route.extend({
	model: function(params) {
            App.SettingsCommonController.selectedTab = "dash"; //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('ClientConfig',{into: 'Settings',outlet: 'settings'});} //No I18N
});
App.SettingsApiKeyRoute = Ember.Route.extend({
	model: function(params) {
            App.SettingsCommonController.selectedTab = "apiKey"; //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('apiKeyGeneration',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsSSLVulnerabilitiesRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "vulnerabilities"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
        }else{
            selectKMPTab("ssl_vulnerabilities");//NO I18N
        }
	},
	renderTemplate: function() {
             if(kmpStandAlone){
               this.render('VulnerabilitiesSettings',{into: 'Settings',outlet: 'settings'});//No I18N
            }
            else{
                this.render('VulnerabilitiesSettings',{ outlet: 'keyInfo'});//No I18N
            }   
        } 
});

App.SettingsServerCertificateRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "certificate"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('ServerCertificate',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsMSCASettingsRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "generalSettings"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
        }else{
            selectKMPTab('msca');//No I18N 
        }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
            this.render('GeneralSettings',{into: 'Settings',outlet: 'settings'}); //No I18N
        }else{
            this.render('GeneralSettings'); //No I18N
        }
        } 
});

App.SettingsMETrackerRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "METracker"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('METracker',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsDomainExpiryDataRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "domainexpiry"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('DomainExpiryData',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsPurgeAuditRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "PurgeAudit"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('PurgeAudit',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsPIIDataRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "PIIData"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('PIIData',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsUnMappedMailsRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "unmappedmails"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('UnMappedMails',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SettingsExportSettingsRoute = Ember.Route.extend({
        beforeModel: function() {
            
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "ReportsPassword"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
	},
	renderTemplate: function() {this.render('ReportsPassword',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SDPCMDBRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "cmdb"; //No I18N
            App.SettingsCommonController.selectedCMDBTab = "cmdbcerts"; //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSDPTabList());  //No I18N             
            if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
        }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
            this.render('CMDB',{into: 'SDP',outlet: 'sdpconfig'}); //No I18N
        }else{
             this.render('CMDB',{into: 'KMPSDPSettings',outlet: 'sdpconfig'}); //No I18N
        }
    }
});

App.SDPSDPServerRoute = Ember.Route.extend({
        beforeModel: function() {
            if(window.userRole!=="Administrator")
            {
                this.transitionTo('Settings.ChangePassword');//No I18N
            }
        },
	model: function(params) {
            App.SettingsCommonController.selectedTab = "cmdb"; //No I18N
            App.SettingsCommonController.selectedCMDBTab = "server"; //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSDPTabList());  //No I18N             
            if(kmpStandAlone){
            controller.set('content', App.Settings.getSettingsTabList());  //No I18N 
        }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
            this.render('SDPServer',{into: 'SDP',outlet: 'sdpconfig'});//No I18N
        }else{
             this.render('SDPServer',{into: 'KMPSDPSettings',outlet: 'sdpconfig'}); //No I18N
        }
        }
})

App.SettingsBackupScheduleAuditRoute = Ember.Route.extend({
	model: function(params) {
            App.SettingsCommonController.selectedTab = "backupDB"; //No I18N
            return this.modelFor("Settings"); //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getBackupScheduleAuditList());  //No I18N 
	},
	renderTemplate: function() {this.render('backupScheduleAudit',{into: 'Settings',outlet: 'settings'});} //No I18N
});

App.SSHMgmtCreateSSHKeyRoute = Ember.Route.extend({
	setupController: function(controller) {
	},
	renderTemplate: function() {
        if(kmpStandAlone){
                this.render('CreateSSHKey',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
            }
            else{
                this.render('CreateSSHKey',{ outlet: 'keyInfo'});//No I18N
                localStorage.setItem("currentView","SSHMgmt/CreateSSHKey");//NO I18N
            }   
        } //No I18N
});

App.SSHMgmtRoute = Ember.Route.extend({
	model: function(params) {
            App.SettingsCommonController.selectedTab = "devices"; //No I18N
            if(kmpStandAlone  || isKMPLicPropInPMP){
            return getMenusForSideView("SSH");//No I18N
        }
	},
	setupController: function(controller) {
            if(kmpStandAlone  || isKMPLicPropInPMP){
            controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
            }
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('SSHMgmtMainTabs',{into: 'application', outlet: 'details'});//No I18N
            }
            else{
                this.render('SSHMgmtMainTabs',{ outlet: 'keyInfo'});//No I18N
            }   
        } 
});

App.SSHMgmtKeysRoute = Ember.Route.extend({
        beforeModel: function() {
            localStorage.setItem("prevViewName",I18N.getMsg("js.ssh.title"));//No I18N
            if(kmpStandAlone){
                App.DashboardDetailsController.gtype="AllResourceUsers";//No I18N
                if(window.userRole!=="Administrator")
                {
                    this.transitionTo('SSHMgmt.SSH');//No I18N
                }
            }
        },    
	model: function(params) {
            App.SettingsCommonController.selectedTab = "keys"; //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('SSHKeys',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
            }
            else{
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
                    App.SettingsCommonController.set("pmpDashHideKeyOptions",true);//No I18N
                    this.render('SSHKeys',{ outlet: 'keyInfo'});//No I18N
                }   
                else
                {
                    App.SettingsCommonController.set("pmpDashHideKeyOptions",false);//No I18N
                    this.render('SSHKeys',{ outlet: 'kmpdashboard'});//No I18N
                }
            }   
        }
});
            
App.SSHMgmtAllUsersRoute = Ember.Route.extend({
	model: function(params) {
            App.InventoryListDetailsController.deploy=false;
            App.SettingsCommonController.selectedTab = "all_users"; //No I18N
	},
	setupController: function(controller) {
            controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
	},
	renderTemplate: function() {
            if(kmpStandAlone){
                this.render('AllResourceUsers',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
            }
            else{
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
                selectKMPTab("ssh_users");//NO I18N
                this.render('AllResourceUsers',{ outlet: 'keyInfo'});//No I18N
            }   
                else
                {
                    this.render('AllResourceUsers',{ outlet: 'kmpdashboard'});//No I18N
                }
            }   
        } //No I18N
});

App.SSHMgmtLandingServerConfigRoute = Ember.Route.extend({
        model: function(params) {
            App.SettingsCommonController.selectedTab = "ls"; //No I18N
        },
	setupController: function(controller) {
            controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
	},
        renderTemplate: function() {this.render('LandingServerConfig',{into: "SSHMgmtMainTabs",outlet: "keyInfo"});} //No I18N
});

App.SSHMgmtLandingServerAssociationRoute = Ember.Route.extend({
        model: function(params) {
            App.InventoryController.lsid=params.lsid;
            App.SettingsCommonController.selectedTab = "ls"; //No I18N
        },
	setupController: function(controller) {
            controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
	},
        renderTemplate: function() {this.render('LandingServerAssociation',{into: "SSHMgmtMainTabs",outlet: "keyInfo"});} //No I18N
});

App.SSHMgmtDiscoveredKeysRoute = Ember.Route.extend({
    model: function(params) {
        App.SettingsCommonController.selectedTab = "dis_keys"; //No I18N
    },
    setupController: function(controller) {
        controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('AllUsersKeys',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('AllUsersKeys',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.SSHMgmtUsersGroupRoute = Ember.Route.extend({
    model: function(params) {
       // App.SettingsCommonController.selectedTab = "all_users"; //No I18N
    },
    setupController: function(controller) {
       // controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('UsersGroup',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('UsersGroup',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.SSHMgmtKeysGroupRoute = Ember.Route.extend({
    model: function(params) {
        App.SettingsCommonController.selectedTab = "keys"; //No I18N
    },
    setupController: function(controller,model) {
        controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('KeysGroup',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('KeysGroup',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.SSHMgmtKeysGroupKeysRoute = Ember.Route.extend({
    model: function(params) {
        App.SettingsCommonController.selectedTab = "keys"; //No I18N
        App.SettingsUserController.kGroupId = params.kgid;
        localStorage.setItem("prevViewName",I18N.getMsg("js.ssh.title"));//No I18N
    },
    setupController: function(controller) {
        controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('KeysGroupKeys',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('KeysGroupKeys',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.SSHMgmtUsersGroupUsersRoute = Ember.Route.extend({
    model: function(params) {
        App.SettingsCommonController.selectedTab = "all_users"; //No I18N
        App.SettingsUserController.kGroupId = params.ugid;
    },
    setupController: function(controller) {
        controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('UsersGroupUsers',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('UsersGroupUsers',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.SSHMgmtUsersGroupRoute = Ember.Route.extend({
    model: function(params) {
        App.SettingsCommonController.selectedTab = "all_users"; //No I18N
    },
    setupController: function(controller) {
        controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
    },
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('UsersGroup',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('UsersGroup',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.SSHMgmtAddKeysGroupRoute = Ember.Route.extend({
        model: function(params) {
            App.SettingsUserController.kGroupId=params.kgid;
            App.SettingsCommonController.selectedTab = "keys"; //No I18N
        },
        setupController: function(controller,model){
            controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
        },       
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('AddKeysGroup',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            selectKMPTab("key_group");//NO I18N
            this.render('AddKeysGroup',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.SSHMgmtAddUsersGroupRoute = Ember.Route.extend({
        model: function(params) {
            App.SettingsUserController.kGroupId=params.ugid;
            App.SettingsCommonController.selectedTab = "all_users"; //No I18N
        },
        setupController: function(controller,model){
            controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
        },       
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('AddUsersGroup',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('AddUsersGroup',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.SSHMgmtKeyRotationAuditRoute = Ember.Route.extend({
    model: function(params) {
        App.SettingsCommonController.keyStateId = params.keyStateId;
        return {keyStateId : params.keyStateId};
	},
	setupController: function(controller,model) {
            if(model.keyStateId==="1")
            {
                localStorage.setItem("prevViewName",I18N.getMsg("js.KeyAssociationAudit.title"))//No I18N
                controller.set('content',I18N.getMsg("js.KeyAssociationAudit.title"));//No I18N
            }
            else
            {
                localStorage.setItem("prevViewName",I18N.getMsg("js.KeyRotationAudit.title"))//No I18N
                controller.set('content',I18N.getMsg("js.KeyRotationAudit.title"));//No I18N
            }
            App.SettingsCommonController.selectedTab = "keys"; //No I18N
            App.Settings.getSSHMgmtTabList();  //No I18N 
	},
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('KeyRotationAudit',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('KeyRotationAudit',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});
App.SSHMgmtKeyAssociationAuditRoute = Ember.Route.extend({
    model: function(params) {
        App.SettingsCommonController.keyStateId=1;        
        localStorage.setItem("prevViewName",I18N.getMsg("js.KeyAssociationAudit.title"))//No I18N
    },
    setupController: function(controller,model) {
        controller.set('content',I18N.getMsg("js.KeyAssociationAudit.title"));//No I18N
    },
    renderTemplate: function() {    
        this.render('KeyRotationAudit',{ outlet: 'keyInfo'});//No I18N
    }
});

var keyRotatAuditId=0;
App.SSHMgmtDetailedKeyRotationAuditRoute = Ember.Route.extend({
    model: function(params) {
            App.ApplicationController.getBack=localStorage.getItem("prevViewName");//No I18N
            keyRotatAuditId=params.keyRotationAuditId;
		return {keyRotationAuditId : params.keyRotationAuditId}; //No I18N
        },
        setupController: function(controller,model) {
            var params='keyRotationAuditId='+model.keyRotationAuditId;//NO I18N
            displayKeyRotationAuditStatus(params);  //No I18N
            autoReloadGrid(displayKeyRotationAuditStatus,params,'KeyRotationStatusDetailsList');//No I18N
	},
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('DetailedKeyRotationAudit',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('DetailedKeyRotationAudit',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

function getPopoverHelpStyle(content,template,id){
    $(".certDeplyClass").popover({
        'template': getPopoverCustomTemplate(template)//No I18N
    });
    $(".certDeplyClass").attr('data-content', content);
    if(id!==undefined)
    {
        $('.certDeplyClass#'+id).popover('show');
    }
    else
    {
    $('.certDeplyClass').popover('show');
    }
    setTimeout(function(){
         $(".popover-title").append('<span id="popovercloseid" class="close">&times;</span>');
        $('.popover-content').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});$(".arrow").hide();
    },10);    
}

App.PolicyConfigView = Ember.View.extend({
    templateName: 'PolicyConfig',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("js.ssh.policySetting.title"));//NO I18N
        App.Settings.getPolicyConfig();
    }
});

App.PolicyConfigController = Ember.ObjectController.extend({
    needs:["SettingsPolicy","application"],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        updateKeyFilePolicyConfiguration:function()
        {
            this.get('controllers.SettingsPolicy').send('updateKeyFilePolicyConfiguration',this);//No I18N
        }
    }
});

App.KMPNotificationView = Ember.View.extend({
    templateName: 'KMPNotification',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("js.NotificationPolicy.Title"));//NO I18N
        $(".modal-dialog").width("800");
        App.Settings.getNotificationConfig();
        kmpStandAlone=false;
        }
});

App.KMPNotificationController = Ember.ObjectController.extend({
    needs:["SettingsNotificationPolicy","application"],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        updateNotificationConfig:function()
        {
            
            if(!kmpStandAlone ){
                var isnotifydomainChecked =$('#DOMAIN_NOTIFY').is(":checked");//No I18N
                if(isnotifydomainChecked){
                var isemailChecked =$('#Email').is(":checked");//No I18N
                if(!isemailChecked){
                    showAlert(I18N.getMsg('pki.notification.provideemail'));//No I18N
                    return false;
                }
                }
            }
            this.get('controllers.SettingsNotificationPolicy').send('updateNotificationConfig',this);//No I18N
        }
    }
});

App.KMPVulnerabilitiesSettingsView = Ember.View.extend({
    templateName: 'KMPVulnerabilitiesSettings',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("vulnerabilities.title"));//NO I18N
        $(".modal-dialog").width("800");
        App.Settings.getSSLVulnerabilitiesSettings();
        kmpStandAlone=false;
    }
});

App.KMPVulnerabilitiesSettingsController = Ember.ObjectController.extend({
    needs:["VulnerabilitiesSettings","application"],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        saveSettings:function()
        {
            this.get('controllers.VulnerabilitiesSettings').send('saveSettings',this);//No I18N
        }
    }
});

App.KMPMSCAAutoRenewalSettingsView = Ember.View.extend({
    templateName: 'KMPMSCAAutoRenewalSettings',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("js.cert.msca.autorenewal"));//NO I18N
        $(".modal-dialog").width("700");
        App.Settings.getMSCAAutoRenewalSettingsView();
        kmpStandAlone=false;
    }
});

App.KMPMSCAAutoRenewalSettingsController = Ember.ObjectController.extend({
    needs:["GeneralSettings","application"],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        updateMSCARenewalTask:function()
        {
            this.get('controllers.GeneralSettings').send('updateMSCARenewalTask',this);//No I18N
        }
    }
});

App.KMPSDPSettingsView = Ember.View.extend({
    templateName: 'KMPSDPSettings',//No I18N
    didInsertElement: function(){
        $(".modal-title").text(I18N.getMsg("js.UsersInAdminTab.sshSslContainer.CMDB_int"));//NO I18N
        $(".modal-dialog").width("800");
        $("#tabs_container").hide();
//        App.SettingsCommonController.selectedCMDBTab = "server"; //No I18N
               this.controller.set('content', App.Settings.getSDPTabList()); //No I18N
        App.SettingsCommonController.selectedCMDBTab = "cmdbcerts"; //No I18N		
	               App.Settings.getCMDBView();
                       $("#cmdbtemplatetoDisp").show();		
	               $("#ServertemplatetoDisp").hide();
        // App.Settings.getSDPServerView();
        kmpStandAlone=false;
    }
});

App.KMPSDPSettingsController = Ember.ObjectController.extend({
    needs:["application","CMDB","SDPServer"],//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
            },calltemplate:function(temp){		
	            if(temp ==="server")		
	            {		           
	                App.SettingsCommonController.selectedCMDBTab = "server"; //No I18N		
	                App.Settings.getSDPTabList(); 		
	                App.Settings.getSDPServerView();		
	               $("#ServertemplatetoDisp").show();		
	               $("#cmdbtemplatetoDisp").hide();		
	            }else{		
	                App.SettingsCommonController.selectedCMDBTab = "cmdbcerts"; //No I18N		
	                App.Settings.getSDPTabList(); 		
	                App.Settings.getCMDBView();		
	               $("#cmdbtemplatetoDisp").show();		
	               $("#ServertemplatetoDisp").hide();		
            }
        }
        }
});

App.AssociateKeyViewView = Ember.View.extend({
    templateName: 'AssociateKeyView',//No I18N
        didInsertElement: function(){
           // $('[data-toggle="popover"]').popover(); //For help Content
            $(".modal-title").text(I18N.getMsg("js.modaltitle.publicKeyAssociation"));//NO I18N
            var controller = this.get('controller');
            var grid ="";
            if(App.SettingsCommonController.associatefrom==="DashboardKeyRotationGraph")
            {
                grid = $("#PKIInventoryList"); //No I18N
            }
            else
            {
                grid = $("#PKISSHKeys"); //No I18N
            }
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_id="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                document.getElementById("Asso_close").click();//NO I18N
                return;
            }
            else if(selRowIds.length>1)
            {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                document.getElementById("Asso_close").click();//NO I18N
                return;                
            }

            $( "#modalDialog" ).draggable();
            var reqUrl="/api/pki/ssh/getResourceWithUsers";//No I18N
            getAjaxApiRequest(reqUrl,"",function(jsonData){
                if(jsonData.message!==undefined)
                {
                    controller.send('close');//NO I18N
                    messageNotification("messageNotifyFailure",jsonData.message);//No I18N
                    return;
                }
                generateResourceUserTree(jsonData);
                    });
        }
});

App.DissociateKeyToUserViewView = Ember.View.extend({
   templateName: 'DissociateKeyToUserView',//No I18N
   didInsertElement: function(){
      // $('[data-toggle="popover"]').popover(); //For help Content
       $(".modal-title").text(I18N.getMsg("js.modaltitle.dissociateUsers"));//NO I18N
       var grid;
       if(App.SettingsCommonController.disassociatefrom==="DashboardKeyRotationGraph")
            {
                grid = $("#PKIInventoryList"); //No I18N
            }
            else
            {
                grid = $("#PKISSHKeys"); //No I18N
            }
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_id="";
//            if(selRowIds == undefined || selRowIds.length == 0) {
//                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
//                document.getElementById("Asso_close").click();//NO I18N
//                return;
//            }
//            else if(selRowIds.length>1)
//            {
//                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
//                document.getElementById("Asso_close").click();//NO I18N
//                return;                
//            }
            key_id=grid.jqGrid('getCell',selRowIds,'KeyID') //No I18N 
            $( "#modalDialog" ).draggable();
            var reqUrl="/api/pki/ssh/getResourceUsersWithKey";//No I18N
            var reqParams="KeyId="+key_id; //No I18N 
            getAjaxApiRequest(reqUrl,reqParams,function(jsonData){
            treeObj=jsonData;
            $('#data').slimscroll({railVisible: true,railBorderRadius: 0,railOpacity: 0.1});
                    $('#data').jstree({
                            "plugins" : [ "themes", "html_data", "checkbox","search","sort"],//NO I18N
                            'core' : jsonData,//NO I18N
                            "search":{//NO I18N
                                "case_insensitive":true,//NO I18N
                                "show_only_matches":true//NO I18N
                            }
                    });
                    var to = false;
                    $('#plugins4_q').keyup(function () {//NO I18N
                        if(to) { clearTimeout(to); }
                        to = setTimeout(function () {
                                var v = $('#plugins4_q').val();//NO I18N
                                $('#data').jstree(true).search(v);//NO I18N
                        }, 250);
                    });
            
            });
        }
});

App.DissociateKeyToUserViewController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        dissociatePublicKeysLocally: function()
        {
        var checked_ids = []; 
            checked_ids=$('#data').jstree(true).get_selected();//NO I18N
            if(checked_ids.length==0)
            {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUserToDisassociate')); //No I18N
                return;                
            }
            var grid;
       if(App.SettingsCommonController.disassociatefrom==="DashboardKeyRotationGraph")
            {
                grid = $("#PKIInventoryList"); //No I18N
            }
            else
            {
                grid = $("#PKISSHKeys"); //No I18N
            }
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_id=grid.jqGrid('getCell',selRowIds,'KeyID'); //No I18N 
            var reqParams="key_ids="+key_id+"&user_id="+checked_ids; //No I18N 
            var reqUrl="/api/pki/ssh/keyDissociationLocally";//No I18N 
            getAjaxApiRequest(reqUrl,reqParams,function(jsonData){
                document.getElementById("Asso_close").click();//NO I18N
                if(jsonData.Status=="success")
                {
                    messageNotification("messageNotifySuccess","Key Dissociation Success");//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure","Key Dissociation failed for one or more keys");//No I18N
                }          
            
            });
            
        },
        dissociatePublicKeysRemotely: function()
        {
        var checked_ids = []; 
            checked_ids=$('#data').jstree(true).get_selected();//NO I18N
            if(checked_ids.length==0)
            {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUserToDisassociate')); //No I18N
                return;                
            }
             var grid;
       if(App.SettingsCommonController.disassociatefrom==="DashboardKeyRotationGraph")
            {
                grid = $("#PKIInventoryList"); //No I18N
            }
            else
            {
                grid = $("#PKISSHKeys"); //No I18N
            }
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_id=grid.jqGrid('getCell',selRowIds,'KeyID'); //No I18N 
            var reqParams="key_ids="+key_id+"&user_id="+checked_ids+"&pmpcp="+Get_Cookie('pmpcc'); //No I18N 
            var reqUrl="/api/pki/ssh/keyDissociationRemotely";//No I18N 
            getAjaxApiRequest(reqUrl,reqParams,function(jsonData){                
                document.getElementById("Asso_close").click();//NO I18N                
                if(jsonData.Status=="Success")
                {
                messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
            
            });
            
        }
    }
});

App.AssociateKeyViewController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        associatePublicKeys: function()
        {
            var grid="";
            if(App.SettingsCommonController.associatefrom==="DashboardKeyRotationGraph")
            {
                grid = $("#PKIInventoryList"); //No I18N
            }
            else
            {
                grid = $("#PKISSHKeys"); //No I18N
            }
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_id="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                this.send('closeModal');//NO I18N
                return;
            }
            else if(selRowIds.length>1)
            {
                showAlert(I18N.getMsg('js.sshkey.selectOneKey')); //No I18N
                this.send('closeModal');//NO I18N
                return;                
            }
            $.each(selRowIds, function()
            {
                var id = this;
                key_id = grid.jqGrid('getCell', id, 'KeyID'); //No I18N
                App.SettingsCommonController.keyName=grid.jqGrid('getCell',id,'KeyName');//No I18N
            });
            var checked_ids = []; 
            checked_ids=$('#data').jstree(true).get_selected();//NO I18N
            var reqparams="keyid="+key_id+"&res_users="+checked_ids+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N
            if(checked_ids.length==0)
            {
                showAlert(I18N.getMsg('js.userselection.selectAtleastOneUserToAssociate')); //No I18N
                return;                
            }
            var reqUrl="/api/pki/ssh/associateKeys";//No I18N
            var close=this;
            getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                    App.SettingsCommonController.keyStateId =1;
                    if(localStorage.getItem("homeTab")!=="PassTrixQuickView"){
                    redirectUrl("SSHMgmt/DetailedKeyRotationAudit/"+jsonData.keyRotationAuditId);//No I18N
                    }
                    close.send('closeModal');//NO I18N
                }
                else{
                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                }
            });
        }
    }
});

App.SSHMgmtShowAssociateMapperRoute = Ember.Route.extend({
	model: function(params) {
            App.SettingsUserController.key_id=params.key_id;
            App.SettingsCommonController.asso_flag=true;
            App.SettingsCommonController.selectedTab="keys";//No I18N
            App.ApplicationController.getBack=localStorage.getItem("prevViewName");//No I18N
	},
        setupController: function(controller) {
        controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
        },
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('AssociateMapper',{into: 'SSHMgmtMainTabs',outlet: 'keyInfo'});//No I18N
            }
            else{
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
                this.render('AssociateMapper',{ outlet: 'keyInfo'});//No I18N
                }   
                else
                {
                    this.render('AssociateMapper',{ outlet: 'kmpdashboard'});//No I18N
                }
            }   
        } //No I18N
});

App.SSHMgmtMappingGraphRoute = Ember.Route.extend({
	model: function(params) {
            App.SettingsUserController.key_id=params.id;
            App.SettingsUserController.type=params.type;            
            App.SettingsCommonController.asso_flag=true;
	},
        setupController: function(controller) {
            if(App.SettingsUserController.type==="user")
            {
                App.SettingsCommonController.selectedTab="all_users";//No I18N 
            }
            else
            {
                App.SettingsCommonController.selectedTab="keys";//No I18N 
            }
        controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N 
        },
        renderTemplate: function() {
            if(kmpStandAlone){
                this.render('MappingGraph',{into: 'SSHMgmtMainTabs',outlet: 'keyInfo'});//No I18N
            }
            else{
                if(localStorage.getItem("homeTab")!="PassTrixQuickView")
                {
                this.render('MappingGraph',{ outlet: 'keyInfo'});//No I18N
            }   
                else
                {
                    this.render('MappingGraph',{ outlet: 'kmpdashboard'});//No I18N
        } 
            }   
        } 
});

// Basic credential Dialog view
App.ResourceUserCredentialView = Ember.View.extend({
    templateName: 'Modal',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.resourceCredential.title"));//NO I18N
            $('.modal-dialog').css({"width":"550px"});//NO I18N
            getBasicCredential();
            if(App.ApplicationController.isAdmin===false)
            {
                $("#select_key_option").hide();
            }
        }
});

function getBasicCredential()
{
           // $('[data-toggle="popover"]').popover();//For help content
            if(App.SettingsCommonController.isSingleCredential)
            {            
                document.getElementById("rootpassword").placeholder="";
            var reqUrl="/api/pki/ssh/getCredential?user_id="+App.SettingsCommonController.user_id;//No I18N
                getAjaxApiRequest(reqUrl,"",function(jsonData){
                    if(jsonData.USER_NAME!==undefined)
                    {
                        $("#rootaccount").val($("<div>").html(jsonData.USER_NAME).text()); //NO I18N
                        document.getElementById("rootaccount").disabled=true;
                        if(jsonData.PASSWORD!==undefined)
                        {
                            document.getElementById("rootpassword").placeholder=jsonData.PASSWORD;
                        }
                        else if(App.SettingsCommonController.isCredentialAvailable==="true" && jsonData.PASSWORD===undefined || jsonData.PASSWORD==="")
                        {
                            if(App.ApplicationController.isAdmin)
                            {
                            $("#isRoot").show();
                        }
                        }
                        else
                        {
                            $("#rootpassword").focus();
                        }
                        if(App.ApplicationController.isAdmin)
                        {
                        if(jsonData.ISADMIN === 1)
                        {
                            document.getElementById("isadmin").checked=true;;
                        }
                        }else
                        {
                            $("#isadmin").hide();
                            $("#isadmin").next().hide();
                    }
                    }
                    else
                    {
                        $("#rootaccount").val("");
                        $("#rootpassword").val("");
                    }
            });
        }
            else
            {
                $("#loginname").hide();
                $("#isadmin").hide();
                $("#credential_type").hide();
                $("#isadmin").next().hide();
            }
        }

App.ResourceUserCredentialController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        submitCredentials: function()
        {
            if(App.SettingsCommonController.isSingleCredential)
            {
                var close=this;
                saveResourceCredential("user",close);//No I18N
            }
            else
            {
                if($("#rootpassword").val()==="")
                {
                    showAlert(I18N.getMsg('js.Password.enterPassword')); //No I18N
                    return;
                }
                var grid;
                var user_ids="";
                var reqUrl;
                if(App.SettingsCommonController.uGroup)
                {
                    grid = $("#PKIUsersGroupList");//NO I18N
                var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                if(selRowIds == undefined || selRowIds.length == 0) {
                        showAlert(I18N.getMsg('js.usersGroup.selectatleastonegroup')); //No I18N
                        return;
                    }
                    $.each(selRowIds, function()
                    {
                        var id = this;
                        var user_id = grid.jqGrid('getCell', id, 'GROUP ID'); //No I18N
                        if(user_ids!=="")
                        {
                            user_ids=user_ids+","+user_id;
                        }
                        else
                        {
                            user_ids=user_id;
                        }
                    });
                    reqUrl="/api/pki/ssh/saveCredentialForUserGroup";//No I18N
                }
                else
                {
                    grid = $("#PKIAllResourceUsers"); //No I18N
                    var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N                 
                    if(selRowIds == undefined || selRowIds.length == 0) {
                    showAlert(I18N.getMsg('js.userselection.selectAtleastOneUser')); //No I18N
                    return;
                }
                $.each(selRowIds, function()
                {
                    var id = this;
                    var user_id = grid.jqGrid('getCell', id, 'UserID'); //No I18N
                    if(user_ids!=="")
                    {
                        user_ids=user_ids+","+user_id;
                    }
                    else
                    {
                        user_ids=user_id;
                    }
                });
                    reqUrl="/api/pki/ssh/saveCredentialForResources";//No I18N
                }                
                
                App.SettingsCommonController.uGroup=false;
                App.SettingsCommonController.cGroup=false;
                var isadmin=document.getElementById("isadmin").checked;
                var reqparams=$( "form" ).serialize()+"&isadmin="+isadmin+"&user_ids="+user_ids;//NO I18N
                ajaxRequestWithCookie(reqUrl,reqparams,true,"",false,"");//NO I18N
                this.send('closeModal');//NO I18N                
            }
        }
    }
});

App.EditPassPhraseView = Ember.View.extend({
    templateName: 'EditPassPhrase',//No I18N
        didInsertElement: function(){
            $(".modal-title").text(I18N.getMsg("js.modaltitle.privateKeyPassPhrase"));//NO I18N
        }
});

App.EditPassPhraseController = Ember.ObjectController.extend({
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        applyPassPhrase:function()
        {
            var passPhrase=$("#PassPhrase").val();
            if(passPhrase==='')
                {
                    showAlert(I18N.getMsg('js.sshkey.enterValidPassphrase'));//No I18N
                    return;
                }
            var reqUrl="/api/pki/ssh/applyPassPhrase";//No I18N            
            var reqparams="PassPhrase="+passPhrase+"&key_id="+App.SettingsUserController.key_id;//NO I18N
            var close=this;
            ajaxRequestWithCookie(reqUrl,reqparams,false,"",true,function(jsonData){
                if(jsonData.Status==="Success")//NO I18N
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    {{App.Settings.listsshkeys()}}
                    close.send('closeModal');//NO I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
                
            });
            
        }
    }
});
    
App.AssociateUserToKeyViewView = Ember.View.extend({
    templateName: 'AssociateUserToKeyView',//No I18N
        didInsertElement: function(){
            isPass=false;
            //$('[data-toggle="popover"]').popover();//For help Content
            $(".modal-title").text(I18N.getMsg("js.modaltitle.publicKeyAssociationToUsers"));//No I18N 
            var grid;
            var msg;
            if(App.SettingsCommonController.uGroup)
            {
                grid = $("#PKIUsersGroupList");//NO I18N
                msg=I18N.getMsg("js.usersGroup.selectatleastonegroup");//NO I18N
            }
            else
            {
                grid = $("#PKIAllResourceUsers"); //No I18N
                msg=I18N.getMsg('js.userselection.selectAtleastOneUser');//NO I18N
            }
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_id="";
            if(selRowIds == undefined || selRowIds.length == 0) {
                showAlert(msg); //No I18N
                document.getElementById("Asso_close").click();//NO I18N
                return;
            }

            var reqUrl="/api/pki/ssh/getkeyslist";//No I18N
            getAjaxApiRequest(reqUrl,"",function(jsonData){
                   var key_array=jsonData.keyList;
                    if(key_array.length===0)
                    {
                            $("#keySelection").hide();
                        $("#createKeyConfirmation").show();
                        $("#confirmationText").text(I18N.getMsg('js.keymappingToUser.PrivatekeynotavailableCreatenewprivatekey'));//NO I18N
                    }
                    var sel=document.getElementById("listofkeys");//No I18N
                    for (var i=0; i<key_array.length; i++)
                    {
                        var opt=document.createElement('option');//No I18N
                        opt.innerHTML = key_array[i].KeyName;
                        opt.value = key_array[i].KeyId;
                        sel.appendChild(opt);
                    }
            });
        }
});


App.DissociateUserToKeyViewView = Ember.View.extend({
    templateName: 'DissociateUserToKeyView',//No I18N
     didInsertElement: function(){  
         $( "#modalDialog" ).draggable();
         if(App.SettingsCommonController.isFromCredential)
         {
             $(".modal-title").text(I18N.getMsg("js.modaltitle.credentialusers"));//NO I18N
             var res_Id = App.InventoryController.res_Id; //No I18N
                var ajaxRequestUrl = '/api/pki/ssh/getResUsersWithCredentials?res_id='+res_Id; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,"",function(jsonData){
                    var colNamesList = ['id',I18N.getMsg('js.general.username')]; //No I18N
                        var colModelList = [
                                { name: 'id', index: 'id',hidden:true}, //No I18N
                                { name: 'UserName', index: 'UserName'} //No I18N
                               
                        ];                   
                        var defaultOptions={multiselect:true,rowNumNeeded:false};
                        loadJQgridWithData("#ListAssociatedUserKeys", jsonData.ResUsersCred, colNamesList, colModelList, "", "", "",defaultOptions,"#associatedKeys");//No I18N
                       var DataGrid = $('#ListAssociatedUserKeys');//No I18N
                        DataGrid.jqGrid('setGridWidth', '460');//No I18N
                });
        }
         else
         {
            var grid = $("#PKIAllResourceUsers"); //No I18N           
            $(".modal-title").text(I18N.getMsg("js.modaltitle.dissociateKeys"));//NO I18N
            //$('[data-toggle="popover"]').popover(); //For help Content
                var user_id = App.SettingsCommonController.user_id; //No I18N
                var reqparams="USERID="+user_id;//NO I18N  
                var reqUrl="/api/pki/ssh/getAssociatedUserKeys";//No I18N
                getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
                    var colNamesList = ['id',I18N.getMsg('js.ssh.keyname')]; //No I18N
                        var colModelList = [
                                { name: 'id', index: 'id',hidden:true}, //No I18N
                                { name: 'text', index: 'text'} //No I18N
                               
                        ];                   
                        var defaultOptions={multiselect:true,rowNumNeeded:false};
                        loadJQgridWithData("#ListAssociatedUserKeys", jsonData.data, colNamesList, colModelList, "", "", "",defaultOptions,"#associatedKeys");//No I18N
                 var DataGrid = $('#ListAssociatedUserKeys');//No I18N
                        DataGrid.jqGrid('setGridWidth', '460');//No I18N    
                });
        }
        }
});

App.DissociateUserToKeyViewController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {               
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        dissociateUserToKeyLocally: function(){
            var grid = $("#ListAssociatedUserKeys"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_ids="";
            if(selRowIds.length==0)
            {
                showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKeyToDisassociate')); //No I18N
                return;                
            }
            $.each(selRowIds, function()
            {
                var id = this;
                var key_id = grid.jqGrid('getCell',id, 'id'); //No I18N
                if(key_ids!=="")
                {
                    key_ids=key_ids+","+key_id;
                }
                else
                {
                    key_ids=key_id;
                }
            });
            grid = $("#PKIAllResourceUsers"); //No I18N
            selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var user_id=grid.jqGrid('getCell',selRowIds,'UserID'); //No I18N            
            var reqparams="key_ids="+key_ids+"&user_id="+user_id;//NO I18N
            var reqUrl="/api/pki/ssh/keyDissociationLocally";//No I18N 
            getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
                document.getElementById("Asso_close").click();//NO I18N
                if(jsonData.Status=="success")
                {
                    messageNotification("messageNotifySuccess","Key Dissociation Success");//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure","Key Dissociation failed for one or more keys");//No I18N
                }   
            
            {{App.Settings.getAllResourceUsers();}}
            $('#PKIAllResourceUsers').trigger('reloadGrid'); //No I18N
        });
        },
        
        dissociateUserToKeyRemotely: function(){
            var grid = $("#ListAssociatedUserKeys"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var key_ids="";
            if(selRowIds.length==0)
            {
                showAlert(I18N.getMsg('js.sshkey.selectAtleastOneKeyToDisassociate')); //No I18N
                return;                
            }
            $.each(selRowIds, function()
            {
                var id = this;
                var key_id = grid.jqGrid('getCell',id, 'id'); //No I18N
                if(key_ids!=="")
                {
                    key_ids=key_ids+","+key_id;
                }
                else
                {
                    key_ids=key_id;
                }
            });
            grid = $("#PKIAllResourceUsers"); //No I18N
            selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            var user_id=grid.jqGrid('getCell',selRowIds,'UserID'); //No I18N             
            var reqparams="key_ids="+key_ids+"&user_id="+user_id+"&pmpcp="+Get_Cookie('pmpcc');//NO I18N         
            var reqUrl="/api/pki/ssh/keyDissociationRemotely";//No I18N 
            getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
                document.getElementById("Asso_close").click();//NO I18N
                if(jsonData.Status=="Success")
                {
                messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N
                }
        });
            
        },
        enumerateUsers:function(){
            var app=this.get('controllers.application');
            var grid = $("#ListAssociatedUserKeys"); //No I18N
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds.length !== 1)
            {
                showAlert(I18N.getMsg('js.userselection.selectOneUser')); //No I18N
                return;                
        }
            var userId="";
            $.each(selRowIds, function()
            {
                var id = this;
                userId = grid.jqGrid('getCell',id, 'id'); //No I18N
            });
            var resId=App.InventoryController.res_Id;
            var ajaxRequestUrl = '/api/pki/ssh/enumerateUsers?userId='+userId+'&resId='+resId; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,"pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    app.send('closeModal');//NO I18N
                });
    },discoverkeysFromRes:function(){
        var app=this.get('controllers.application');
            var grid = $("#ListAssociatedUserKeys"); 
            var selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            if(selRowIds.length !== 1)
            {
                showAlert(I18N.getMsg('js.userselection.selectOneUser')); //No I18N
                return;                
    }
            var userId="";
            $.each(selRowIds, function()
            {
                var id = this;
                userId = grid.jqGrid('getCell',id, 'id'); //No I18N
            });
            var resId=App.InventoryController.res_Id;
            var ajaxRequestUrl = '/api/pki/ssh/discoverkeyListFromRes?userId='+userId+'&resId='+resId; //No I18N
                getAjaxApiRequest(ajaxRequestUrl,"pmpcp="+Get_Cookie('pmpcc'),function(jsonData){//NO I18N
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                    app.send('closeModal');//NO I18N
                });
    }
    }
});

App.AssociateUserToKeyViewController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        showCreateKey : function()
        {
            $("#keySelection").hide();
            $("#createKeyConfirmation").hide();
            $("#CreateSshKeyForm").show();
        },
        back : function()
        {
            $("#keySelection").show();
            $("#CreateSshKeyForm").hide();
        },
        createKey: function(){
            var KEY_Name=$("#keyName").val();//NO I18N
            var KEY_PASS=$("#passPhrase").val();//NO I18N
            var COMMENT=$("#comment").val();//NO I18N
            var LENGTH=$("#length").val();
            if(KEY_Name=='')
            {
                showAlert(I18N.getMsg('js.sshkey.enterkeyname'));//No I18N
                return;
            }
            var reqUrl="/api/pki/ssh/createSSHKey";//No I18N
            var reqparams=$( "#createKeyForm" ).serialize();//NO I18N
            ajaxRequestWithCookie(reqUrl,reqparams,false,"",true,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                        var sel=document.getElementById("listofkeys");//No I18N
                        var opt=document.createElement('option');//No I18N
                        opt.innerHTML = KEY_Name;
                        opt.value = jsonData.key_id;
                        sel.appendChild(opt);
                        document.getElementById("listofkeys").value=jsonData.key_id;//No I18N
                        $("#keySelection").show();
                        $("#CreateSshKeyForm").hide();           
                    }
                    else
                    {
                        showAlert(jsonData.Message);//No I18N
                    }
            });
        },
        associatePublicKeys: function()
        {
            var app=this.get('controllers.application');
            var grid;
            var msg;
            var selRowIds;
            var user_ids="";
            var reqUrl;
            if(App.SettingsCommonController.uGroup)
            {
                grid = $("#PKIUsersGroupList");//NO I18N
                selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N             
                $.each(selRowIds, function()
                {
                    var id = this;
                    var user_id = grid.jqGrid('getCell', id, 'GROUP ID'); //No I18N
                    if(user_ids!=="")
                    {
                        user_ids=user_ids+","+user_id;
            }
                    else
                    {
                        user_ids=user_id;
                    }
                });  
                reqUrl="/api/pki/ssh/usergroupassociation"; //No I18N
            }
            else
            {
                grid = $("#PKIAllResourceUsers"); //No I18N
                selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N             
            $.each(selRowIds, function()
            {
                var id = this;
                var user_id = grid.jqGrid('getCell', id, 'UserID'); //No I18N
                if(user_ids!=="")
                {
                    user_ids=user_ids+","+user_id;
                }
                else
                {
                    user_ids=user_id;
                }
            });
                reqUrl="/api/pki/ssh/singleUserAssociation"; //No I18N
            }
            var key_id = ""; 
            key_id=document.getElementById("listofkeys").value;
            App.SettingsCommonController.keyName=document.getElementById("listofkeys").options[document.getElementById("listofkeys").selectedIndex].text;
            if(key_id==='---select one Key---')
                {
                    showAlert(I18N.getMsg('js.sshkey.selectakey')); //No I18N
                    return;
                }
            var ajaxRequestUrl='/api/pki/ssh/checkSshKeyPair';//NO I18N
            var passPhrase=$("#PassPhrase").val();
            if(passPhrase==="" && isPass===false)
            {
                var reqParam='key_id='+key_id;//NO I18N
                getAjaxApiRequest(ajaxRequestUrl,reqParam,function(jsonData){
                    if(jsonData.isPubKeyAvailable)
                    {
            var reqparams="USERIDS="+user_ids+"&key_id="+key_id;//NO I18N
                        //ajaxRequestUrl = "/api/pki/ssh/singleUserAssociation?key_id="+key_id; //No I18N
                        //ajaxapicall(ajaxRequestUrl,reqparams,true,"");//NO I18N
                        getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
                            if(jsonData.Status==="Success")//NO I18N
                            {
                                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                                    redirectUrl("SSHMgmt/DetailedKeyRotationAudit/"+jsonData.keyRotationAuditId);//No I18N
                            }   
                            else{
                                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                            }
                        });
                        app.send('closeModal');//NO I18N
                    }
                    else
                    {
                        $("#passphrase").show();
                        isPass=true;
                    }
                });
            }
            else
            {
                if(passPhrase==="")
                {
                    showAlert(I18N.getMsg('js.sshkey.enterValidPassphrase'));//NO I18N
                    return;
                }
                ajaxRequestUrl='/api/pki/ssh/applyPassPhrase';//NO I18N
                var reqParam="key_id="+key_id+"&PassPhrase="+$("#PassPhrase").val();//NO I18N
                ajaxRequestWithCookie(ajaxRequestUrl,reqParam,false,"",true,function(jsonData){
                    if(jsonData.Status==="Success")
                    {
                        var reqparams="USERIDS="+user_ids+"&key_id="+key_id;//NO I18N
                        //ajaxRequestUrl = "/api/pki/ssh/singleUserAssociation?key_id="+key_id; //No I18N
                        //ajaxapicall(ajaxRequestUrl,reqparams,true,"");//NO I18N
                        getAjaxApiRequest(reqUrl,reqparams,function(jsonData){
                            if(jsonData.Status==="Success")//NO I18N
                            {
                                    messageNotification("messageNotifySuccess",I18N.getMsg(jsonData.Message));//No I18N
                                    redirectUrl("SSHMgmt/DetailedKeyRotationAudit/"+jsonData.keyRotationAuditId);//No I18N
                            }   
                            else{
                                    messageNotification("messageNotifyFailure",I18N.getMsg(jsonData.Message));//No I18N
                            }
                        });
                        app.send('closeModal');//NO I18N
                        isPass=false;
                    }
                    else
                    {
                        showAlert(I18N.getMsg('js.sshkey.passphraseNotApplied'));//NO I18N
                    }
                })
            }
        }
    }
});

App.CreateAndDeployView = Ember.View.extend({
    templateName: 'createAndDeploy',//No I18N
        didInsertElement: function(){
           // $('[data-toggle="popover"]').popover();
            $(".modal-title").text(I18N.getMsg("js.modaltitle.createandDeploykeys"));//NO I18N
        }
});

App.CreateAndDeployController = Ember.ObjectController.extend({
    needs:'application',//NO I18N
    actions: {
        close: function() {
          return this.send('closeModal');//NO I18N
        },
        createAndDeployKey: function(){
            var app=this.get('controllers.application');
            var reqparams=$( "#createAdnDeployForm" ).serialize();
            var reqUrl="/api/pki/ssh/createandDeployKey";//No I18N
            if(App.InventoryListDetailsController.deploy==true)
            {
                reqparams=reqparams+"&res_id="+App.InventoryController.res_Id;//NO I18N
            }
            else
            {
            var user_ids="";
                var grid;
                var selRowIds ;
                if(App.SettingsCommonController.uGroup)
                {
                    reqUrl="/api/pki/ssh/userGroupCreateAndDeploy";//No I18N
                    grid = $("#PKIUsersGroupList");//NO I18N
                    selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
            $.each(selRowIds, function()
            {
                var id = this;
                        var user_id = grid.jqGrid('getCell', id, 'GROUP ID'); //No I18N
                        if(user_ids!=="")
                        {
                            user_ids=user_ids+","+user_id;
                        }
                        else
                        {
                            user_ids=user_id;
                        }
                    });
                }
                else
                {
                    grid = $("#PKIAllResourceUsers"); //No I18N
                    selRowIds = grid.jqGrid('getGridParam','selarrrow'); //No I18N 
                    $.each(selRowIds, function()
                    {
                        var id = this;
                var user_id = grid.jqGrid('getCell', id, 'UserID'); //No I18N
                if(user_ids!=="")
                {
                    user_ids=user_ids+","+user_id;
                }
                else
                {
                    user_ids=user_id;
                }
            });
                }                
                
                reqparams=reqparams+"&user_ids="+user_ids;//NO I18N            
            }
            var COMMENT=$("#comment").val();//NO I18N
            var LENGTH=$("#length").val();
            
            ajaxRequestWithCookie(reqUrl,reqparams,false,"",true,function(jsonData){
                if(jsonData.Status=="Success")
                {
                    messageNotification("messageNotifySuccess",jsonData.Message);//No I18N
                }
                else
                {
                    messageNotification("messageNotifyFailure",jsonData.Message);//No I18N                    
                }
                app.send('closeModal');//NO I18N
            });
            App.SettingsCommonController.uGroup=false;
            App.SettingsCommonController.cGroup=false;
            App.InventoryListDetailsController.deploy=false;
        }
    }
});


App.SSHMgmtKeyHistoryAuditRoute = Ember.Route.extend({
	 model: function(params) {
            App.ApplicationController.getBack=localStorage.getItem("prevViewName");//No I18N
		App.SettingsUserController.key_id=params.key_id;
        },
        setupController: function(controller,model) {
	},
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('KeyHistoryAudit',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            this.render('KeyHistoryAudit',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});

App.AssoCreateComponent = Ember.Component.extend({
    actions:{
        showCreateKey:function()
        {
            this.sendAction("showCreateKey");//No I18N
        },
        associatePublicKeys:function()
        {
            this.sendAction("associatePublicKeys");//No I18N
        },
        close:function()
        {
            this.sendAction("close");//No I18N
        },
        back:function()
        {
            this.sendAction("back");//No I18N
        },
        createKey:function()
        {
            this.sendAction("createKey");//No I18N
        }
        
    }
});
App.AdDetailsComponent = Ember.Component.extend({
    actions:{
        openADOUdialog:function(template)
        {
            this.sendAction("openADOUdialog",template);//No I18N
        },
        generateTree:function()
        {
            this.sendAction("generateTree");//No I18N
        },
        importUsersFromAD:function()
        {
            this.sendAction("importUsersFromAD");//No I18N
        },
        close:function()
        {
            this.sendAction("close");//No I18N
        }
    }
});

App.AdDetailsDiagComponent = Ember.Component.extend({
    actions:{
        ADOUList:function()
        {
            this.sendAction("ADOUList");//No I18N
        },
        generateTree:function()
        {
            this.sendAction("generateTree");//No I18N
        },
        importUsersFromAD:function()
        {
            this.sendAction("importUsersFromAD");//No I18N
        },
        close:function()
        {
            this.sendAction("close");//No I18N
        }
    }
});

App.SSHMgmtSSHRoute = App.InventoryFilterRoute.extend({
     model: function(params) {
         App.SettingsCommonController.asso_flag=false;
    },
    setupController: function(controller) {
        App.SettingsCommonController.selectedTab = "devices"; //No I18N
        controller.set('content', App.Settings.getSSHMgmtTabList());  //No I18N
    },
    renderTemplate: function() {
        if(kmpStandAlone){
            this.render('SSHResources',{into:"SSHMgmtMainTabs", outlet: 'keyInfo'});//No I18N
        }
        else{
            selectKMPTab("ssh_server");//NO I18N
            this.render('SSHResources',{ outlet: 'keyInfo'});//No I18N
        }   
    }
});
